import { openBlock as C, createElementBlock as w, Fragment as ie, renderList as ae, normalizeClass as H, createBlock as ft, resolveDynamicComponent as wt, mergeProps as Ze, createElementVNode as k, createCommentVNode as M, createTextVNode as hn, resolveComponent as je, toDisplayString as de, createVNode as he, renderSlot as ze, withDirectives as Ne, vShow as di, pushScopeId as pi, popScopeId as gi, vModelSelect as jt, vModelText as yi, normalizeProps as we, vModelDynamic as Hr, guardReactiveProps as qe, vModelRadio as Er, vModelCheckbox as Pr } from "vue";
const Fr = {
  props: {
    only: {
      type: Array,
      required: !1
    },
    except: {
      type: Array,
      required: !1
    },
    orderByOnly: {
      type: Boolean,
      required: !1,
      default: !1
    }
  },
  methods: {
    subset(s) {
      if (this.only || this.except) {
        let p = Object.keys(s).filter(
          (h) => this.only ? this.only.includes(h) : !this.except.includes(h)
        ).reduce((h, E) => (h[E] = s[E], h), {});
        if (this.orderByOnly && !this.except) {
          let h = {};
          this.only.forEach((E) => {
            h[E] = p[E];
          }), p = h;
        }
        return p;
      }
      return s;
    }
  }
}, bi = {
  mixins: [Fr],
  props: {
    columns: {
      type: Number,
      required: !1,
      default: 1,
      validator: function(s) {
        return 12 % s === 0;
      }
    },
    spread: {
      type: Boolean,
      required: !1,
      default: !0
    },
    rowClass: {
      type: String,
      required: !1,
      default: null
    },
    colClass: {
      type: String,
      required: !1,
      default: null
    },
    componentClass: {
      type: String,
      required: !1,
      default: null
    }
  },
  methods: {
    rows(s) {
      const p = this.subset(s), h = Object.keys(p), E = h.length, $ = Math.ceil(E / this.columns);
      let N = [...Array($).keys()];
      for (const x in N) {
        let _ = [];
        for (let G = x * this.columns; G <= x * this.columns + (this.columns - 1); G++)
          if (h[G]) {
            const ne = { ...p[h[G]] };
            ne.key = h[G], _.push(ne);
          }
        N[x] = _;
      }
      return N;
    },
    colSize(s) {
      let p = 12 / this.columns;
      return s.length < this.columns && this.spread && (p = Math.floor(12 / s.length)), p;
    }
  }
}, Ee = {
  props: {
    labelPosition: {
      type: String,
      required: !1,
      default: "horizontal",
      validator: function(s) {
        return ["horizontal", "vertical", "none"].includes(s);
      }
    },
    labelColumnSize: {
      type: Number,
      required: !1,
      default: 6,
      validator: function(s) {
        return s < 12;
      }
    },
    synchronous: {
      type: Boolean,
      required: !1,
      default: !1
    },
    helperText: {
      type: String,
      required: !1,
      default: ""
    },
    helperTextClass: {
      type: String,
      required: !1,
      default: ""
    }
  },
  computed: {
    boundValue: {
      get() {
        return this.getFilter(this.filter.key);
      },
      set(s) {
        this.setFilterLoadData(this.filter.key, s);
      }
    }
  },
  methods: {
    setFilterLoadData(s, p) {
      this.setFilter(s, p), !this.synchronous && this.pageDefinition.retrieveData && this.loadData();
    }
  }
};
const fe = (s, p) => {
  const h = s.__vccOpts || s;
  for (const [E, $] of p)
    h[E] = $;
  return h;
}, Mr = {
  name: "FilterGrid",
  mixins: [bi, Ee],
  props: {
    labelPosition: {
      type: String,
      required: !1,
      default: "horizontal",
      validator: function(s) {
        return ["horizontal", "vertical", "none"].includes(s);
      }
    },
    synchronous: {
      type: Boolean,
      required: !1,
      default: !1
    },
    clearButton: {
      type: Boolean,
      required: !1,
      default: !0
    },
    buttonPosition: {
      type: String,
      required: !1,
      default: "center",
      validator: function(s) {
        return ["left", "center", "right", "none"].includes(s);
      }
    }
  },
  methods: {
    initializeDefaultsLoadData() {
      this.initializeDefaults(
        this.subset(this.getFilters) ? Object.keys(this.subset(this.getFilters)) : null
      ), !this.synchronous && this.pageDefinition.loadData && this.loadData();
    }
  }
}, $r = ["id"], jr = {
  key: 0,
  class: "row button-row harness-ui-filtergrid-row harness-ui-filtergrid-buttonrow"
}, Br = /* @__PURE__ */ hn(" \xA0 ");
function Ir(s, p, h, E, $, N) {
  return C(), w("div", null, [
    (C(!0), w(ie, null, ae(s.rows(this.filters), (x, _) => (C(), w("div", {
      class: H("row harness-ui-filtergrid-row " + s.rowClass),
      key: _
    }, [
      (C(!0), w(ie, null, ae(x, (G, ne) => (C(), w("div", {
        class: H(
          "harness-ui-filtergrid-col col-sm-" + 12 / s.columns + " " + s.colClass
        ),
        key: s.pageDefinition.key + "-" + ne,
        id: G.key + "-col"
      }, [
        (C(), ft(wt(G.component), Ze({ filter: G, ...G.props, ...s.$props, ...s.$attrs }, {
          key: s.pageDefinition.key + "-filtergrid-" + G.key,
          class: s.componentClass
        }), null, 16, ["class"]))
      ], 10, $r))), 128))
    ], 2))), 128)),
    (h.synchronous || h.clearButton) && h.buttonPosition !== "none" ? (C(), w("div", jr, [
      k("div", {
        class: H("col-md-12 text-" + h.buttonPosition)
      }, [
        h.synchronous ? (C(), w("button", {
          key: 0,
          class: "btn btn-primary btn-sm harness-ui-filtergrid-applybutton",
          onClick: p[0] || (p[0] = (...x) => s.loadData && s.loadData(...x)),
          role: "button"
        }, " Apply Filters ")) : M("", !0),
        Br,
        h.clearButton ? (C(), w("button", {
          key: 1,
          role: "button",
          class: "btn btn-primary btn-sm harness-ui-filtergrid-clearbutton",
          onClick: p[1] || (p[1] = (...x) => N.initializeDefaultsLoadData && N.initializeDefaultsLoadData(...x))
        }, " Clear Filters ")) : M("", !0)
      ], 2)
    ])) : M("", !0)
  ]);
}
const Rr = /* @__PURE__ */ fe(Mr, [["render", Ir], ["__scopeId", "data-v-d8cc0be1"]]), zr = {
  name: "ChartGrid",
  mixins: [bi],
  computed: {
    chartRows() {
      return this.rows(this.charts);
    }
  }
};
function Vr(s, p, h, E, $, N) {
  return C(), w("div", null, [
    (C(!0), w(ie, null, ae(N.chartRows, (x, _) => (C(), w("div", {
      class: H("row harness-ui-chartgrid-row " + s.rowClass),
      key: _
    }, [
      (C(!0), w(ie, null, ae(x, (G, ne) => (C(), w("div", {
        class: H("col-md-" + s.colSize(x) + " " + s.colClass),
        key: ne
      }, [
        (C(), ft(wt(G.component), Ze({ chart: G, ...G.props, ...s.$props, ...s.$attrs }, {
          key: s.pageDefinition.key + "-chartgrid-" + G.key,
          class: s.componentClass
        }), null, 16, ["class"]))
      ], 2))), 128))
    ], 2))), 128))
  ]);
}
const Wr = /* @__PURE__ */ fe(zr, [["render", Vr]]), Ur = {
  name: "GridWithFilters",
  props: ["columns"]
}, Gr = { class: "display-4" }, Qr = { class: "row" }, Xr = { class: "col-md-12" }, Yr = { class: "card" }, Jr = /* @__PURE__ */ k("div", { class: "card-header" }, "Filters", -1), Kr = { class: "card-body" };
function Zr(s, p, h, E, $, N) {
  const x = je("FilterGrid"), _ = je("ChartGrid");
  return C(), w("div", null, [
    k("h1", Gr, de(s.page.title), 1),
    k("div", Qr, [
      k("div", Xr, [
        k("div", Yr, [
          Jr,
          k("div", Kr, [
            he(x)
          ])
        ])
      ])
    ]),
    he(_, { columns: h.columns }, null, 8, ["columns"])
  ]);
}
const es = /* @__PURE__ */ fe(Ur, [["render", Zr]]), mi = {
  props: {
    chart: {
      type: Object,
      required: !0
    },
    tableClass: {
      type: String,
      required: !1,
      default: null
    },
    headerClass: {
      type: String,
      required: !1,
      default: null
    },
    labelClass: {
      type: String,
      required: !1,
      default: null
    },
    rowClass: {
      type: String,
      required: !1,
      default: null
    },
    cellClass: {
      type: String,
      required: !1,
      default: null
    },
    rowHeaderCol: {
      type: Boolean,
      required: !1,
      default: !1
    }
  },
  computed: {
    columnHeaders() {
      return this.validatedChartData ? Object.keys(this.validatedChartData[0]) : [];
    },
    validatedChartData() {
      return this.validateChartData(this.chartData, this.chart.key);
    }
  }
};
const ts = {
  name: "DataTable508",
  mixins: [mi],
  computed: {
    columnHeaders() {
      return this.validatedChartData ? Object.keys(this.validatedChartData[0]) : [];
    },
    chartData() {
      let s = this.getChartData(this.chart.key) || null, p = this.getChartProps(this.chart.key).tableAdapter || null;
      if (s && p)
        try {
          return p(this.chart, this.filters, s);
        } catch (h) {
          throw String(
            "There was an error in the formatted text from your tableAdapter function: " + String(h)
          );
        }
      return s;
    }
  }
}, ns = ["id"], is = ["innerHTML"], rs = ["innerHTML"], ss = ["innerHTML"];
function as(s, p, h, E, $, N) {
  return s.validatedChartData && s.validatedChartData.length ? (C(), w("div", {
    key: 0,
    id: s.chart.key + "_data_table",
    class: "harness-ui-datatable"
  }, [
    k("table", {
      class: H("harness-ui-table table " + s.tableClass)
    }, [
      k("thead", {
        class: H(s.headerClass)
      }, [
        k("tr", null, [
          (C(!0), w(ie, null, ae(N.columnHeaders, (x, _) => (C(), w("th", {
            scope: "col",
            key: _,
            class: H(s.labelClass),
            innerHTML: x
          }, null, 10, is))), 128))
        ])
      ], 2),
      k("tbody", null, [
        (C(!0), w(ie, null, ae(s.validatedChartData, (x, _) => (C(), w("tr", {
          key: _,
          class: H(s.rowClass)
        }, [
          (C(!0), w(ie, null, ae(N.columnHeaders, (G, ne) => (C(), w(ie, null, [
            ne === 0 && s.rowHeaderCol ? (C(), w("th", {
              key: ne,
              class: H(s.cellClass),
              innerHTML: x[G],
              scope: "row"
            }, null, 10, rs)) : (C(), w("td", {
              key: `${ne}-else`,
              class: H(s.cellClass),
              innerHTML: x[G]
            }, null, 10, ss))
          ], 64))), 256))
        ], 2))), 128))
      ])
    ], 2)
  ], 8, ns)) : M("", !0);
}
const os = /* @__PURE__ */ fe(ts, [["render", as], ["__scopeId", "data-v-d0c810b3"]]);
const ls = {
  name: "ChartWithTable",
  props: {
    chart: {
      type: Object,
      required: !0
    },
    chartComponent: {
      type: [Object, Function],
      required: !0
    },
    tableDisplay: {
      type: String,
      required: !1,
      default: "toggle"
    },
    scrollable: {
      type: Boolean,
      required: !1,
      default: !1
    },
    downloadable: {
      type: Boolean,
      required: !1,
      default: !0
    },
    card: {
      type: Boolean,
      required: !1,
      default: !0
    },
    buttonPosition: {
      type: String,
      required: !1,
      default: "top"
    },
    saveImageButton: {
      type: Function,
      required: !1
    },
    collapsible: {
      type: Boolean,
      required: !1,
      default: !1
    },
    collapsibleFunc: {
      type: Function,
      required: !1,
      default: () => !0
    },
    startCollapsed: {
      type: Boolean,
      required: !1,
      default: !1
    },
    showTableButtonText: {
      type: String,
      required: !1,
      default: "Show Table"
    },
    showChartButtonText: {
      type: String,
      required: !1,
      default: "Show Chart"
    }
  },
  data: function() {
    return {
      view: "chart",
      chartReady: !1,
      collapsed: this.startCollapsed
    };
  },
  methods: {
    toggleView() {
      switch (this.view) {
        case "chart":
          this.view = "table";
          break;
        case "table":
          this.view = "chart";
          break;
      }
      this.$emit("view", this.view);
    },
    toggleCollapse() {
      this.collapsed = !this.collapsed, this.$emit("collapsed", this.collapsed), this.collapsibleFunc();
    }
  },
  computed: {
    labels() {
      let s = {};
      return this.$attrs.tableColumns && this.$attrs.tableColumnLabels ? (s.tableColumns = this.$attrs.tableColumns, s.tableColumnLabels = this.$attrs.tableColumnLabels) : this.getChartProps(this.chart.key).tableColumns && this.getChartProps(this.chart.key).tableColumnLabels && (s.tableColumns = this.getChartProps(this.chart.key).tableColumns, s.tableColumnLabels = this.getChartProps(
        this.chart.key
      ).tableColumnLabels), s;
    },
    scroll() {
      return this.scrollable ? "height:" + this.getChartProps(this.chart.key).height + "px;overflow-y:auto;" : "";
    }
  }
}, us = (s) => (pi("data-v-5ccab39d"), s = s(), gi(), s), fs = ["id"], cs = { class: "row" }, ds = { class: "harness-ui-chartwithtable-title" }, hs = ["aria-controls"], ps = { class: "harness-ui-chartwithtable-subtitle" }, gs = {
  key: 0,
  class: "col-md-6"
}, ys = {
  id: "button-container",
  class: "float-right"
}, bs = ["aria-label"], ms = ["innerHTML"], vs = ["aria-label"], ks = ["innerHTML"], Cs = ["aria-label"], Ts = ["aria-label"], ws = ["id"], Ss = { class: "harness-ui-chartwithtable-abovechart" }, Ds = /* @__PURE__ */ us(() => /* @__PURE__ */ k("br", null, null, -1)), xs = { class: "harness-ui-chartwithtable-belowchart" }, _s = ["id"], Ls = {
  id: "button-container",
  class: "float-right"
}, As = ["aria-label"], Ns = ["innerHTML"], qs = ["aria-label"], Os = ["innerHTML"], Hs = { key: 2 }, Es = ["aria-label"], Ps = { key: 3 }, Fs = ["aria-label"];
function Ms(s, p, h, E, $, N) {
  const x = je("DataTable508");
  return C(), w("div", {
    id: h.chart.key + "_container",
    class: H((h.card ? "card" : "") + " harness-ui-chartwithtable")
  }, [
    k("div", {
      class: H(h.card ? "card-header" : "")
    }, [
      k("div", cs, [
        k("div", {
          class: H(h.buttonPosition === "top" ? "col-md-6" : "col-md-12")
        }, [
          k("h3", {
            class: H(h.card ? "card-title" : "")
          }, [
            k("div", ds, [
              k("div", null, [
                ze(s.$slots, "title", {
                  innerHTML: h.chart.title
                }, void 0, !0),
                h.collapsible ? (C(), w("button", {
                  key: 0,
                  id: "collapseButton",
                  "data-toggle": "collapse",
                  "aria-expanded": "false",
                  "aria-controls": h.chart.key + "ChartTableBody " + h.chart.key + "Buttons",
                  onClick: p[0] || (p[0] = (..._) => N.toggleCollapse && N.toggleCollapse(..._)),
                  "aria-label": "Toggle Chart"
                }, de(s.collapsed ? "+" : "-"), 9, hs)) : M("", !0)
              ]),
              k("div", ps, [
                ze(s.$slots, "subtitle", {}, void 0, !0)
              ])
            ])
          ], 2)
        ], 2),
        h.buttonPosition === "top" ? (C(), w("div", gs, [
          k("h3", {
            class: H(
              "harness-ui-chartwithtable-buttonrow" + (h.card ? " card-title" : "")
            )
          }, [
            k("span", ys, [
              h.tableDisplay == "toggle" && s.view == "chart" ? (C(), w("button", {
                key: 0,
                role: "button",
                "aria-label": "Show Table: " + (h.chart.title || h.chart.key),
                onClick: p[1] || (p[1] = (..._) => N.toggleView && N.toggleView(..._)),
                class: "btn btn-sm btn-primary harness-ui-togglebutton"
              }, [
                k("span", { innerHTML: h.showTableButtonText }, null, 8, ms)
              ], 8, bs)) : M("", !0),
              h.tableDisplay == "toggle" && s.view == "table" ? (C(), w("button", {
                key: 1,
                role: "button",
                "aria-label": "Show Chart: " + (h.chart.title || h.chart.key),
                onClick: p[2] || (p[2] = (..._) => N.toggleView && N.toggleView(..._)),
                class: "btn btn-sm btn-primary harness-ui-togglebutton"
              }, [
                k("span", { innerHTML: h.showChartButtonText }, null, 8, ks)
              ], 8, vs)) : M("", !0),
              h.downloadable && s.getChartData(h.chart.key) ? (C(), w("button", {
                key: 2,
                role: "button",
                "aria-label": "Download Table: " + (h.chart.title || h.chart.key),
                onClick: p[3] || (p[3] = (_) => s.downloadCSV(h.chart.key)),
                class: "btn btn-sm btn-primary harness-ui-downloadbutton"
              }, " Download CSV ", 8, Cs)) : M("", !0),
              h.saveImageButton && s.getChartData(h.chart.key) ? (C(), w("button", {
                key: 3,
                role: "button",
                "aria-label": "Download Table: " + (h.chart.title || h.chart.key),
                onClick: p[4] || (p[4] = (_) => h.saveImageButton()),
                class: "btn btn-sm btn-primary harness-ui-downloadbutton"
              }, " Save Image ", 8, Ts)) : M("", !0),
              ze(s.$slots, "additional-buttons", {}, void 0, !0)
            ])
          ], 2)
        ])) : M("", !0)
      ])
    ], 2),
    k("div", {
      id: h.chart.key + "ChartTableBody",
      class: H(
        "card-body harness-ui-chartwithtable-body" + (h.collapsible ? " " + h.chart.key + "-multi-collapse" : "") + (s.collapsed ? " collapse" : " show")
      )
    }, [
      k("div", Ss, [
        ze(s.$slots, "above-chart", {}, void 0, !0)
      ]),
      Ne((C(), ft(wt(h.chartComponent), Ze({ chart: h.chart, ...h.chart.props, ...s.$attrs }, {
        key: "chartwithtable" + h.chart.key + "chart"
      }), null, 16)), [
        [di, h.tableDisplay != "toggle" || s.view == "chart"]
      ]),
      Ds,
      k("div", xs, [
        ze(s.$slots, "below-chart", {}, void 0, !0)
      ]),
      Ne((C(), ft(x, Ze({ chart: h.chart, ...h.chart.props, ...s.$attrs }, {
        key: "chartwithtable" + h.chart.key + "table",
        style: N.scroll
      }), null, 16, ["style"])), [
        [di, h.tableDisplay != "toggle" || s.view == "table"]
      ])
    ], 10, ws),
    h.buttonPosition === "bottom" ? (C(), w("h3", {
      key: 0,
      id: h.chart.key + "Buttons",
      class: H(
        "harness-ui-chartwithtable-buttonrow" + (h.collapsible ? " " + h.chart.key + "-multi-collapse" : "") + (s.collapsed ? " collapse" : " show") + (h.card ? " card-title" : "")
      )
    }, [
      k("span", Ls, [
        h.tableDisplay == "toggle" && s.view == "chart" ? (C(), w("button", {
          key: 0,
          role: "button",
          "aria-label": "Show Table: " + (h.chart.title || h.chart.key),
          onClick: p[5] || (p[5] = (..._) => N.toggleView && N.toggleView(..._)),
          class: "btn btn-sm btn-primary harness-ui-togglebutton"
        }, [
          k("span", { innerHTML: h.showTableButtonText }, null, 8, Ns)
        ], 8, As)) : M("", !0),
        h.tableDisplay == "toggle" && s.view == "table" ? (C(), w("button", {
          key: 1,
          role: "button",
          "aria-label": "Show Chart: " + (h.chart.title || h.chart.key),
          onClick: p[6] || (p[6] = (..._) => N.toggleView && N.toggleView(..._)),
          class: "btn btn-sm btn-primary harness-ui-togglebutton"
        }, [
          k("span", { innerHTML: h.showChartButtonText }, null, 8, Os)
        ], 8, qs)) : M("", !0),
        h.downloadable && s.getChartData(h.chart.key) ? (C(), w("span", Hs, [
          k("button", {
            role: "button",
            "aria-label": "Download Table: " + (h.chart.title || h.chart.key),
            onClick: p[7] || (p[7] = (_) => s.downloadCSV(h.chart.key, N.labels || null)),
            class: "btn btn-sm btn-primary harness-ui-downloadbutton"
          }, " Download CSV ", 8, Es)
        ])) : M("", !0),
        h.saveImageButton && s.getChartData(h.chart.key) ? (C(), w("span", Ps, [
          h.saveImageButton ? (C(), w("button", {
            key: 0,
            role: "button",
            "aria-label": "Download Image: " + (h.chart.title || h.chart.key),
            onClick: p[8] || (p[8] = (_) => h.saveImageButton()),
            class: "btn btn-sm btn-primary harness-ui-downloadbutton"
          }, " Save Image ", 8, Fs)) : M("", !0)
        ])) : M("", !0),
        ze(s.$slots, "additional-buttons", {}, void 0, !0)
      ])
    ], 10, _s)) : M("", !0)
  ], 10, fs);
}
const $s = /* @__PURE__ */ fe(ls, [["render", Ms], ["__scopeId", "data-v-5ccab39d"]]);
const js = {
  name: "InteractiveTable",
  mixins: [mi],
  props: {
    local: {
      type: Object,
      required: !1,
      default: () => {
      }
    },
    numRowOptions: {
      type: Array,
      required: !0
    },
    defaultSortColumn: {
      type: String,
      required: !0
    },
    defaultSortOrder: {
      type: String,
      required: !1,
      default: "asc",
      validator: function(s) {
        return ["asc", "desc"].includes(s);
      }
    },
    numPaginationOptions: {
      type: Number,
      required: !1,
      default: 5
    }
  },
  data() {
    return {
      sortedDescending: this.defaultSortOrder === "desc",
      pageNumber: 1,
      searchQuery: "",
      columnSelector: this.defaultSortColumn,
      columnSort: this.defaultSortOrder,
      paginationAmount: 5
    };
  },
  methods: {
    setColumnFilter(s) {
      s === this.columnSelector && (this.sortedDescending = !this.sortedDescending), this.columnSelector = s, this.columnSort = this.sortedDescending ? "desc" : "asc", this.tableOptions.length && this.setFilter(this.chart.key + "TableOptions", [
        {
          pageNumber: this.pageNumber,
          searchQuery: this.searchQuery,
          columnSelector: this.columnSelector,
          columnSort: this.sortedDescending ? "desc" : "asc",
          paginationAmount: this.paginationAmount,
          numberOfPages: this.numberOfPages
        }
      ]), (!this.isSearchable || !this.isSortable || !this.isPaginated) && this.LOAD_DATA();
    },
    setPageNum(s) {
      this.pageNumber = s, this.tableOptions.length && this.setFilter(this.chart.key + "TableOptions", {
        pageNumber: this.pageNumber,
        searchQuery: this.searchQuery,
        columnSelector: this.columnSelector,
        columnSort: this.columnSort,
        paginationAmount: this.paginationAmount,
        numberOfPages: this.numberOfPages
      }), (!this.isSearchable || !this.isSortable || !this.isPaginated) && this.LOAD_DATA();
    },
    isActiveAndDescending(s) {
      return this.columnSort === "desc" && this.columnSelector === s;
    },
    isActiveAndAscending(s) {
      return this.columnSort === "asc" && this.columnSelector === s;
    }
  },
  computed: {
    tableOptions() {
      let s = [];
      return Object.keys(this.filters).includes(this.chart.key + "TableOptions") && (s = this.getOptionsForFilter(this.chart.key + "TableOptions")), s;
    },
    tableAdaptedData() {
      let s = this.getChartData(this.chart.key) || null, p = this.getChartProps(this.chart.key).tableAdapter || null;
      if (s && p)
        try {
          s = p(this.chart, this.filters, s);
        } catch (h) {
          throw String(
            "There was an error in the formatted text from your tableAdapter function: " + String(h)
          );
        }
      return s;
    },
    chartData() {
      let s = this.tableAdaptedData;
      if (s) {
        if (this.isSearchable && (s = s.filter((p) => Object.values(p).reduce((h, E) => h || (E ? E.toLowerCase().includes(this.searchQuery.toLowerCase()) : !1), !1))), this.isSortable && (this.columnSort === "asc" ? s = s.sort((p, h) => p[this.columnSelector].toString().localeCompare(h[this.columnSelector], "en", {
          sensitivity: "base"
        })) : this.columnSort === "desc" && (s = s.sort((p, h) => h[this.columnSelector].toString().localeCompare(p[this.columnSelector], "en", {
          sensitivity: "base"
        })))), this.isPaginated) {
          let p = this.pageNumber, h = s.length, E = parseInt(this.paginationAmount), $ = p * E > h ? h : p * E, N = (p - 1) * E;
          s = s.slice(N, $);
        }
        return s;
      }
      return s;
    },
    isSearchable() {
      return this.local ? !this.local.hasOwnProperty("search") || this.local.hasOwnProperty("search") && this.local.search !== !1 : !0;
    },
    isSortable() {
      return this.local ? !this.local.hasOwnProperty("sort") || this.local.hasOwnProperty("sort") && this.local.sort !== !1 : !0;
    },
    isPaginated() {
      return this.local ? !this.local.hasOwnProperty("paginate") || this.local.hasOwnProperty("paginate") && this.local.paginate !== !1 : !0;
    },
    numberOfPages() {
      let s = this.tableAdaptedData;
      s && (s = s.filter((N) => Object.values(N).reduce((x, _) => x || (_ ? _.toLowerCase().includes(this.searchQuery.toLowerCase()) : !1), !1)));
      let p = [1], h = parseInt(this.paginationAmount), E = this.validateChartData(s, this.chart.key) ? this.validateChartData(s, this.chart.key).length : 0, $ = Math.ceil(E / h);
      for (let N = 2; N <= $; N++)
        p.push(N);
      return p;
    },
    searchText: {
      get() {
        return this.searchQuery;
      },
      set(s) {
        this.searchQuery = s, this.pageNumber = 1, this.tableOptions.length && this.setFilter(this.chart.key + "TableOptions", {
          pageNumber: this.pageNumber,
          searchQuery: this.searchQuery,
          columnSelector: this.columnSelector,
          columnSort: this.columnSort,
          paginationAmount: this.paginationAmount,
          numberOfPages: this.numberOfPages
        }), (!this.isSearchable || !this.isSortable || !this.isPaginated) && this.LOAD_DATA();
      }
    },
    paginationOptions() {
      return this.pageNumber <= this.numPaginationOptions ? this.numberOfPages.slice(0, this.numPaginationOptions) : this.numberOfPages.slice(
        this.pageNumber - this.numPaginationOptions,
        this.pageNumber
      );
    }
  },
  beforeUpdate() {
    this.pageNumber > this.numberOfPages.length && (this.pageNumber = 1, this.tableOptions.length && this.setFilter(this.chart.key + "TableOptions", {
      pageNumber: this.pageNumber,
      searchQuery: this.searchQuery,
      columnSelector: this.columnSelector,
      columnSort: this.columnSort,
      paginationAmount: this.paginationAmount,
      numberOfPages: this.numberOfPages
    }), this.LOAD_DATA());
  }
}, Bt = (s) => (pi("data-v-0ad4c383"), s = s(), gi(), s), Bs = { class: "row py-2" }, Is = { class: "col-sm-3" }, Rs = { class: "row form-row" }, zs = { class: "offset-1 col-4" }, Vs = ["id"], Ws = ["value"], Us = { class: "col-sm-4 offset-sm-5 text-right" }, Gs = { class: "row form-row" }, Qs = { class: "offset-4 col-8 pr-4" }, Xs = ["id"], Ys = ["id"], Js = ["onClick"], Ks = { class: "harness-ui-interactivetable-column-header" }, Zs = {
  key: 0,
  class: /* @__PURE__ */ H(["activeCol"])
}, ea = {
  key: 1,
  class: /* @__PURE__ */ H(["activeCol"])
}, ta = ["innerHTML"], na = ["innerHTML"], ia = { class: "row justify-content-center" }, ra = { class: "col-md-2 text-center" }, sa = {
  "aria-label": "Table pagination navigation",
  class: "navigation text-center harness-ui-interactivetable-pagination-navigation"
}, aa = { class: "pagination harness-ui-interactivetable-pagination" }, oa = /* @__PURE__ */ Bt(() => /* @__PURE__ */ k("i", { class: "bi-chevron-double-left" }, null, -1)), la = [
  oa
], ua = /* @__PURE__ */ Bt(() => /* @__PURE__ */ k("i", { class: "bi-chevron-left" }, null, -1)), fa = [
  ua
], ca = ["onClick"], da = /* @__PURE__ */ Bt(() => /* @__PURE__ */ k("i", { class: "bi-chevron-right" }, null, -1)), ha = [
  da
], pa = /* @__PURE__ */ Bt(() => /* @__PURE__ */ k("i", { class: "bi-chevron-double-right" }, null, -1)), ga = [
  pa
];
function ya(s, p, h, E, $, N) {
  return C(), w("div", null, [
    k("div", null, [
      k("div", Bs, [
        k("div", Is, [
          k("div", Rs, [
            k("div", zs, [
              Ne(k("select", {
                class: "form-control harness-ui-interactivetable-select",
                id: s.chart.key + "NumRowsSelect",
                "aria-label": "Amount of rows to paginate by",
                "onUpdate:modelValue": p[0] || (p[0] = (x) => $.paginationAmount = x)
              }, [
                (C(!0), w(ie, null, ae(h.numRowOptions, (x) => (C(), w("option", {
                  key: x,
                  value: x
                }, de(x), 9, Ws))), 128))
              ], 8, Vs), [
                [jt, $.paginationAmount]
              ])
            ])
          ])
        ]),
        k("div", Us, [
          k("div", Gs, [
            k("div", Qs, [
              Ne(k("input", {
                type: "text",
                class: "form-control harness-ui-interactivetable-text-input",
                id: s.chart.key + "SearchQueryInput",
                "aria-label": "Table search",
                "onUpdate:modelValue": p[1] || (p[1] = (x) => N.searchText = x),
                placeholder: "Search..."
              }, null, 8, Xs), [
                [yi, N.searchText]
              ])
            ])
          ])
        ])
      ]),
      s.validatedChartData && s.validatedChartData.length ? (C(), w("div", {
        key: 0,
        id: s.chart.key + "_data_table",
        class: "harness-ui-interactivetable-datatable"
      }, [
        k("table", {
          class: H("harness-ui-interactivetable-table table " + s.tableClass)
        }, [
          k("thead", {
            class: H(s.headerClass)
          }, [
            k("tr", null, [
              (C(!0), w(ie, null, ae(s.columnHeaders, (x, _) => (C(), w("th", {
                scope: "col",
                key: _,
                class: H("table-header " + s.labelClass),
                onClick: (G) => N.setColumnFilter(x)
              }, [
                k("button", Ks, de(x), 1),
                N.isActiveAndDescending(x) ? (C(), w("span", Zs, "\u25BC")) : M("", !0),
                N.isActiveAndAscending(x) ? (C(), w("span", ea, "\u25B2")) : M("", !0)
              ], 10, Js))), 128))
            ])
          ], 2),
          k("tbody", null, [
            (C(!0), w(ie, null, ae(s.validatedChartData, (x, _) => (C(), w("tr", {
              key: _,
              class: H(s.rowClass)
            }, [
              (C(!0), w(ie, null, ae(s.columnHeaders, (G, ne) => (C(), w(ie, null, [
                ne === 0 && s.rowHeaderCol ? (C(), w("th", {
                  key: ne,
                  class: H(s.cellClass),
                  innerHTML: x[G],
                  scope: "row"
                }, null, 10, ta)) : (C(), w("td", {
                  key: `${ne}-else`,
                  class: H(s.cellClass),
                  innerHTML: x[G]
                }, null, 10, na))
              ], 64))), 256))
            ], 2))), 128))
          ])
        ], 2)
      ], 8, Ys)) : M("", !0)
    ]),
    k("div", ia, [
      k("div", ra, [
        k("nav", sa, [
          k("ul", aa, [
            k("li", {
              class: H(`page-link ${$.pageNumber <= 1 ? "disabled" : ""}`),
              onClick: p[2] || (p[2] = (x) => N.setPageNum(1))
            }, la, 2),
            k("li", {
              class: H(`page-link ${$.pageNumber <= 1 ? "disabled" : ""}`),
              onClick: p[3] || (p[3] = (x) => $.pageNumber != 1 ? N.setPageNum($.pageNumber - 1) : "")
            }, fa, 2),
            (C(!0), w(ie, null, ae(N.paginationOptions, (x) => (C(), w("li", {
              key: x,
              class: H([
                "page-item",
                "harness-ui-interactivetable-pagination-pageitem",
                x === $.pageNumber ? " active" : ""
              ])
            }, [
              k("button", {
                class: H("page-link"),
                onClick: (_) => N.setPageNum(x)
              }, de(x), 9, ca)
            ], 2))), 128)),
            k("li", {
              class: H(`page-link ${$.pageNumber <= 1 ? "disabled" : ""}`),
              onClick: p[4] || (p[4] = (x) => $.pageNumber < N.numberOfPages.length ? N.setPageNum($.pageNumber + 1) : "")
            }, ha, 2),
            k("li", {
              class: H(`page-link ${$.pageNumber <= 1 ? "disabled" : ""}`),
              onClick: p[5] || (p[5] = (x) => N.setPageNum(N.numberOfPages.length))
            }, ga, 2)
          ])
        ])
      ])
    ])
  ]);
}
const ba = /* @__PURE__ */ fe(js, [["render", ya], ["__scopeId", "data-v-0ad4c383"]]), ma = {
  name: "filter-picker",
  props: {
    validFilters: {
      required: !0,
      type: Array
    },
    removeButtonPosition: {
      type: String,
      required: !1,
      default: "center",
      validator: function(s) {
        return ["left", "center", "right"].includes(s);
      }
    },
    columnSize: {
      type: Number,
      required: !1,
      default: 12,
      validator: function(s) {
        return 12 % s === 0;
      }
    }
  },
  data() {
    return {
      active: []
    };
  },
  computed: {
    inactive() {
      return this.validFilters.filter(
        function(s) {
          return !this.active.includes(s);
        }.bind(this)
      );
    }
  },
  methods: {
    addFilter(s) {
      s.target.value && this.active.push(s.target.value);
    },
    removeFilter(s) {
      s.target.value && (this.active = this.active.filter((p) => p !== s.target.value), this.setFilter(
        s.target.value,
        this.getFilterDefault(s.target.value)
      ), this.loadData());
    }
  }
}, va = { class: "harness-ui-filterpicker" }, ka = { class: "row" }, Ca = { class: "row harness-ui-filtergrid-row" }, Ta = { class: "col" }, wa = /* @__PURE__ */ hn("Add Filter"), Sa = /* @__PURE__ */ k("option", null, null, -1), Da = ["value"], xa = { class: "col" }, _a = /* @__PURE__ */ hn("Remove Filter"), La = /* @__PURE__ */ k("option", null, null, -1), Aa = ["value"], Na = { class: "row button-row harness-ui-filtergrid-row harness-ui-filtergrid-buttonrow pt-3" }, qa = /* @__PURE__ */ k("hr", null, null, -1);
function Oa(s, p, h, E, $, N) {
  const x = je("FilterGrid");
  return C(), w("div", va, [
    k("div", ka, [
      k("div", {
        class: H("col-" + h.columnSize)
      }, [
        k("div", Ca, [
          k("div", Ta, [
            ze(s.$slots, "default", { class: "harness-ui-filterpicker-label" }, () => [
              wa
            ]),
            k("select", {
              class: "form-control harness-ui-filterpicker-select",
              name: "filterPicker",
              id: "filterPicker",
              onChange: p[0] || (p[0] = (..._) => N.addFilter && N.addFilter(..._))
            }, [
              Sa,
              (C(!0), w(ie, null, ae(N.inactive, (_) => (C(), w("option", {
                key: _,
                value: _
              }, de(s.getLabel(_)), 9, Da))), 128))
            ], 32)
          ]),
          k("div", xa, [
            ze(s.$slots, "default", { class: "harness-ui-filterpicker-label" }, () => [
              _a
            ]),
            k("select", {
              class: "form-control harness-ui-filterpicker-select",
              name: "filterPicker",
              id: "filterPicker",
              onChange: p[1] || (p[1] = (..._) => N.removeFilter && N.removeFilter(..._))
            }, [
              La,
              (C(!0), w(ie, null, ae($.active, (_) => (C(), w("option", {
                key: _,
                value: _
              }, de(s.getLabel(_)), 9, Aa))), 128))
            ], 32)
          ])
        ]),
        k("div", Na, [
          k("div", {
            class: H("col-md-12 text-" + h.removeButtonPosition)
          }, [
            k("button", {
              role: "button",
              class: "btn btn-primary btn-sm harness-ui-filtergrid-clearbutton",
              onClick: p[2] || (p[2] = (_) => {
                $.active = [], s.initializeDefaults(), s.loadData();
              })
            }, " Remove All Filters ")
          ], 2)
        ]),
        qa,
        he(x, Ze({ only: $.active }, { ...s.$attrs }), null, 16, ["only"])
      ], 2)
    ])
  ]);
}
const Ha = /* @__PURE__ */ fe(ma, [["render", Oa]]), Ea = {
  name: "FiltersAccordion",
  props: {
    validFilters: {
      type: Array,
      required: !0
    },
    mappingFunction: {
      type: Function,
      required: !1
    },
    filterLayout: {
      type: Object,
      required: !1
    }
  },
  computed: {
    filterTypes() {
      return Object.keys(this.filters).reduce((s, p) => (p = this.filters[p], p.props && !s.includes(p.props.filterType) && p.props.filterType !== "internal" && p.props.filterType && s.push(p.props.filterType), s), []);
    }
  },
  methods: {
    subsetFiltersByType(s) {
      return Object.keys(this.filters).filter(
        function(p) {
          if (this.filters[p].props)
            return this.filters[p].props.filterType === s && this.validFilters.includes(p);
        }.bind(this)
      );
    },
    filterMapping(s) {
      return this.mappingFunction ? this.mappingFunction(s) : `${s.replace("_", " ")}s`;
    },
    toggle(s) {
      s.preventDefault();
      let p = s.target.id.split("-")[0], h = document.getElementById(p + "-icon");
      if (h.classList.contains("bi-caret-down-square"))
        h.classList.remove("bi-caret-down-square"), h.classList.add("bi-caret-up-square"), this.filterTypes.filter((E) => E !== p).forEach((E) => {
          let $ = document.getElementById(E + "-icon");
          $.classList.contains("bi-caret-up-square") && ($.classList.remove("bi-caret-up-square"), $.classList.add("bi-caret-down-square"));
        });
      else if (h.classList.contains("bi-caret-up-square")) {
        let E = document.getElementById(p + "-icon");
        E.classList.remove("bi-caret-up-square"), E.classList.add("bi-caret-down-square");
      }
    },
    dirtyFilterString(s) {
      return this.subsetFiltersByType(s).filter((p) => this.isFilterDirty(p)).map((p) => this.getLabel(p)).join(", ");
    },
    clearFilterTypeFilters(s) {
      let p = this.subsetFiltersByType(s);
      this.initializeDefaults(p), this.loadData();
    },
    filterGridLayout(s) {
      return this.filterLayout ? this.filterLayout[s] : {
        columns: 4,
        labelPosition: "vertical",
        spread: !0
      };
    }
  }
}, Pa = { class: "row" }, Fa = {
  class: "accordion col-12",
  id: "filters-accordion"
}, Ma = ["id"], $a = ["id", "data-target"], ja = { class: "mb-0" }, Ba = { class: "row" }, Ia = ["id"], Ra = ["id"], za = ["id", "aria-controls"], Va = ["id"], Wa = ["id"], Ua = ["id"], Ga = ["id"], Qa = ["id", "aria-labelledby"], Xa = { class: "card-body" }, Ya = { class: "row button-row harness-ui-filtergrid-row harness-ui-filtergrid-buttonrow" }, Ja = { class: "col-md-12 text-center" }, Ka = ["onClick"];
function Za(s, p, h, E, $, N) {
  const x = je("FilterGrid");
  return C(), w("div", Pa, [
    k("div", Fa, [
      (C(!0), w(ie, null, ae(N.filterTypes, (_, G) => (C(), w("div", {
        class: "card",
        id: _ + "-card",
        key: G
      }, [
        k("div", {
          class: "card-header",
          id: _ + "-heading",
          onClick: p[2] || (p[2] = (...ne) => N.toggle && N.toggle(...ne)),
          "data-toggle": "collapse",
          "data-target": "#collapse-" + _
        }, [
          k("h2", ja, [
            k("div", Ba, [
              k("div", {
                class: "col-6",
                id: _ + "-col1"
              }, [
                k("i", {
                  class: H(
                    "bi bi-ui-checks " + (N.dirtyFilterString(_).length ? "active" : "")
                  ),
                  id: _ + "-checks"
                }, null, 10, Ra),
                k("button", {
                  class: "btn btn-link",
                  id: _ + "-button",
                  type: "button",
                  "aria-expanded": "false",
                  "aria-controls": "collapse-" + _
                }, de(N.filterMapping(_)), 9, za),
                N.dirtyFilterString(_).length ? (C(), w("small", {
                  key: 0,
                  id: _ + "-small"
                }, de(N.dirtyFilterString(_)), 9, Va)) : M("", !0)
              ], 8, Ia),
              k("div", {
                class: "col-6 text-right",
                id: _ + "-col2"
              }, [
                k("button", {
                  class: "btn btn-link text-right",
                  id: _ + "-collapsebutton",
                  onClick: p[1] || (p[1] = (...ne) => N.toggle && N.toggle(...ne))
                }, [
                  k("i", {
                    class: "bi bi-caret-down-square",
                    id: _ + "-icon",
                    onClick: p[0] || (p[0] = (...ne) => N.toggle && N.toggle(...ne))
                  }, null, 8, Ga)
                ], 8, Ua)
              ], 8, Wa)
            ])
          ])
        ], 8, $a),
        k("div", {
          id: "collapse-" + _,
          class: "collapse",
          "aria-labelledby": _ + "-heading",
          "data-parent": "#filters-accordion"
        }, [
          k("div", Xa, [
            he(x, {
              columns: N.filterGridLayout(_).columns,
              "label-position": N.filterGridLayout(_).labelPosition,
              spread: N.filterGridLayout(_).spread,
              only: N.subsetFiltersByType(_),
              "clear-button": !1
            }, null, 8, ["columns", "label-position", "spread", "only"]),
            k("div", Ya, [
              k("div", Ja, [
                k("button", {
                  class: "btn btn-primary btn-sm harness-ui-filtergrid-clearbutton",
                  role: "button",
                  onClick: (ne) => N.clearFilterTypeFilters(_)
                }, " Clear Filters ", 8, Ka)
              ])
            ])
          ])
        ], 8, Qa)
      ], 8, Ma))), 128))
    ])
  ]);
}
const eo = /* @__PURE__ */ fe(Ea, [["render", Za]]), Be = {
  props: {
    filter: {
      type: Object,
      required: !0,
      validator: function(s) {
        return Object.keys(s).includes("key");
      }
    }
  }
}, to = {
  name: "InputPartial",
  mixins: [Ee, Be],
  props: {
    type: {
      required: !0,
      type: String
    },
    strictError: {
      type: Boolean,
      required: !0
    },
    prependComponent: {
      required: !1,
      type: Object
    },
    prependHTML: {
      required: !1,
      type: String
    },
    appendComponent: {
      required: !1,
      type: Object
    },
    appendHTML: {
      required: !1,
      type: String
    },
    placeholder: {
      required: !1,
      type: String,
      default: ""
    },
    inputClearButton: {
      required: !1,
      type: Boolean,
      default: !1
    }
  },
  methods: {
    initDefault() {
      this.INITIALIZE_DEFAULTS([this.filter.key]), this.synchronous || this.loadData();
    }
  }
}, no = { class: "input-group" }, io = {
  key: 1,
  class: "input-group-prepend"
}, ro = ["innerHTML"], so = ["type", "placeholder", "id", "aria-labelledby"], ao = {
  key: 3,
  class: "input-group-append"
}, oo = ["innerHTML"], lo = /* @__PURE__ */ k("i", { class: "bi bi-x" }, null, -1), uo = [
  lo
];
function fo(s, p, h, E, $, N) {
  return C(), w("div", no, [
    h.prependComponent ? (C(), ft(wt(h.prependComponent), we(Ze({ key: 0 }, { ...s.$props, ...s.$attrs, strictError: h.strictError })), null, 16)) : h.prependHTML ? (C(), w("div", io, [
      k("span", {
        class: "input-group-text",
        innerHTML: h.prependHTML
      }, null, 8, ro)
    ])) : M("", !0),
    Ne(k("input", {
      type: h.type,
      class: H(`form-control harness-ui-${h.type}-input ${s.isFilterDirty(s.filter.key) ? "dirty-filter-input" : ""} ${h.strictError ? "typeahead-strict-error" : ""}`),
      placeholder: h.placeholder,
      "onUpdate:modelValue": p[0] || (p[0] = (x) => s.boundValue = x),
      id: `${s.filter.key}-${h.type}-input`,
      "aria-labelledby": `${s.filter.key}-label`
    }, null, 10, so), [
      [Hr, s.boundValue]
    ]),
    h.appendComponent ? (C(), ft(wt(h.appendComponent), we(Ze({ key: 2 }, { ...s.$props, ...s.$attrs, strictError: h.strictError })), null, 16)) : h.appendHTML || h.inputClearButton ? (C(), w("div", ao, [
      h.appendHTML ? (C(), w("span", {
        key: 0,
        class: "input-group-text",
        innerHTML: h.appendHTML
      }, null, 8, oo)) : M("", !0),
      h.inputClearButton ? (C(), w("button", {
        key: 1,
        class: "btn btn-outline-secondary harness-ui-input-group-clear-button",
        onClick: p[1] || (p[1] = (x) => N.initDefault())
      }, uo)) : M("", !0)
    ])) : M("", !0)
  ]);
}
const co = /* @__PURE__ */ fe(to, [["render", fo]]);
var ho = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : typeof global < "u" ? global : typeof self < "u" ? self : {}, vi = { exports: {} };
/*!
 * jQuery JavaScript Library v3.6.1
 * https://jquery.com/
 *
 * Includes Sizzle.js
 * https://sizzlejs.com/
 *
 * Copyright OpenJS Foundation and other contributors
 * Released under the MIT license
 * https://jquery.org/license
 *
 * Date: 2022-08-26T17:52Z
 */
(function(s) {
  (function(p, h) {
    s.exports = p.document ? h(p, !0) : function(E) {
      if (!E.document)
        throw new Error("jQuery requires a window with a document");
      return h(E);
    };
  })(typeof window < "u" ? window : ho, function(p, h) {
    var E = [], $ = Object.getPrototypeOf, N = E.slice, x = E.flat ? function(e) {
      return E.flat.call(e);
    } : function(e) {
      return E.concat.apply([], e);
    }, _ = E.push, G = E.indexOf, ne = {}, gn = ne.toString, St = ne.hasOwnProperty, yn = St.toString, ki = yn.call(Object), J = {}, U = function(t) {
      return typeof t == "function" && typeof t.nodeType != "number" && typeof t.item != "function";
    }, et = function(t) {
      return t != null && t === t.window;
    }, X = p.document, Ci = {
      type: !0,
      src: !0,
      nonce: !0,
      noModule: !0
    };
    function bn(e, t, n) {
      n = n || X;
      var i, a, o = n.createElement("script");
      if (o.text = e, t)
        for (i in Ci)
          a = t[i] || t.getAttribute && t.getAttribute(i), a && o.setAttribute(i, a);
      n.head.appendChild(o).parentNode.removeChild(o);
    }
    function tt(e) {
      return e == null ? e + "" : typeof e == "object" || typeof e == "function" ? ne[gn.call(e)] || "object" : typeof e;
    }
    var mn = "3.6.1", r = function(e, t) {
      return new r.fn.init(e, t);
    };
    r.fn = r.prototype = {
      jquery: mn,
      constructor: r,
      length: 0,
      toArray: function() {
        return N.call(this);
      },
      get: function(e) {
        return e == null ? N.call(this) : e < 0 ? this[e + this.length] : this[e];
      },
      pushStack: function(e) {
        var t = r.merge(this.constructor(), e);
        return t.prevObject = this, t;
      },
      each: function(e) {
        return r.each(this, e);
      },
      map: function(e) {
        return this.pushStack(r.map(this, function(t, n) {
          return e.call(t, n, t);
        }));
      },
      slice: function() {
        return this.pushStack(N.apply(this, arguments));
      },
      first: function() {
        return this.eq(0);
      },
      last: function() {
        return this.eq(-1);
      },
      even: function() {
        return this.pushStack(r.grep(this, function(e, t) {
          return (t + 1) % 2;
        }));
      },
      odd: function() {
        return this.pushStack(r.grep(this, function(e, t) {
          return t % 2;
        }));
      },
      eq: function(e) {
        var t = this.length, n = +e + (e < 0 ? t : 0);
        return this.pushStack(n >= 0 && n < t ? [this[n]] : []);
      },
      end: function() {
        return this.prevObject || this.constructor();
      },
      push: _,
      sort: E.sort,
      splice: E.splice
    }, r.extend = r.fn.extend = function() {
      var e, t, n, i, a, o, l = arguments[0] || {}, d = 1, f = arguments.length, b = !1;
      for (typeof l == "boolean" && (b = l, l = arguments[d] || {}, d++), typeof l != "object" && !U(l) && (l = {}), d === f && (l = this, d--); d < f; d++)
        if ((e = arguments[d]) != null)
          for (t in e)
            i = e[t], !(t === "__proto__" || l === i) && (b && i && (r.isPlainObject(i) || (a = Array.isArray(i))) ? (n = l[t], a && !Array.isArray(n) ? o = [] : !a && !r.isPlainObject(n) ? o = {} : o = n, a = !1, l[t] = r.extend(b, o, i)) : i !== void 0 && (l[t] = i));
      return l;
    }, r.extend({
      expando: "jQuery" + (mn + Math.random()).replace(/\D/g, ""),
      isReady: !0,
      error: function(e) {
        throw new Error(e);
      },
      noop: function() {
      },
      isPlainObject: function(e) {
        var t, n;
        return !e || gn.call(e) !== "[object Object]" ? !1 : (t = $(e), t ? (n = St.call(t, "constructor") && t.constructor, typeof n == "function" && yn.call(n) === ki) : !0);
      },
      isEmptyObject: function(e) {
        var t;
        for (t in e)
          return !1;
        return !0;
      },
      globalEval: function(e, t, n) {
        bn(e, { nonce: t && t.nonce }, n);
      },
      each: function(e, t) {
        var n, i = 0;
        if (It(e))
          for (n = e.length; i < n && t.call(e[i], i, e[i]) !== !1; i++)
            ;
        else
          for (i in e)
            if (t.call(e[i], i, e[i]) === !1)
              break;
        return e;
      },
      makeArray: function(e, t) {
        var n = t || [];
        return e != null && (It(Object(e)) ? r.merge(
          n,
          typeof e == "string" ? [e] : e
        ) : _.call(n, e)), n;
      },
      inArray: function(e, t, n) {
        return t == null ? -1 : G.call(t, e, n);
      },
      merge: function(e, t) {
        for (var n = +t.length, i = 0, a = e.length; i < n; i++)
          e[a++] = t[i];
        return e.length = a, e;
      },
      grep: function(e, t, n) {
        for (var i, a = [], o = 0, l = e.length, d = !n; o < l; o++)
          i = !t(e[o], o), i !== d && a.push(e[o]);
        return a;
      },
      map: function(e, t, n) {
        var i, a, o = 0, l = [];
        if (It(e))
          for (i = e.length; o < i; o++)
            a = t(e[o], o, n), a != null && l.push(a);
        else
          for (o in e)
            a = t(e[o], o, n), a != null && l.push(a);
        return x(l);
      },
      guid: 1,
      support: J
    }), typeof Symbol == "function" && (r.fn[Symbol.iterator] = E[Symbol.iterator]), r.each(
      "Boolean Number String Function Array Date RegExp Object Error Symbol".split(" "),
      function(e, t) {
        ne["[object " + t + "]"] = t.toLowerCase();
      }
    );
    function It(e) {
      var t = !!e && "length" in e && e.length, n = tt(e);
      return U(e) || et(e) ? !1 : n === "array" || t === 0 || typeof t == "number" && t > 0 && t - 1 in e;
    }
    var Ve = function(e) {
      var t, n, i, a, o, l, d, f, b, v, L, m, T, P, W, F, le, oe, ve, Z = "sizzle" + 1 * new Date(), V = e.document, be = 0, Y = 0, se = Pt(), vt = Pt(), Ot = Pt(), ke = Pt(), Qe = function(u, c) {
        return u === c && (L = !0), 0;
      }, Xe = {}.hasOwnProperty, me = [], Ie = me.pop, xe = me.push, Re = me.push, ii = me.slice, Ye = function(u, c) {
        for (var g = 0, S = u.length; g < S; g++)
          if (u[g] === c)
            return g;
        return -1;
      }, sn = "checked|selected|async|autofocus|autoplay|controls|defer|disabled|hidden|ismap|loop|multiple|open|readonly|required|scoped", K = "[\\x20\\t\\r\\n\\f]", Je = "(?:\\\\[\\da-fA-F]{1,6}" + K + "?|\\\\[^\\r\\n\\f]|[\\w-]|[^\0-\\x7f])+", ri = "\\[" + K + "*(" + Je + ")(?:" + K + "*([*^$|!~]?=)" + K + `*(?:'((?:\\\\.|[^\\\\'])*)'|"((?:\\\\.|[^\\\\"])*)"|(` + Je + "))|)" + K + "*\\]", an = ":(" + Je + `)(?:\\((('((?:\\\\.|[^\\\\'])*)'|"((?:\\\\.|[^\\\\"])*)")|((?:\\\\.|[^\\\\()[\\]]|` + ri + ")*)|.*)\\)|)", vr = new RegExp(K + "+", "g"), Ht = new RegExp("^" + K + "+|((?:^|[^\\\\])(?:\\\\.)*)" + K + "+$", "g"), kr = new RegExp("^" + K + "*," + K + "*"), si = new RegExp("^" + K + "*([>+~]|" + K + ")" + K + "*"), Cr = new RegExp(K + "|>"), Tr = new RegExp(an), wr = new RegExp("^" + Je + "$"), Et = {
        ID: new RegExp("^#(" + Je + ")"),
        CLASS: new RegExp("^\\.(" + Je + ")"),
        TAG: new RegExp("^(" + Je + "|[*])"),
        ATTR: new RegExp("^" + ri),
        PSEUDO: new RegExp("^" + an),
        CHILD: new RegExp("^:(only|first|last|nth|nth-last)-(child|of-type)(?:\\(" + K + "*(even|odd|(([+-]|)(\\d*)n|)" + K + "*(?:([+-]|)" + K + "*(\\d+)|))" + K + "*\\)|)", "i"),
        bool: new RegExp("^(?:" + sn + ")$", "i"),
        needsContext: new RegExp("^" + K + "*[>+~]|:(even|odd|eq|gt|lt|nth|first|last)(?:\\(" + K + "*((?:-\\d)?\\d*)" + K + "*\\)|)(?=[^-]|$)", "i")
      }, Sr = /HTML$/i, Dr = /^(?:input|select|textarea|button)$/i, xr = /^h\d$/i, kt = /^[^{]+\{\s*\[native \w/, _r = /^(?:#([\w-]+)|(\w+)|\.([\w-]+))$/, on = /[+~]/, Me = new RegExp("\\\\[\\da-fA-F]{1,6}" + K + "?|\\\\([^\\r\\n\\f])", "g"), $e = function(u, c) {
        var g = "0x" + u.slice(1) - 65536;
        return c || (g < 0 ? String.fromCharCode(g + 65536) : String.fromCharCode(g >> 10 | 55296, g & 1023 | 56320));
      }, ai = /([\0-\x1f\x7f]|^-?\d)|^-$|[^\0-\x1f\x7f-\uFFFF\w-]/g, oi = function(u, c) {
        return c ? u === "\0" ? "\uFFFD" : u.slice(0, -1) + "\\" + u.charCodeAt(u.length - 1).toString(16) + " " : "\\" + u;
      }, li = function() {
        m();
      }, Lr = Mt(
        function(u) {
          return u.disabled === !0 && u.nodeName.toLowerCase() === "fieldset";
        },
        { dir: "parentNode", next: "legend" }
      );
      try {
        Re.apply(
          me = ii.call(V.childNodes),
          V.childNodes
        ), me[V.childNodes.length].nodeType;
      } catch {
        Re = {
          apply: me.length ? function(c, g) {
            xe.apply(c, ii.call(g));
          } : function(c, g) {
            for (var S = c.length, y = 0; c[S++] = g[y++]; )
              ;
            c.length = S - 1;
          }
        };
      }
      function ee(u, c, g, S) {
        var y, D, A, q, O, I, j, z = c && c.ownerDocument, Q = c ? c.nodeType : 9;
        if (g = g || [], typeof u != "string" || !u || Q !== 1 && Q !== 9 && Q !== 11)
          return g;
        if (!S && (m(c), c = c || T, W)) {
          if (Q !== 11 && (O = _r.exec(u)))
            if (y = O[1]) {
              if (Q === 9)
                if (A = c.getElementById(y)) {
                  if (A.id === y)
                    return g.push(A), g;
                } else
                  return g;
              else if (z && (A = z.getElementById(y)) && ve(c, A) && A.id === y)
                return g.push(A), g;
            } else {
              if (O[2])
                return Re.apply(g, c.getElementsByTagName(u)), g;
              if ((y = O[3]) && n.getElementsByClassName && c.getElementsByClassName)
                return Re.apply(g, c.getElementsByClassName(y)), g;
            }
          if (n.qsa && !ke[u + " "] && (!F || !F.test(u)) && (Q !== 1 || c.nodeName.toLowerCase() !== "object")) {
            if (j = u, z = c, Q === 1 && (Cr.test(u) || si.test(u))) {
              for (z = on.test(u) && un(c.parentNode) || c, (z !== c || !n.scope) && ((q = c.getAttribute("id")) ? q = q.replace(ai, oi) : c.setAttribute("id", q = Z)), I = l(u), D = I.length; D--; )
                I[D] = (q ? "#" + q : ":scope") + " " + Ft(I[D]);
              j = I.join(",");
            }
            try {
              return Re.apply(
                g,
                z.querySelectorAll(j)
              ), g;
            } catch {
              ke(u, !0);
            } finally {
              q === Z && c.removeAttribute("id");
            }
          }
        }
        return f(u.replace(Ht, "$1"), c, g, S);
      }
      function Pt() {
        var u = [];
        function c(g, S) {
          return u.push(g + " ") > i.cacheLength && delete c[u.shift()], c[g + " "] = S;
        }
        return c;
      }
      function Le(u) {
        return u[Z] = !0, u;
      }
      function Ae(u) {
        var c = T.createElement("fieldset");
        try {
          return !!u(c);
        } catch {
          return !1;
        } finally {
          c.parentNode && c.parentNode.removeChild(c), c = null;
        }
      }
      function ln(u, c) {
        for (var g = u.split("|"), S = g.length; S--; )
          i.attrHandle[g[S]] = c;
      }
      function ui(u, c) {
        var g = c && u, S = g && u.nodeType === 1 && c.nodeType === 1 && u.sourceIndex - c.sourceIndex;
        if (S)
          return S;
        if (g) {
          for (; g = g.nextSibling; )
            if (g === c)
              return -1;
        }
        return u ? 1 : -1;
      }
      function Ar(u) {
        return function(c) {
          var g = c.nodeName.toLowerCase();
          return g === "input" && c.type === u;
        };
      }
      function Nr(u) {
        return function(c) {
          var g = c.nodeName.toLowerCase();
          return (g === "input" || g === "button") && c.type === u;
        };
      }
      function fi(u) {
        return function(c) {
          return "form" in c ? c.parentNode && c.disabled === !1 ? "label" in c ? "label" in c.parentNode ? c.parentNode.disabled === u : c.disabled === u : c.isDisabled === u || c.isDisabled !== !u && Lr(c) === u : c.disabled === u : "label" in c ? c.disabled === u : !1;
        };
      }
      function Ke(u) {
        return Le(function(c) {
          return c = +c, Le(function(g, S) {
            for (var y, D = u([], g.length, c), A = D.length; A--; )
              g[y = D[A]] && (g[y] = !(S[y] = g[y]));
          });
        });
      }
      function un(u) {
        return u && typeof u.getElementsByTagName < "u" && u;
      }
      n = ee.support = {}, o = ee.isXML = function(u) {
        var c = u && u.namespaceURI, g = u && (u.ownerDocument || u).documentElement;
        return !Sr.test(c || g && g.nodeName || "HTML");
      }, m = ee.setDocument = function(u) {
        var c, g, S = u ? u.ownerDocument || u : V;
        return S == T || S.nodeType !== 9 || !S.documentElement || (T = S, P = T.documentElement, W = !o(T), V != T && (g = T.defaultView) && g.top !== g && (g.addEventListener ? g.addEventListener("unload", li, !1) : g.attachEvent && g.attachEvent("onunload", li)), n.scope = Ae(function(y) {
          return P.appendChild(y).appendChild(T.createElement("div")), typeof y.querySelectorAll < "u" && !y.querySelectorAll(":scope fieldset div").length;
        }), n.attributes = Ae(function(y) {
          return y.className = "i", !y.getAttribute("className");
        }), n.getElementsByTagName = Ae(function(y) {
          return y.appendChild(T.createComment("")), !y.getElementsByTagName("*").length;
        }), n.getElementsByClassName = kt.test(T.getElementsByClassName), n.getById = Ae(function(y) {
          return P.appendChild(y).id = Z, !T.getElementsByName || !T.getElementsByName(Z).length;
        }), n.getById ? (i.filter.ID = function(y) {
          var D = y.replace(Me, $e);
          return function(A) {
            return A.getAttribute("id") === D;
          };
        }, i.find.ID = function(y, D) {
          if (typeof D.getElementById < "u" && W) {
            var A = D.getElementById(y);
            return A ? [A] : [];
          }
        }) : (i.filter.ID = function(y) {
          var D = y.replace(Me, $e);
          return function(A) {
            var q = typeof A.getAttributeNode < "u" && A.getAttributeNode("id");
            return q && q.value === D;
          };
        }, i.find.ID = function(y, D) {
          if (typeof D.getElementById < "u" && W) {
            var A, q, O, I = D.getElementById(y);
            if (I) {
              if (A = I.getAttributeNode("id"), A && A.value === y)
                return [I];
              for (O = D.getElementsByName(y), q = 0; I = O[q++]; )
                if (A = I.getAttributeNode("id"), A && A.value === y)
                  return [I];
            }
            return [];
          }
        }), i.find.TAG = n.getElementsByTagName ? function(y, D) {
          if (typeof D.getElementsByTagName < "u")
            return D.getElementsByTagName(y);
          if (n.qsa)
            return D.querySelectorAll(y);
        } : function(y, D) {
          var A, q = [], O = 0, I = D.getElementsByTagName(y);
          if (y === "*") {
            for (; A = I[O++]; )
              A.nodeType === 1 && q.push(A);
            return q;
          }
          return I;
        }, i.find.CLASS = n.getElementsByClassName && function(y, D) {
          if (typeof D.getElementsByClassName < "u" && W)
            return D.getElementsByClassName(y);
        }, le = [], F = [], (n.qsa = kt.test(T.querySelectorAll)) && (Ae(function(y) {
          var D;
          P.appendChild(y).innerHTML = "<a id='" + Z + "'></a><select id='" + Z + "-\r\\' msallowcapture=''><option selected=''></option></select>", y.querySelectorAll("[msallowcapture^='']").length && F.push("[*^$]=" + K + `*(?:''|"")`), y.querySelectorAll("[selected]").length || F.push("\\[" + K + "*(?:value|" + sn + ")"), y.querySelectorAll("[id~=" + Z + "-]").length || F.push("~="), D = T.createElement("input"), D.setAttribute("name", ""), y.appendChild(D), y.querySelectorAll("[name='']").length || F.push("\\[" + K + "*name" + K + "*=" + K + `*(?:''|"")`), y.querySelectorAll(":checked").length || F.push(":checked"), y.querySelectorAll("a#" + Z + "+*").length || F.push(".#.+[+~]"), y.querySelectorAll("\\\f"), F.push("[\\r\\n\\f]");
        }), Ae(function(y) {
          y.innerHTML = "<a href='' disabled='disabled'></a><select disabled='disabled'><option/></select>";
          var D = T.createElement("input");
          D.setAttribute("type", "hidden"), y.appendChild(D).setAttribute("name", "D"), y.querySelectorAll("[name=d]").length && F.push("name" + K + "*[*^$|!~]?="), y.querySelectorAll(":enabled").length !== 2 && F.push(":enabled", ":disabled"), P.appendChild(y).disabled = !0, y.querySelectorAll(":disabled").length !== 2 && F.push(":enabled", ":disabled"), y.querySelectorAll("*,:x"), F.push(",.*:");
        })), (n.matchesSelector = kt.test(oe = P.matches || P.webkitMatchesSelector || P.mozMatchesSelector || P.oMatchesSelector || P.msMatchesSelector)) && Ae(function(y) {
          n.disconnectedMatch = oe.call(y, "*"), oe.call(y, "[s!='']:x"), le.push("!=", an);
        }), F = F.length && new RegExp(F.join("|")), le = le.length && new RegExp(le.join("|")), c = kt.test(P.compareDocumentPosition), ve = c || kt.test(P.contains) ? function(y, D) {
          var A = y.nodeType === 9 ? y.documentElement : y, q = D && D.parentNode;
          return y === q || !!(q && q.nodeType === 1 && (A.contains ? A.contains(q) : y.compareDocumentPosition && y.compareDocumentPosition(q) & 16));
        } : function(y, D) {
          if (D) {
            for (; D = D.parentNode; )
              if (D === y)
                return !0;
          }
          return !1;
        }, Qe = c ? function(y, D) {
          if (y === D)
            return L = !0, 0;
          var A = !y.compareDocumentPosition - !D.compareDocumentPosition;
          return A || (A = (y.ownerDocument || y) == (D.ownerDocument || D) ? y.compareDocumentPosition(D) : 1, A & 1 || !n.sortDetached && D.compareDocumentPosition(y) === A ? y == T || y.ownerDocument == V && ve(V, y) ? -1 : D == T || D.ownerDocument == V && ve(V, D) ? 1 : v ? Ye(v, y) - Ye(v, D) : 0 : A & 4 ? -1 : 1);
        } : function(y, D) {
          if (y === D)
            return L = !0, 0;
          var A, q = 0, O = y.parentNode, I = D.parentNode, j = [y], z = [D];
          if (!O || !I)
            return y == T ? -1 : D == T ? 1 : O ? -1 : I ? 1 : v ? Ye(v, y) - Ye(v, D) : 0;
          if (O === I)
            return ui(y, D);
          for (A = y; A = A.parentNode; )
            j.unshift(A);
          for (A = D; A = A.parentNode; )
            z.unshift(A);
          for (; j[q] === z[q]; )
            q++;
          return q ? ui(j[q], z[q]) : j[q] == V ? -1 : z[q] == V ? 1 : 0;
        }), T;
      }, ee.matches = function(u, c) {
        return ee(u, null, null, c);
      }, ee.matchesSelector = function(u, c) {
        if (m(u), n.matchesSelector && W && !ke[c + " "] && (!le || !le.test(c)) && (!F || !F.test(c)))
          try {
            var g = oe.call(u, c);
            if (g || n.disconnectedMatch || u.document && u.document.nodeType !== 11)
              return g;
          } catch {
            ke(c, !0);
          }
        return ee(c, T, null, [u]).length > 0;
      }, ee.contains = function(u, c) {
        return (u.ownerDocument || u) != T && m(u), ve(u, c);
      }, ee.attr = function(u, c) {
        (u.ownerDocument || u) != T && m(u);
        var g = i.attrHandle[c.toLowerCase()], S = g && Xe.call(i.attrHandle, c.toLowerCase()) ? g(u, c, !W) : void 0;
        return S !== void 0 ? S : n.attributes || !W ? u.getAttribute(c) : (S = u.getAttributeNode(c)) && S.specified ? S.value : null;
      }, ee.escape = function(u) {
        return (u + "").replace(ai, oi);
      }, ee.error = function(u) {
        throw new Error("Syntax error, unrecognized expression: " + u);
      }, ee.uniqueSort = function(u) {
        var c, g = [], S = 0, y = 0;
        if (L = !n.detectDuplicates, v = !n.sortStable && u.slice(0), u.sort(Qe), L) {
          for (; c = u[y++]; )
            c === u[y] && (S = g.push(y));
          for (; S--; )
            u.splice(g[S], 1);
        }
        return v = null, u;
      }, a = ee.getText = function(u) {
        var c, g = "", S = 0, y = u.nodeType;
        if (y) {
          if (y === 1 || y === 9 || y === 11) {
            if (typeof u.textContent == "string")
              return u.textContent;
            for (u = u.firstChild; u; u = u.nextSibling)
              g += a(u);
          } else if (y === 3 || y === 4)
            return u.nodeValue;
        } else
          for (; c = u[S++]; )
            g += a(c);
        return g;
      }, i = ee.selectors = {
        cacheLength: 50,
        createPseudo: Le,
        match: Et,
        attrHandle: {},
        find: {},
        relative: {
          ">": { dir: "parentNode", first: !0 },
          " ": { dir: "parentNode" },
          "+": { dir: "previousSibling", first: !0 },
          "~": { dir: "previousSibling" }
        },
        preFilter: {
          ATTR: function(u) {
            return u[1] = u[1].replace(Me, $e), u[3] = (u[3] || u[4] || u[5] || "").replace(Me, $e), u[2] === "~=" && (u[3] = " " + u[3] + " "), u.slice(0, 4);
          },
          CHILD: function(u) {
            return u[1] = u[1].toLowerCase(), u[1].slice(0, 3) === "nth" ? (u[3] || ee.error(u[0]), u[4] = +(u[4] ? u[5] + (u[6] || 1) : 2 * (u[3] === "even" || u[3] === "odd")), u[5] = +(u[7] + u[8] || u[3] === "odd")) : u[3] && ee.error(u[0]), u;
          },
          PSEUDO: function(u) {
            var c, g = !u[6] && u[2];
            return Et.CHILD.test(u[0]) ? null : (u[3] ? u[2] = u[4] || u[5] || "" : g && Tr.test(g) && (c = l(g, !0)) && (c = g.indexOf(")", g.length - c) - g.length) && (u[0] = u[0].slice(0, c), u[2] = g.slice(0, c)), u.slice(0, 3));
          }
        },
        filter: {
          TAG: function(u) {
            var c = u.replace(Me, $e).toLowerCase();
            return u === "*" ? function() {
              return !0;
            } : function(g) {
              return g.nodeName && g.nodeName.toLowerCase() === c;
            };
          },
          CLASS: function(u) {
            var c = se[u + " "];
            return c || (c = new RegExp("(^|" + K + ")" + u + "(" + K + "|$)")) && se(
              u,
              function(g) {
                return c.test(
                  typeof g.className == "string" && g.className || typeof g.getAttribute < "u" && g.getAttribute("class") || ""
                );
              }
            );
          },
          ATTR: function(u, c, g) {
            return function(S) {
              var y = ee.attr(S, u);
              return y == null ? c === "!=" : c ? (y += "", c === "=" ? y === g : c === "!=" ? y !== g : c === "^=" ? g && y.indexOf(g) === 0 : c === "*=" ? g && y.indexOf(g) > -1 : c === "$=" ? g && y.slice(-g.length) === g : c === "~=" ? (" " + y.replace(vr, " ") + " ").indexOf(g) > -1 : c === "|=" ? y === g || y.slice(0, g.length + 1) === g + "-" : !1) : !0;
            };
          },
          CHILD: function(u, c, g, S, y) {
            var D = u.slice(0, 3) !== "nth", A = u.slice(-4) !== "last", q = c === "of-type";
            return S === 1 && y === 0 ? function(O) {
              return !!O.parentNode;
            } : function(O, I, j) {
              var z, Q, te, R, ue, ce, Ce = D !== A ? "nextSibling" : "previousSibling", re = O.parentNode, Ct = q && O.nodeName.toLowerCase(), Tt = !j && !q, Te = !1;
              if (re) {
                if (D) {
                  for (; Ce; ) {
                    for (R = O; R = R[Ce]; )
                      if (q ? R.nodeName.toLowerCase() === Ct : R.nodeType === 1)
                        return !1;
                    ce = Ce = u === "only" && !ce && "nextSibling";
                  }
                  return !0;
                }
                if (ce = [A ? re.firstChild : re.lastChild], A && Tt) {
                  for (R = re, te = R[Z] || (R[Z] = {}), Q = te[R.uniqueID] || (te[R.uniqueID] = {}), z = Q[u] || [], ue = z[0] === be && z[1], Te = ue && z[2], R = ue && re.childNodes[ue]; R = ++ue && R && R[Ce] || (Te = ue = 0) || ce.pop(); )
                    if (R.nodeType === 1 && ++Te && R === O) {
                      Q[u] = [be, ue, Te];
                      break;
                    }
                } else if (Tt && (R = O, te = R[Z] || (R[Z] = {}), Q = te[R.uniqueID] || (te[R.uniqueID] = {}), z = Q[u] || [], ue = z[0] === be && z[1], Te = ue), Te === !1)
                  for (; (R = ++ue && R && R[Ce] || (Te = ue = 0) || ce.pop()) && !((q ? R.nodeName.toLowerCase() === Ct : R.nodeType === 1) && ++Te && (Tt && (te = R[Z] || (R[Z] = {}), Q = te[R.uniqueID] || (te[R.uniqueID] = {}), Q[u] = [be, Te]), R === O)); )
                    ;
                return Te -= y, Te === S || Te % S === 0 && Te / S >= 0;
              }
            };
          },
          PSEUDO: function(u, c) {
            var g, S = i.pseudos[u] || i.setFilters[u.toLowerCase()] || ee.error("unsupported pseudo: " + u);
            return S[Z] ? S(c) : S.length > 1 ? (g = [u, u, "", c], i.setFilters.hasOwnProperty(u.toLowerCase()) ? Le(function(y, D) {
              for (var A, q = S(y, c), O = q.length; O--; )
                A = Ye(y, q[O]), y[A] = !(D[A] = q[O]);
            }) : function(y) {
              return S(y, 0, g);
            }) : S;
          }
        },
        pseudos: {
          not: Le(function(u) {
            var c = [], g = [], S = d(u.replace(Ht, "$1"));
            return S[Z] ? Le(function(y, D, A, q) {
              for (var O, I = S(y, null, q, []), j = y.length; j--; )
                (O = I[j]) && (y[j] = !(D[j] = O));
            }) : function(y, D, A) {
              return c[0] = y, S(c, null, A, g), c[0] = null, !g.pop();
            };
          }),
          has: Le(function(u) {
            return function(c) {
              return ee(u, c).length > 0;
            };
          }),
          contains: Le(function(u) {
            return u = u.replace(Me, $e), function(c) {
              return (c.textContent || a(c)).indexOf(u) > -1;
            };
          }),
          lang: Le(function(u) {
            return wr.test(u || "") || ee.error("unsupported lang: " + u), u = u.replace(Me, $e).toLowerCase(), function(c) {
              var g;
              do
                if (g = W ? c.lang : c.getAttribute("xml:lang") || c.getAttribute("lang"))
                  return g = g.toLowerCase(), g === u || g.indexOf(u + "-") === 0;
              while ((c = c.parentNode) && c.nodeType === 1);
              return !1;
            };
          }),
          target: function(u) {
            var c = e.location && e.location.hash;
            return c && c.slice(1) === u.id;
          },
          root: function(u) {
            return u === P;
          },
          focus: function(u) {
            return u === T.activeElement && (!T.hasFocus || T.hasFocus()) && !!(u.type || u.href || ~u.tabIndex);
          },
          enabled: fi(!1),
          disabled: fi(!0),
          checked: function(u) {
            var c = u.nodeName.toLowerCase();
            return c === "input" && !!u.checked || c === "option" && !!u.selected;
          },
          selected: function(u) {
            return u.parentNode && u.parentNode.selectedIndex, u.selected === !0;
          },
          empty: function(u) {
            for (u = u.firstChild; u; u = u.nextSibling)
              if (u.nodeType < 6)
                return !1;
            return !0;
          },
          parent: function(u) {
            return !i.pseudos.empty(u);
          },
          header: function(u) {
            return xr.test(u.nodeName);
          },
          input: function(u) {
            return Dr.test(u.nodeName);
          },
          button: function(u) {
            var c = u.nodeName.toLowerCase();
            return c === "input" && u.type === "button" || c === "button";
          },
          text: function(u) {
            var c;
            return u.nodeName.toLowerCase() === "input" && u.type === "text" && ((c = u.getAttribute("type")) == null || c.toLowerCase() === "text");
          },
          first: Ke(function() {
            return [0];
          }),
          last: Ke(function(u, c) {
            return [c - 1];
          }),
          eq: Ke(function(u, c, g) {
            return [g < 0 ? g + c : g];
          }),
          even: Ke(function(u, c) {
            for (var g = 0; g < c; g += 2)
              u.push(g);
            return u;
          }),
          odd: Ke(function(u, c) {
            for (var g = 1; g < c; g += 2)
              u.push(g);
            return u;
          }),
          lt: Ke(function(u, c, g) {
            for (var S = g < 0 ? g + c : g > c ? c : g; --S >= 0; )
              u.push(S);
            return u;
          }),
          gt: Ke(function(u, c, g) {
            for (var S = g < 0 ? g + c : g; ++S < c; )
              u.push(S);
            return u;
          })
        }
      }, i.pseudos.nth = i.pseudos.eq;
      for (t in { radio: !0, checkbox: !0, file: !0, password: !0, image: !0 })
        i.pseudos[t] = Ar(t);
      for (t in { submit: !0, reset: !0 })
        i.pseudos[t] = Nr(t);
      function ci() {
      }
      ci.prototype = i.filters = i.pseudos, i.setFilters = new ci(), l = ee.tokenize = function(u, c) {
        var g, S, y, D, A, q, O, I = vt[u + " "];
        if (I)
          return c ? 0 : I.slice(0);
        for (A = u, q = [], O = i.preFilter; A; ) {
          (!g || (S = kr.exec(A))) && (S && (A = A.slice(S[0].length) || A), q.push(y = [])), g = !1, (S = si.exec(A)) && (g = S.shift(), y.push({
            value: g,
            type: S[0].replace(Ht, " ")
          }), A = A.slice(g.length));
          for (D in i.filter)
            (S = Et[D].exec(A)) && (!O[D] || (S = O[D](S))) && (g = S.shift(), y.push({
              value: g,
              type: D,
              matches: S
            }), A = A.slice(g.length));
          if (!g)
            break;
        }
        return c ? A.length : A ? ee.error(u) : vt(u, q).slice(0);
      };
      function Ft(u) {
        for (var c = 0, g = u.length, S = ""; c < g; c++)
          S += u[c].value;
        return S;
      }
      function Mt(u, c, g) {
        var S = c.dir, y = c.next, D = y || S, A = g && D === "parentNode", q = Y++;
        return c.first ? function(O, I, j) {
          for (; O = O[S]; )
            if (O.nodeType === 1 || A)
              return u(O, I, j);
          return !1;
        } : function(O, I, j) {
          var z, Q, te, R = [be, q];
          if (j) {
            for (; O = O[S]; )
              if ((O.nodeType === 1 || A) && u(O, I, j))
                return !0;
          } else
            for (; O = O[S]; )
              if (O.nodeType === 1 || A)
                if (te = O[Z] || (O[Z] = {}), Q = te[O.uniqueID] || (te[O.uniqueID] = {}), y && y === O.nodeName.toLowerCase())
                  O = O[S] || O;
                else {
                  if ((z = Q[D]) && z[0] === be && z[1] === q)
                    return R[2] = z[2];
                  if (Q[D] = R, R[2] = u(O, I, j))
                    return !0;
                }
          return !1;
        };
      }
      function fn(u) {
        return u.length > 1 ? function(c, g, S) {
          for (var y = u.length; y--; )
            if (!u[y](c, g, S))
              return !1;
          return !0;
        } : u[0];
      }
      function qr(u, c, g) {
        for (var S = 0, y = c.length; S < y; S++)
          ee(u, c[S], g);
        return g;
      }
      function $t(u, c, g, S, y) {
        for (var D, A = [], q = 0, O = u.length, I = c != null; q < O; q++)
          (D = u[q]) && (!g || g(D, S, y)) && (A.push(D), I && c.push(q));
        return A;
      }
      function cn(u, c, g, S, y, D) {
        return S && !S[Z] && (S = cn(S)), y && !y[Z] && (y = cn(y, D)), Le(function(A, q, O, I) {
          var j, z, Q, te = [], R = [], ue = q.length, ce = A || qr(
            c || "*",
            O.nodeType ? [O] : O,
            []
          ), Ce = u && (A || !c) ? $t(ce, te, u, O, I) : ce, re = g ? y || (A ? u : ue || S) ? [] : q : Ce;
          if (g && g(Ce, re, O, I), S)
            for (j = $t(re, R), S(j, [], O, I), z = j.length; z--; )
              (Q = j[z]) && (re[R[z]] = !(Ce[R[z]] = Q));
          if (A) {
            if (y || u) {
              if (y) {
                for (j = [], z = re.length; z--; )
                  (Q = re[z]) && j.push(Ce[z] = Q);
                y(null, re = [], j, I);
              }
              for (z = re.length; z--; )
                (Q = re[z]) && (j = y ? Ye(A, Q) : te[z]) > -1 && (A[j] = !(q[j] = Q));
            }
          } else
            re = $t(
              re === q ? re.splice(ue, re.length) : re
            ), y ? y(null, q, re, I) : Re.apply(q, re);
        });
      }
      function dn(u) {
        for (var c, g, S, y = u.length, D = i.relative[u[0].type], A = D || i.relative[" "], q = D ? 1 : 0, O = Mt(function(z) {
          return z === c;
        }, A, !0), I = Mt(function(z) {
          return Ye(c, z) > -1;
        }, A, !0), j = [function(z, Q, te) {
          var R = !D && (te || Q !== b) || ((c = Q).nodeType ? O(z, Q, te) : I(z, Q, te));
          return c = null, R;
        }]; q < y; q++)
          if (g = i.relative[u[q].type])
            j = [Mt(fn(j), g)];
          else {
            if (g = i.filter[u[q].type].apply(null, u[q].matches), g[Z]) {
              for (S = ++q; S < y && !i.relative[u[S].type]; S++)
                ;
              return cn(
                q > 1 && fn(j),
                q > 1 && Ft(
                  u.slice(0, q - 1).concat({ value: u[q - 2].type === " " ? "*" : "" })
                ).replace(Ht, "$1"),
                g,
                q < S && dn(u.slice(q, S)),
                S < y && dn(u = u.slice(S)),
                S < y && Ft(u)
              );
            }
            j.push(g);
          }
        return fn(j);
      }
      function Or(u, c) {
        var g = c.length > 0, S = u.length > 0, y = function(D, A, q, O, I) {
          var j, z, Q, te = 0, R = "0", ue = D && [], ce = [], Ce = b, re = D || S && i.find.TAG("*", I), Ct = be += Ce == null ? 1 : Math.random() || 0.1, Tt = re.length;
          for (I && (b = A == T || A || I); R !== Tt && (j = re[R]) != null; R++) {
            if (S && j) {
              for (z = 0, !A && j.ownerDocument != T && (m(j), q = !W); Q = u[z++]; )
                if (Q(j, A || T, q)) {
                  O.push(j);
                  break;
                }
              I && (be = Ct);
            }
            g && ((j = !Q && j) && te--, D && ue.push(j));
          }
          if (te += R, g && R !== te) {
            for (z = 0; Q = c[z++]; )
              Q(ue, ce, A, q);
            if (D) {
              if (te > 0)
                for (; R--; )
                  ue[R] || ce[R] || (ce[R] = Ie.call(O));
              ce = $t(ce);
            }
            Re.apply(O, ce), I && !D && ce.length > 0 && te + c.length > 1 && ee.uniqueSort(O);
          }
          return I && (be = Ct, b = Ce), ue;
        };
        return g ? Le(y) : y;
      }
      return d = ee.compile = function(u, c) {
        var g, S = [], y = [], D = Ot[u + " "];
        if (!D) {
          for (c || (c = l(u)), g = c.length; g--; )
            D = dn(c[g]), D[Z] ? S.push(D) : y.push(D);
          D = Ot(
            u,
            Or(y, S)
          ), D.selector = u;
        }
        return D;
      }, f = ee.select = function(u, c, g, S) {
        var y, D, A, q, O, I = typeof u == "function" && u, j = !S && l(u = I.selector || u);
        if (g = g || [], j.length === 1) {
          if (D = j[0] = j[0].slice(0), D.length > 2 && (A = D[0]).type === "ID" && c.nodeType === 9 && W && i.relative[D[1].type]) {
            if (c = (i.find.ID(A.matches[0].replace(Me, $e), c) || [])[0], c)
              I && (c = c.parentNode);
            else
              return g;
            u = u.slice(D.shift().value.length);
          }
          for (y = Et.needsContext.test(u) ? 0 : D.length; y-- && (A = D[y], !i.relative[q = A.type]); )
            if ((O = i.find[q]) && (S = O(
              A.matches[0].replace(Me, $e),
              on.test(D[0].type) && un(c.parentNode) || c
            ))) {
              if (D.splice(y, 1), u = S.length && Ft(D), !u)
                return Re.apply(g, S), g;
              break;
            }
        }
        return (I || d(u, j))(
          S,
          c,
          !W,
          g,
          !c || on.test(u) && un(c.parentNode) || c
        ), g;
      }, n.sortStable = Z.split("").sort(Qe).join("") === Z, n.detectDuplicates = !!L, m(), n.sortDetached = Ae(function(u) {
        return u.compareDocumentPosition(T.createElement("fieldset")) & 1;
      }), Ae(function(u) {
        return u.innerHTML = "<a href='#'></a>", u.firstChild.getAttribute("href") === "#";
      }) || ln("type|href|height|width", function(u, c, g) {
        if (!g)
          return u.getAttribute(c, c.toLowerCase() === "type" ? 1 : 2);
      }), (!n.attributes || !Ae(function(u) {
        return u.innerHTML = "<input/>", u.firstChild.setAttribute("value", ""), u.firstChild.getAttribute("value") === "";
      })) && ln("value", function(u, c, g) {
        if (!g && u.nodeName.toLowerCase() === "input")
          return u.defaultValue;
      }), Ae(function(u) {
        return u.getAttribute("disabled") == null;
      }) || ln(sn, function(u, c, g) {
        var S;
        if (!g)
          return u[c] === !0 ? c.toLowerCase() : (S = u.getAttributeNode(c)) && S.specified ? S.value : null;
      }), ee;
    }(p);
    r.find = Ve, r.expr = Ve.selectors, r.expr[":"] = r.expr.pseudos, r.uniqueSort = r.unique = Ve.uniqueSort, r.text = Ve.getText, r.isXMLDoc = Ve.isXML, r.contains = Ve.contains, r.escapeSelector = Ve.escape;
    var nt = function(e, t, n) {
      for (var i = [], a = n !== void 0; (e = e[t]) && e.nodeType !== 9; )
        if (e.nodeType === 1) {
          if (a && r(e).is(n))
            break;
          i.push(e);
        }
      return i;
    }, vn = function(e, t) {
      for (var n = []; e; e = e.nextSibling)
        e.nodeType === 1 && e !== t && n.push(e);
      return n;
    }, kn = r.expr.match.needsContext;
    function Se(e, t) {
      return e.nodeName && e.nodeName.toLowerCase() === t.toLowerCase();
    }
    var Cn = /^<([a-z][^\/\0>:\x20\t\r\n\f]*)[\x20\t\r\n\f]*\/?>(?:<\/\1>|)$/i;
    function Rt(e, t, n) {
      return U(t) ? r.grep(e, function(i, a) {
        return !!t.call(i, a, i) !== n;
      }) : t.nodeType ? r.grep(e, function(i) {
        return i === t !== n;
      }) : typeof t != "string" ? r.grep(e, function(i) {
        return G.call(t, i) > -1 !== n;
      }) : r.filter(t, e, n);
    }
    r.filter = function(e, t, n) {
      var i = t[0];
      return n && (e = ":not(" + e + ")"), t.length === 1 && i.nodeType === 1 ? r.find.matchesSelector(i, e) ? [i] : [] : r.find.matches(e, r.grep(t, function(a) {
        return a.nodeType === 1;
      }));
    }, r.fn.extend({
      find: function(e) {
        var t, n, i = this.length, a = this;
        if (typeof e != "string")
          return this.pushStack(r(e).filter(function() {
            for (t = 0; t < i; t++)
              if (r.contains(a[t], this))
                return !0;
          }));
        for (n = this.pushStack([]), t = 0; t < i; t++)
          r.find(e, a[t], n);
        return i > 1 ? r.uniqueSort(n) : n;
      },
      filter: function(e) {
        return this.pushStack(Rt(this, e || [], !1));
      },
      not: function(e) {
        return this.pushStack(Rt(this, e || [], !0));
      },
      is: function(e) {
        return !!Rt(
          this,
          typeof e == "string" && kn.test(e) ? r(e) : e || [],
          !1
        ).length;
      }
    });
    var Tn, Ti = /^(?:\s*(<[\w\W]+>)[^>]*|#([\w-]+))$/, wi = r.fn.init = function(e, t, n) {
      var i, a;
      if (!e)
        return this;
      if (n = n || Tn, typeof e == "string")
        if (e[0] === "<" && e[e.length - 1] === ">" && e.length >= 3 ? i = [null, e, null] : i = Ti.exec(e), i && (i[1] || !t))
          if (i[1]) {
            if (t = t instanceof r ? t[0] : t, r.merge(this, r.parseHTML(
              i[1],
              t && t.nodeType ? t.ownerDocument || t : X,
              !0
            )), Cn.test(i[1]) && r.isPlainObject(t))
              for (i in t)
                U(this[i]) ? this[i](t[i]) : this.attr(i, t[i]);
            return this;
          } else
            return a = X.getElementById(i[2]), a && (this[0] = a, this.length = 1), this;
        else
          return !t || t.jquery ? (t || n).find(e) : this.constructor(t).find(e);
      else {
        if (e.nodeType)
          return this[0] = e, this.length = 1, this;
        if (U(e))
          return n.ready !== void 0 ? n.ready(e) : e(r);
      }
      return r.makeArray(e, this);
    };
    wi.prototype = r.fn, Tn = r(X);
    var Si = /^(?:parents|prev(?:Until|All))/, Di = {
      children: !0,
      contents: !0,
      next: !0,
      prev: !0
    };
    r.fn.extend({
      has: function(e) {
        var t = r(e, this), n = t.length;
        return this.filter(function() {
          for (var i = 0; i < n; i++)
            if (r.contains(this, t[i]))
              return !0;
        });
      },
      closest: function(e, t) {
        var n, i = 0, a = this.length, o = [], l = typeof e != "string" && r(e);
        if (!kn.test(e)) {
          for (; i < a; i++)
            for (n = this[i]; n && n !== t; n = n.parentNode)
              if (n.nodeType < 11 && (l ? l.index(n) > -1 : n.nodeType === 1 && r.find.matchesSelector(n, e))) {
                o.push(n);
                break;
              }
        }
        return this.pushStack(o.length > 1 ? r.uniqueSort(o) : o);
      },
      index: function(e) {
        return e ? typeof e == "string" ? G.call(r(e), this[0]) : G.call(
          this,
          e.jquery ? e[0] : e
        ) : this[0] && this[0].parentNode ? this.first().prevAll().length : -1;
      },
      add: function(e, t) {
        return this.pushStack(
          r.uniqueSort(
            r.merge(this.get(), r(e, t))
          )
        );
      },
      addBack: function(e) {
        return this.add(
          e == null ? this.prevObject : this.prevObject.filter(e)
        );
      }
    });
    function wn(e, t) {
      for (; (e = e[t]) && e.nodeType !== 1; )
        ;
      return e;
    }
    r.each({
      parent: function(e) {
        var t = e.parentNode;
        return t && t.nodeType !== 11 ? t : null;
      },
      parents: function(e) {
        return nt(e, "parentNode");
      },
      parentsUntil: function(e, t, n) {
        return nt(e, "parentNode", n);
      },
      next: function(e) {
        return wn(e, "nextSibling");
      },
      prev: function(e) {
        return wn(e, "previousSibling");
      },
      nextAll: function(e) {
        return nt(e, "nextSibling");
      },
      prevAll: function(e) {
        return nt(e, "previousSibling");
      },
      nextUntil: function(e, t, n) {
        return nt(e, "nextSibling", n);
      },
      prevUntil: function(e, t, n) {
        return nt(e, "previousSibling", n);
      },
      siblings: function(e) {
        return vn((e.parentNode || {}).firstChild, e);
      },
      children: function(e) {
        return vn(e.firstChild);
      },
      contents: function(e) {
        return e.contentDocument != null && $(e.contentDocument) ? e.contentDocument : (Se(e, "template") && (e = e.content || e), r.merge([], e.childNodes));
      }
    }, function(e, t) {
      r.fn[e] = function(n, i) {
        var a = r.map(this, t, n);
        return e.slice(-5) !== "Until" && (i = n), i && typeof i == "string" && (a = r.filter(i, a)), this.length > 1 && (Di[e] || r.uniqueSort(a), Si.test(e) && a.reverse()), this.pushStack(a);
      };
    });
    var Oe = /[^\x20\t\r\n\f]+/g;
    function xi(e) {
      var t = {};
      return r.each(e.match(Oe) || [], function(n, i) {
        t[i] = !0;
      }), t;
    }
    r.Callbacks = function(e) {
      e = typeof e == "string" ? xi(e) : r.extend({}, e);
      var t, n, i, a, o = [], l = [], d = -1, f = function() {
        for (a = a || e.once, i = t = !0; l.length; d = -1)
          for (n = l.shift(); ++d < o.length; )
            o[d].apply(n[0], n[1]) === !1 && e.stopOnFalse && (d = o.length, n = !1);
        e.memory || (n = !1), t = !1, a && (n ? o = [] : o = "");
      }, b = {
        add: function() {
          return o && (n && !t && (d = o.length - 1, l.push(n)), function v(L) {
            r.each(L, function(m, T) {
              U(T) ? (!e.unique || !b.has(T)) && o.push(T) : T && T.length && tt(T) !== "string" && v(T);
            });
          }(arguments), n && !t && f()), this;
        },
        remove: function() {
          return r.each(arguments, function(v, L) {
            for (var m; (m = r.inArray(L, o, m)) > -1; )
              o.splice(m, 1), m <= d && d--;
          }), this;
        },
        has: function(v) {
          return v ? r.inArray(v, o) > -1 : o.length > 0;
        },
        empty: function() {
          return o && (o = []), this;
        },
        disable: function() {
          return a = l = [], o = n = "", this;
        },
        disabled: function() {
          return !o;
        },
        lock: function() {
          return a = l = [], !n && !t && (o = n = ""), this;
        },
        locked: function() {
          return !!a;
        },
        fireWith: function(v, L) {
          return a || (L = L || [], L = [v, L.slice ? L.slice() : L], l.push(L), t || f()), this;
        },
        fire: function() {
          return b.fireWith(this, arguments), this;
        },
        fired: function() {
          return !!i;
        }
      };
      return b;
    };
    function it(e) {
      return e;
    }
    function Dt(e) {
      throw e;
    }
    function Sn(e, t, n, i) {
      var a;
      try {
        e && U(a = e.promise) ? a.call(e).done(t).fail(n) : e && U(a = e.then) ? a.call(e, t, n) : t.apply(void 0, [e].slice(i));
      } catch (o) {
        n.apply(void 0, [o]);
      }
    }
    r.extend({
      Deferred: function(e) {
        var t = [
          [
            "notify",
            "progress",
            r.Callbacks("memory"),
            r.Callbacks("memory"),
            2
          ],
          [
            "resolve",
            "done",
            r.Callbacks("once memory"),
            r.Callbacks("once memory"),
            0,
            "resolved"
          ],
          [
            "reject",
            "fail",
            r.Callbacks("once memory"),
            r.Callbacks("once memory"),
            1,
            "rejected"
          ]
        ], n = "pending", i = {
          state: function() {
            return n;
          },
          always: function() {
            return a.done(arguments).fail(arguments), this;
          },
          catch: function(o) {
            return i.then(null, o);
          },
          pipe: function() {
            var o = arguments;
            return r.Deferred(function(l) {
              r.each(t, function(d, f) {
                var b = U(o[f[4]]) && o[f[4]];
                a[f[1]](function() {
                  var v = b && b.apply(this, arguments);
                  v && U(v.promise) ? v.promise().progress(l.notify).done(l.resolve).fail(l.reject) : l[f[0] + "With"](
                    this,
                    b ? [v] : arguments
                  );
                });
              }), o = null;
            }).promise();
          },
          then: function(o, l, d) {
            var f = 0;
            function b(v, L, m, T) {
              return function() {
                var P = this, W = arguments, F = function() {
                  var oe, ve;
                  if (!(v < f)) {
                    if (oe = m.apply(P, W), oe === L.promise())
                      throw new TypeError("Thenable self-resolution");
                    ve = oe && (typeof oe == "object" || typeof oe == "function") && oe.then, U(ve) ? T ? ve.call(
                      oe,
                      b(f, L, it, T),
                      b(f, L, Dt, T)
                    ) : (f++, ve.call(
                      oe,
                      b(f, L, it, T),
                      b(f, L, Dt, T),
                      b(
                        f,
                        L,
                        it,
                        L.notifyWith
                      )
                    )) : (m !== it && (P = void 0, W = [oe]), (T || L.resolveWith)(P, W));
                  }
                }, le = T ? F : function() {
                  try {
                    F();
                  } catch (oe) {
                    r.Deferred.exceptionHook && r.Deferred.exceptionHook(
                      oe,
                      le.stackTrace
                    ), v + 1 >= f && (m !== Dt && (P = void 0, W = [oe]), L.rejectWith(P, W));
                  }
                };
                v ? le() : (r.Deferred.getStackHook && (le.stackTrace = r.Deferred.getStackHook()), p.setTimeout(le));
              };
            }
            return r.Deferred(function(v) {
              t[0][3].add(
                b(
                  0,
                  v,
                  U(d) ? d : it,
                  v.notifyWith
                )
              ), t[1][3].add(
                b(
                  0,
                  v,
                  U(o) ? o : it
                )
              ), t[2][3].add(
                b(
                  0,
                  v,
                  U(l) ? l : Dt
                )
              );
            }).promise();
          },
          promise: function(o) {
            return o != null ? r.extend(o, i) : i;
          }
        }, a = {};
        return r.each(t, function(o, l) {
          var d = l[2], f = l[5];
          i[l[1]] = d.add, f && d.add(
            function() {
              n = f;
            },
            t[3 - o][2].disable,
            t[3 - o][3].disable,
            t[0][2].lock,
            t[0][3].lock
          ), d.add(l[3].fire), a[l[0]] = function() {
            return a[l[0] + "With"](this === a ? void 0 : this, arguments), this;
          }, a[l[0] + "With"] = d.fireWith;
        }), i.promise(a), e && e.call(a, a), a;
      },
      when: function(e) {
        var t = arguments.length, n = t, i = Array(n), a = N.call(arguments), o = r.Deferred(), l = function(d) {
          return function(f) {
            i[d] = this, a[d] = arguments.length > 1 ? N.call(arguments) : f, --t || o.resolveWith(i, a);
          };
        };
        if (t <= 1 && (Sn(
          e,
          o.done(l(n)).resolve,
          o.reject,
          !t
        ), o.state() === "pending" || U(a[n] && a[n].then)))
          return o.then();
        for (; n--; )
          Sn(a[n], l(n), o.reject);
        return o.promise();
      }
    });
    var _i = /^(Eval|Internal|Range|Reference|Syntax|Type|URI)Error$/;
    r.Deferred.exceptionHook = function(e, t) {
      p.console && p.console.warn && e && _i.test(e.name) && p.console.warn("jQuery.Deferred exception: " + e.message, e.stack, t);
    }, r.readyException = function(e) {
      p.setTimeout(function() {
        throw e;
      });
    };
    var zt = r.Deferred();
    r.fn.ready = function(e) {
      return zt.then(e).catch(function(t) {
        r.readyException(t);
      }), this;
    }, r.extend({
      isReady: !1,
      readyWait: 1,
      ready: function(e) {
        (e === !0 ? --r.readyWait : r.isReady) || (r.isReady = !0, !(e !== !0 && --r.readyWait > 0) && zt.resolveWith(X, [r]));
      }
    }), r.ready.then = zt.then;
    function xt() {
      X.removeEventListener("DOMContentLoaded", xt), p.removeEventListener("load", xt), r.ready();
    }
    X.readyState === "complete" || X.readyState !== "loading" && !X.documentElement.doScroll ? p.setTimeout(r.ready) : (X.addEventListener("DOMContentLoaded", xt), p.addEventListener("load", xt));
    var Pe = function(e, t, n, i, a, o, l) {
      var d = 0, f = e.length, b = n == null;
      if (tt(n) === "object") {
        a = !0;
        for (d in n)
          Pe(e, t, d, n[d], !0, o, l);
      } else if (i !== void 0 && (a = !0, U(i) || (l = !0), b && (l ? (t.call(e, i), t = null) : (b = t, t = function(v, L, m) {
        return b.call(r(v), m);
      })), t))
        for (; d < f; d++)
          t(
            e[d],
            n,
            l ? i : i.call(e[d], d, t(e[d], n))
          );
      return a ? e : b ? t.call(e) : f ? t(e[0], n) : o;
    }, Li = /^-ms-/, Ai = /-([a-z])/g;
    function Ni(e, t) {
      return t.toUpperCase();
    }
    function He(e) {
      return e.replace(Li, "ms-").replace(Ai, Ni);
    }
    var ct = function(e) {
      return e.nodeType === 1 || e.nodeType === 9 || !+e.nodeType;
    };
    function dt() {
      this.expando = r.expando + dt.uid++;
    }
    dt.uid = 1, dt.prototype = {
      cache: function(e) {
        var t = e[this.expando];
        return t || (t = {}, ct(e) && (e.nodeType ? e[this.expando] = t : Object.defineProperty(e, this.expando, {
          value: t,
          configurable: !0
        }))), t;
      },
      set: function(e, t, n) {
        var i, a = this.cache(e);
        if (typeof t == "string")
          a[He(t)] = n;
        else
          for (i in t)
            a[He(i)] = t[i];
        return a;
      },
      get: function(e, t) {
        return t === void 0 ? this.cache(e) : e[this.expando] && e[this.expando][He(t)];
      },
      access: function(e, t, n) {
        return t === void 0 || t && typeof t == "string" && n === void 0 ? this.get(e, t) : (this.set(e, t, n), n !== void 0 ? n : t);
      },
      remove: function(e, t) {
        var n, i = e[this.expando];
        if (i !== void 0) {
          if (t !== void 0)
            for (Array.isArray(t) ? t = t.map(He) : (t = He(t), t = t in i ? [t] : t.match(Oe) || []), n = t.length; n--; )
              delete i[t[n]];
          (t === void 0 || r.isEmptyObject(i)) && (e.nodeType ? e[this.expando] = void 0 : delete e[this.expando]);
        }
      },
      hasData: function(e) {
        var t = e[this.expando];
        return t !== void 0 && !r.isEmptyObject(t);
      }
    };
    var B = new dt(), pe = new dt(), qi = /^(?:\{[\w\W]*\}|\[[\w\W]*\])$/, Oi = /[A-Z]/g;
    function Hi(e) {
      return e === "true" ? !0 : e === "false" ? !1 : e === "null" ? null : e === +e + "" ? +e : qi.test(e) ? JSON.parse(e) : e;
    }
    function Dn(e, t, n) {
      var i;
      if (n === void 0 && e.nodeType === 1)
        if (i = "data-" + t.replace(Oi, "-$&").toLowerCase(), n = e.getAttribute(i), typeof n == "string") {
          try {
            n = Hi(n);
          } catch {
          }
          pe.set(e, t, n);
        } else
          n = void 0;
      return n;
    }
    r.extend({
      hasData: function(e) {
        return pe.hasData(e) || B.hasData(e);
      },
      data: function(e, t, n) {
        return pe.access(e, t, n);
      },
      removeData: function(e, t) {
        pe.remove(e, t);
      },
      _data: function(e, t, n) {
        return B.access(e, t, n);
      },
      _removeData: function(e, t) {
        B.remove(e, t);
      }
    }), r.fn.extend({
      data: function(e, t) {
        var n, i, a, o = this[0], l = o && o.attributes;
        if (e === void 0) {
          if (this.length && (a = pe.get(o), o.nodeType === 1 && !B.get(o, "hasDataAttrs"))) {
            for (n = l.length; n--; )
              l[n] && (i = l[n].name, i.indexOf("data-") === 0 && (i = He(i.slice(5)), Dn(o, i, a[i])));
            B.set(o, "hasDataAttrs", !0);
          }
          return a;
        }
        return typeof e == "object" ? this.each(function() {
          pe.set(this, e);
        }) : Pe(this, function(d) {
          var f;
          if (o && d === void 0)
            return f = pe.get(o, e), f !== void 0 || (f = Dn(o, e), f !== void 0) ? f : void 0;
          this.each(function() {
            pe.set(this, e, d);
          });
        }, null, t, arguments.length > 1, null, !0);
      },
      removeData: function(e) {
        return this.each(function() {
          pe.remove(this, e);
        });
      }
    }), r.extend({
      queue: function(e, t, n) {
        var i;
        if (e)
          return t = (t || "fx") + "queue", i = B.get(e, t), n && (!i || Array.isArray(n) ? i = B.access(e, t, r.makeArray(n)) : i.push(n)), i || [];
      },
      dequeue: function(e, t) {
        t = t || "fx";
        var n = r.queue(e, t), i = n.length, a = n.shift(), o = r._queueHooks(e, t), l = function() {
          r.dequeue(e, t);
        };
        a === "inprogress" && (a = n.shift(), i--), a && (t === "fx" && n.unshift("inprogress"), delete o.stop, a.call(e, l, o)), !i && o && o.empty.fire();
      },
      _queueHooks: function(e, t) {
        var n = t + "queueHooks";
        return B.get(e, n) || B.access(e, n, {
          empty: r.Callbacks("once memory").add(function() {
            B.remove(e, [t + "queue", n]);
          })
        });
      }
    }), r.fn.extend({
      queue: function(e, t) {
        var n = 2;
        return typeof e != "string" && (t = e, e = "fx", n--), arguments.length < n ? r.queue(this[0], e) : t === void 0 ? this : this.each(function() {
          var i = r.queue(this, e, t);
          r._queueHooks(this, e), e === "fx" && i[0] !== "inprogress" && r.dequeue(this, e);
        });
      },
      dequeue: function(e) {
        return this.each(function() {
          r.dequeue(this, e);
        });
      },
      clearQueue: function(e) {
        return this.queue(e || "fx", []);
      },
      promise: function(e, t) {
        var n, i = 1, a = r.Deferred(), o = this, l = this.length, d = function() {
          --i || a.resolveWith(o, [o]);
        };
        for (typeof e != "string" && (t = e, e = void 0), e = e || "fx"; l--; )
          n = B.get(o[l], e + "queueHooks"), n && n.empty && (i++, n.empty.add(d));
        return d(), a.promise(t);
      }
    });
    var xn = /[+-]?(?:\d*\.|)\d+(?:[eE][+-]?\d+|)/.source, ht = new RegExp("^(?:([+-])=|)(" + xn + ")([a-z%]*)$", "i"), Fe = ["Top", "Right", "Bottom", "Left"], We = X.documentElement, rt = function(e) {
      return r.contains(e.ownerDocument, e);
    }, Ei = { composed: !0 };
    We.getRootNode && (rt = function(e) {
      return r.contains(e.ownerDocument, e) || e.getRootNode(Ei) === e.ownerDocument;
    });
    var _t = function(e, t) {
      return e = t || e, e.style.display === "none" || e.style.display === "" && rt(e) && r.css(e, "display") === "none";
    };
    function _n(e, t, n, i) {
      var a, o, l = 20, d = i ? function() {
        return i.cur();
      } : function() {
        return r.css(e, t, "");
      }, f = d(), b = n && n[3] || (r.cssNumber[t] ? "" : "px"), v = e.nodeType && (r.cssNumber[t] || b !== "px" && +f) && ht.exec(r.css(e, t));
      if (v && v[3] !== b) {
        for (f = f / 2, b = b || v[3], v = +f || 1; l--; )
          r.style(e, t, v + b), (1 - o) * (1 - (o = d() / f || 0.5)) <= 0 && (l = 0), v = v / o;
        v = v * 2, r.style(e, t, v + b), n = n || [];
      }
      return n && (v = +v || +f || 0, a = n[1] ? v + (n[1] + 1) * n[2] : +n[2], i && (i.unit = b, i.start = v, i.end = a)), a;
    }
    var Ln = {};
    function Pi(e) {
      var t, n = e.ownerDocument, i = e.nodeName, a = Ln[i];
      return a || (t = n.body.appendChild(n.createElement(i)), a = r.css(t, "display"), t.parentNode.removeChild(t), a === "none" && (a = "block"), Ln[i] = a, a);
    }
    function st(e, t) {
      for (var n, i, a = [], o = 0, l = e.length; o < l; o++)
        i = e[o], i.style && (n = i.style.display, t ? (n === "none" && (a[o] = B.get(i, "display") || null, a[o] || (i.style.display = "")), i.style.display === "" && _t(i) && (a[o] = Pi(i))) : n !== "none" && (a[o] = "none", B.set(i, "display", n)));
      for (o = 0; o < l; o++)
        a[o] != null && (e[o].style.display = a[o]);
      return e;
    }
    r.fn.extend({
      show: function() {
        return st(this, !0);
      },
      hide: function() {
        return st(this);
      },
      toggle: function(e) {
        return typeof e == "boolean" ? e ? this.show() : this.hide() : this.each(function() {
          _t(this) ? r(this).show() : r(this).hide();
        });
      }
    });
    var pt = /^(?:checkbox|radio)$/i, An = /<([a-z][^\/\0>\x20\t\r\n\f]*)/i, Nn = /^$|^module$|\/(?:java|ecma)script/i;
    (function() {
      var e = X.createDocumentFragment(), t = e.appendChild(X.createElement("div")), n = X.createElement("input");
      n.setAttribute("type", "radio"), n.setAttribute("checked", "checked"), n.setAttribute("name", "t"), t.appendChild(n), J.checkClone = t.cloneNode(!0).cloneNode(!0).lastChild.checked, t.innerHTML = "<textarea>x</textarea>", J.noCloneChecked = !!t.cloneNode(!0).lastChild.defaultValue, t.innerHTML = "<option></option>", J.option = !!t.lastChild;
    })();
    var De = {
      thead: [1, "<table>", "</table>"],
      col: [2, "<table><colgroup>", "</colgroup></table>"],
      tr: [2, "<table><tbody>", "</tbody></table>"],
      td: [3, "<table><tbody><tr>", "</tr></tbody></table>"],
      _default: [0, "", ""]
    };
    De.tbody = De.tfoot = De.colgroup = De.caption = De.thead, De.th = De.td, J.option || (De.optgroup = De.option = [1, "<select multiple='multiple'>", "</select>"]);
    function ge(e, t) {
      var n;
      return typeof e.getElementsByTagName < "u" ? n = e.getElementsByTagName(t || "*") : typeof e.querySelectorAll < "u" ? n = e.querySelectorAll(t || "*") : n = [], t === void 0 || t && Se(e, t) ? r.merge([e], n) : n;
    }
    function Vt(e, t) {
      for (var n = 0, i = e.length; n < i; n++)
        B.set(
          e[n],
          "globalEval",
          !t || B.get(t[n], "globalEval")
        );
    }
    var Fi = /<|&#?\w+;/;
    function qn(e, t, n, i, a) {
      for (var o, l, d, f, b, v, L = t.createDocumentFragment(), m = [], T = 0, P = e.length; T < P; T++)
        if (o = e[T], o || o === 0)
          if (tt(o) === "object")
            r.merge(m, o.nodeType ? [o] : o);
          else if (!Fi.test(o))
            m.push(t.createTextNode(o));
          else {
            for (l = l || L.appendChild(t.createElement("div")), d = (An.exec(o) || ["", ""])[1].toLowerCase(), f = De[d] || De._default, l.innerHTML = f[1] + r.htmlPrefilter(o) + f[2], v = f[0]; v--; )
              l = l.lastChild;
            r.merge(m, l.childNodes), l = L.firstChild, l.textContent = "";
          }
      for (L.textContent = "", T = 0; o = m[T++]; ) {
        if (i && r.inArray(o, i) > -1) {
          a && a.push(o);
          continue;
        }
        if (b = rt(o), l = ge(L.appendChild(o), "script"), b && Vt(l), n)
          for (v = 0; o = l[v++]; )
            Nn.test(o.type || "") && n.push(o);
      }
      return L;
    }
    var On = /^([^.]*)(?:\.(.+)|)/;
    function at() {
      return !0;
    }
    function ot() {
      return !1;
    }
    function Mi(e, t) {
      return e === $i() == (t === "focus");
    }
    function $i() {
      try {
        return X.activeElement;
      } catch {
      }
    }
    function Wt(e, t, n, i, a, o) {
      var l, d;
      if (typeof t == "object") {
        typeof n != "string" && (i = i || n, n = void 0);
        for (d in t)
          Wt(e, d, n, i, t[d], o);
        return e;
      }
      if (i == null && a == null ? (a = n, i = n = void 0) : a == null && (typeof n == "string" ? (a = i, i = void 0) : (a = i, i = n, n = void 0)), a === !1)
        a = ot;
      else if (!a)
        return e;
      return o === 1 && (l = a, a = function(f) {
        return r().off(f), l.apply(this, arguments);
      }, a.guid = l.guid || (l.guid = r.guid++)), e.each(function() {
        r.event.add(this, t, a, i, n);
      });
    }
    r.event = {
      global: {},
      add: function(e, t, n, i, a) {
        var o, l, d, f, b, v, L, m, T, P, W, F = B.get(e);
        if (!!ct(e))
          for (n.handler && (o = n, n = o.handler, a = o.selector), a && r.find.matchesSelector(We, a), n.guid || (n.guid = r.guid++), (f = F.events) || (f = F.events = /* @__PURE__ */ Object.create(null)), (l = F.handle) || (l = F.handle = function(le) {
            return typeof r < "u" && r.event.triggered !== le.type ? r.event.dispatch.apply(e, arguments) : void 0;
          }), t = (t || "").match(Oe) || [""], b = t.length; b--; )
            d = On.exec(t[b]) || [], T = W = d[1], P = (d[2] || "").split(".").sort(), T && (L = r.event.special[T] || {}, T = (a ? L.delegateType : L.bindType) || T, L = r.event.special[T] || {}, v = r.extend({
              type: T,
              origType: W,
              data: i,
              handler: n,
              guid: n.guid,
              selector: a,
              needsContext: a && r.expr.match.needsContext.test(a),
              namespace: P.join(".")
            }, o), (m = f[T]) || (m = f[T] = [], m.delegateCount = 0, (!L.setup || L.setup.call(e, i, P, l) === !1) && e.addEventListener && e.addEventListener(T, l)), L.add && (L.add.call(e, v), v.handler.guid || (v.handler.guid = n.guid)), a ? m.splice(m.delegateCount++, 0, v) : m.push(v), r.event.global[T] = !0);
      },
      remove: function(e, t, n, i, a) {
        var o, l, d, f, b, v, L, m, T, P, W, F = B.hasData(e) && B.get(e);
        if (!(!F || !(f = F.events))) {
          for (t = (t || "").match(Oe) || [""], b = t.length; b--; ) {
            if (d = On.exec(t[b]) || [], T = W = d[1], P = (d[2] || "").split(".").sort(), !T) {
              for (T in f)
                r.event.remove(e, T + t[b], n, i, !0);
              continue;
            }
            for (L = r.event.special[T] || {}, T = (i ? L.delegateType : L.bindType) || T, m = f[T] || [], d = d[2] && new RegExp("(^|\\.)" + P.join("\\.(?:.*\\.|)") + "(\\.|$)"), l = o = m.length; o--; )
              v = m[o], (a || W === v.origType) && (!n || n.guid === v.guid) && (!d || d.test(v.namespace)) && (!i || i === v.selector || i === "**" && v.selector) && (m.splice(o, 1), v.selector && m.delegateCount--, L.remove && L.remove.call(e, v));
            l && !m.length && ((!L.teardown || L.teardown.call(e, P, F.handle) === !1) && r.removeEvent(e, T, F.handle), delete f[T]);
          }
          r.isEmptyObject(f) && B.remove(e, "handle events");
        }
      },
      dispatch: function(e) {
        var t, n, i, a, o, l, d = new Array(arguments.length), f = r.event.fix(e), b = (B.get(this, "events") || /* @__PURE__ */ Object.create(null))[f.type] || [], v = r.event.special[f.type] || {};
        for (d[0] = f, t = 1; t < arguments.length; t++)
          d[t] = arguments[t];
        if (f.delegateTarget = this, !(v.preDispatch && v.preDispatch.call(this, f) === !1)) {
          for (l = r.event.handlers.call(this, f, b), t = 0; (a = l[t++]) && !f.isPropagationStopped(); )
            for (f.currentTarget = a.elem, n = 0; (o = a.handlers[n++]) && !f.isImmediatePropagationStopped(); )
              (!f.rnamespace || o.namespace === !1 || f.rnamespace.test(o.namespace)) && (f.handleObj = o, f.data = o.data, i = ((r.event.special[o.origType] || {}).handle || o.handler).apply(a.elem, d), i !== void 0 && (f.result = i) === !1 && (f.preventDefault(), f.stopPropagation()));
          return v.postDispatch && v.postDispatch.call(this, f), f.result;
        }
      },
      handlers: function(e, t) {
        var n, i, a, o, l, d = [], f = t.delegateCount, b = e.target;
        if (f && b.nodeType && !(e.type === "click" && e.button >= 1)) {
          for (; b !== this; b = b.parentNode || this)
            if (b.nodeType === 1 && !(e.type === "click" && b.disabled === !0)) {
              for (o = [], l = {}, n = 0; n < f; n++)
                i = t[n], a = i.selector + " ", l[a] === void 0 && (l[a] = i.needsContext ? r(a, this).index(b) > -1 : r.find(a, this, null, [b]).length), l[a] && o.push(i);
              o.length && d.push({ elem: b, handlers: o });
            }
        }
        return b = this, f < t.length && d.push({ elem: b, handlers: t.slice(f) }), d;
      },
      addProp: function(e, t) {
        Object.defineProperty(r.Event.prototype, e, {
          enumerable: !0,
          configurable: !0,
          get: U(t) ? function() {
            if (this.originalEvent)
              return t(this.originalEvent);
          } : function() {
            if (this.originalEvent)
              return this.originalEvent[e];
          },
          set: function(n) {
            Object.defineProperty(this, e, {
              enumerable: !0,
              configurable: !0,
              writable: !0,
              value: n
            });
          }
        });
      },
      fix: function(e) {
        return e[r.expando] ? e : new r.Event(e);
      },
      special: {
        load: {
          noBubble: !0
        },
        click: {
          setup: function(e) {
            var t = this || e;
            return pt.test(t.type) && t.click && Se(t, "input") && Lt(t, "click", at), !1;
          },
          trigger: function(e) {
            var t = this || e;
            return pt.test(t.type) && t.click && Se(t, "input") && Lt(t, "click"), !0;
          },
          _default: function(e) {
            var t = e.target;
            return pt.test(t.type) && t.click && Se(t, "input") && B.get(t, "click") || Se(t, "a");
          }
        },
        beforeunload: {
          postDispatch: function(e) {
            e.result !== void 0 && e.originalEvent && (e.originalEvent.returnValue = e.result);
          }
        }
      }
    };
    function Lt(e, t, n) {
      if (!n) {
        B.get(e, t) === void 0 && r.event.add(e, t, at);
        return;
      }
      B.set(e, t, !1), r.event.add(e, t, {
        namespace: !1,
        handler: function(i) {
          var a, o, l = B.get(this, t);
          if (i.isTrigger & 1 && this[t]) {
            if (l.length)
              (r.event.special[t] || {}).delegateType && i.stopPropagation();
            else if (l = N.call(arguments), B.set(this, t, l), a = n(this, t), this[t](), o = B.get(this, t), l !== o || a ? B.set(this, t, !1) : o = {}, l !== o)
              return i.stopImmediatePropagation(), i.preventDefault(), o && o.value;
          } else
            l.length && (B.set(this, t, {
              value: r.event.trigger(
                r.extend(l[0], r.Event.prototype),
                l.slice(1),
                this
              )
            }), i.stopImmediatePropagation());
        }
      });
    }
    r.removeEvent = function(e, t, n) {
      e.removeEventListener && e.removeEventListener(t, n);
    }, r.Event = function(e, t) {
      if (!(this instanceof r.Event))
        return new r.Event(e, t);
      e && e.type ? (this.originalEvent = e, this.type = e.type, this.isDefaultPrevented = e.defaultPrevented || e.defaultPrevented === void 0 && e.returnValue === !1 ? at : ot, this.target = e.target && e.target.nodeType === 3 ? e.target.parentNode : e.target, this.currentTarget = e.currentTarget, this.relatedTarget = e.relatedTarget) : this.type = e, t && r.extend(this, t), this.timeStamp = e && e.timeStamp || Date.now(), this[r.expando] = !0;
    }, r.Event.prototype = {
      constructor: r.Event,
      isDefaultPrevented: ot,
      isPropagationStopped: ot,
      isImmediatePropagationStopped: ot,
      isSimulated: !1,
      preventDefault: function() {
        var e = this.originalEvent;
        this.isDefaultPrevented = at, e && !this.isSimulated && e.preventDefault();
      },
      stopPropagation: function() {
        var e = this.originalEvent;
        this.isPropagationStopped = at, e && !this.isSimulated && e.stopPropagation();
      },
      stopImmediatePropagation: function() {
        var e = this.originalEvent;
        this.isImmediatePropagationStopped = at, e && !this.isSimulated && e.stopImmediatePropagation(), this.stopPropagation();
      }
    }, r.each({
      altKey: !0,
      bubbles: !0,
      cancelable: !0,
      changedTouches: !0,
      ctrlKey: !0,
      detail: !0,
      eventPhase: !0,
      metaKey: !0,
      pageX: !0,
      pageY: !0,
      shiftKey: !0,
      view: !0,
      char: !0,
      code: !0,
      charCode: !0,
      key: !0,
      keyCode: !0,
      button: !0,
      buttons: !0,
      clientX: !0,
      clientY: !0,
      offsetX: !0,
      offsetY: !0,
      pointerId: !0,
      pointerType: !0,
      screenX: !0,
      screenY: !0,
      targetTouches: !0,
      toElement: !0,
      touches: !0,
      which: !0
    }, r.event.addProp), r.each({ focus: "focusin", blur: "focusout" }, function(e, t) {
      r.event.special[e] = {
        setup: function() {
          return Lt(this, e, Mi), !1;
        },
        trigger: function() {
          return Lt(this, e), !0;
        },
        _default: function(n) {
          return B.get(n.target, e);
        },
        delegateType: t
      };
    }), r.each({
      mouseenter: "mouseover",
      mouseleave: "mouseout",
      pointerenter: "pointerover",
      pointerleave: "pointerout"
    }, function(e, t) {
      r.event.special[e] = {
        delegateType: t,
        bindType: t,
        handle: function(n) {
          var i, a = this, o = n.relatedTarget, l = n.handleObj;
          return (!o || o !== a && !r.contains(a, o)) && (n.type = l.origType, i = l.handler.apply(this, arguments), n.type = t), i;
        }
      };
    }), r.fn.extend({
      on: function(e, t, n, i) {
        return Wt(this, e, t, n, i);
      },
      one: function(e, t, n, i) {
        return Wt(this, e, t, n, i, 1);
      },
      off: function(e, t, n) {
        var i, a;
        if (e && e.preventDefault && e.handleObj)
          return i = e.handleObj, r(e.delegateTarget).off(
            i.namespace ? i.origType + "." + i.namespace : i.origType,
            i.selector,
            i.handler
          ), this;
        if (typeof e == "object") {
          for (a in e)
            this.off(a, t, e[a]);
          return this;
        }
        return (t === !1 || typeof t == "function") && (n = t, t = void 0), n === !1 && (n = ot), this.each(function() {
          r.event.remove(this, e, n, t);
        });
      }
    });
    var ji = /<script|<style|<link/i, Bi = /checked\s*(?:[^=]|=\s*.checked.)/i, Ii = /^\s*<!\[CDATA\[|\]\]>\s*$/g;
    function Hn(e, t) {
      return Se(e, "table") && Se(t.nodeType !== 11 ? t : t.firstChild, "tr") && r(e).children("tbody")[0] || e;
    }
    function Ri(e) {
      return e.type = (e.getAttribute("type") !== null) + "/" + e.type, e;
    }
    function zi(e) {
      return (e.type || "").slice(0, 5) === "true/" ? e.type = e.type.slice(5) : e.removeAttribute("type"), e;
    }
    function En(e, t) {
      var n, i, a, o, l, d, f;
      if (t.nodeType === 1) {
        if (B.hasData(e) && (o = B.get(e), f = o.events, f)) {
          B.remove(t, "handle events");
          for (a in f)
            for (n = 0, i = f[a].length; n < i; n++)
              r.event.add(t, a, f[a][n]);
        }
        pe.hasData(e) && (l = pe.access(e), d = r.extend({}, l), pe.set(t, d));
      }
    }
    function Vi(e, t) {
      var n = t.nodeName.toLowerCase();
      n === "input" && pt.test(e.type) ? t.checked = e.checked : (n === "input" || n === "textarea") && (t.defaultValue = e.defaultValue);
    }
    function lt(e, t, n, i) {
      t = x(t);
      var a, o, l, d, f, b, v = 0, L = e.length, m = L - 1, T = t[0], P = U(T);
      if (P || L > 1 && typeof T == "string" && !J.checkClone && Bi.test(T))
        return e.each(function(W) {
          var F = e.eq(W);
          P && (t[0] = T.call(this, W, F.html())), lt(F, t, n, i);
        });
      if (L && (a = qn(t, e[0].ownerDocument, !1, e, i), o = a.firstChild, a.childNodes.length === 1 && (a = o), o || i)) {
        for (l = r.map(ge(a, "script"), Ri), d = l.length; v < L; v++)
          f = a, v !== m && (f = r.clone(f, !0, !0), d && r.merge(l, ge(f, "script"))), n.call(e[v], f, v);
        if (d)
          for (b = l[l.length - 1].ownerDocument, r.map(l, zi), v = 0; v < d; v++)
            f = l[v], Nn.test(f.type || "") && !B.access(f, "globalEval") && r.contains(b, f) && (f.src && (f.type || "").toLowerCase() !== "module" ? r._evalUrl && !f.noModule && r._evalUrl(f.src, {
              nonce: f.nonce || f.getAttribute("nonce")
            }, b) : bn(f.textContent.replace(Ii, ""), f, b));
      }
      return e;
    }
    function Pn(e, t, n) {
      for (var i, a = t ? r.filter(t, e) : e, o = 0; (i = a[o]) != null; o++)
        !n && i.nodeType === 1 && r.cleanData(ge(i)), i.parentNode && (n && rt(i) && Vt(ge(i, "script")), i.parentNode.removeChild(i));
      return e;
    }
    r.extend({
      htmlPrefilter: function(e) {
        return e;
      },
      clone: function(e, t, n) {
        var i, a, o, l, d = e.cloneNode(!0), f = rt(e);
        if (!J.noCloneChecked && (e.nodeType === 1 || e.nodeType === 11) && !r.isXMLDoc(e))
          for (l = ge(d), o = ge(e), i = 0, a = o.length; i < a; i++)
            Vi(o[i], l[i]);
        if (t)
          if (n)
            for (o = o || ge(e), l = l || ge(d), i = 0, a = o.length; i < a; i++)
              En(o[i], l[i]);
          else
            En(e, d);
        return l = ge(d, "script"), l.length > 0 && Vt(l, !f && ge(e, "script")), d;
      },
      cleanData: function(e) {
        for (var t, n, i, a = r.event.special, o = 0; (n = e[o]) !== void 0; o++)
          if (ct(n)) {
            if (t = n[B.expando]) {
              if (t.events)
                for (i in t.events)
                  a[i] ? r.event.remove(n, i) : r.removeEvent(n, i, t.handle);
              n[B.expando] = void 0;
            }
            n[pe.expando] && (n[pe.expando] = void 0);
          }
      }
    }), r.fn.extend({
      detach: function(e) {
        return Pn(this, e, !0);
      },
      remove: function(e) {
        return Pn(this, e);
      },
      text: function(e) {
        return Pe(this, function(t) {
          return t === void 0 ? r.text(this) : this.empty().each(function() {
            (this.nodeType === 1 || this.nodeType === 11 || this.nodeType === 9) && (this.textContent = t);
          });
        }, null, e, arguments.length);
      },
      append: function() {
        return lt(this, arguments, function(e) {
          if (this.nodeType === 1 || this.nodeType === 11 || this.nodeType === 9) {
            var t = Hn(this, e);
            t.appendChild(e);
          }
        });
      },
      prepend: function() {
        return lt(this, arguments, function(e) {
          if (this.nodeType === 1 || this.nodeType === 11 || this.nodeType === 9) {
            var t = Hn(this, e);
            t.insertBefore(e, t.firstChild);
          }
        });
      },
      before: function() {
        return lt(this, arguments, function(e) {
          this.parentNode && this.parentNode.insertBefore(e, this);
        });
      },
      after: function() {
        return lt(this, arguments, function(e) {
          this.parentNode && this.parentNode.insertBefore(e, this.nextSibling);
        });
      },
      empty: function() {
        for (var e, t = 0; (e = this[t]) != null; t++)
          e.nodeType === 1 && (r.cleanData(ge(e, !1)), e.textContent = "");
        return this;
      },
      clone: function(e, t) {
        return e = e == null ? !1 : e, t = t == null ? e : t, this.map(function() {
          return r.clone(this, e, t);
        });
      },
      html: function(e) {
        return Pe(this, function(t) {
          var n = this[0] || {}, i = 0, a = this.length;
          if (t === void 0 && n.nodeType === 1)
            return n.innerHTML;
          if (typeof t == "string" && !ji.test(t) && !De[(An.exec(t) || ["", ""])[1].toLowerCase()]) {
            t = r.htmlPrefilter(t);
            try {
              for (; i < a; i++)
                n = this[i] || {}, n.nodeType === 1 && (r.cleanData(ge(n, !1)), n.innerHTML = t);
              n = 0;
            } catch {
            }
          }
          n && this.empty().append(t);
        }, null, e, arguments.length);
      },
      replaceWith: function() {
        var e = [];
        return lt(this, arguments, function(t) {
          var n = this.parentNode;
          r.inArray(this, e) < 0 && (r.cleanData(ge(this)), n && n.replaceChild(t, this));
        }, e);
      }
    }), r.each({
      appendTo: "append",
      prependTo: "prepend",
      insertBefore: "before",
      insertAfter: "after",
      replaceAll: "replaceWith"
    }, function(e, t) {
      r.fn[e] = function(n) {
        for (var i, a = [], o = r(n), l = o.length - 1, d = 0; d <= l; d++)
          i = d === l ? this : this.clone(!0), r(o[d])[t](i), _.apply(a, i.get());
        return this.pushStack(a);
      };
    });
    var Ut = new RegExp("^(" + xn + ")(?!px)[a-z%]+$", "i"), Gt = /^--/, At = function(e) {
      var t = e.ownerDocument.defaultView;
      return (!t || !t.opener) && (t = p), t.getComputedStyle(e);
    }, Fn = function(e, t, n) {
      var i, a, o = {};
      for (a in t)
        o[a] = e.style[a], e.style[a] = t[a];
      i = n.call(e);
      for (a in t)
        e.style[a] = o[a];
      return i;
    }, Wi = new RegExp(Fe.join("|"), "i"), Mn = "[\\x20\\t\\r\\n\\f]", Ui = new RegExp(
      "^" + Mn + "+|((?:^|[^\\\\])(?:\\\\.)*)" + Mn + "+$",
      "g"
    );
    (function() {
      function e() {
        if (!!b) {
          f.style.cssText = "position:absolute;left:-11111px;width:60px;margin-top:1px;padding:0;border:0", b.style.cssText = "position:relative;display:block;box-sizing:border-box;overflow:scroll;margin:auto;border:1px;padding:1px;width:60%;top:1%", We.appendChild(f).appendChild(b);
          var v = p.getComputedStyle(b);
          n = v.top !== "1%", d = t(v.marginLeft) === 12, b.style.right = "60%", o = t(v.right) === 36, i = t(v.width) === 36, b.style.position = "absolute", a = t(b.offsetWidth / 3) === 12, We.removeChild(f), b = null;
        }
      }
      function t(v) {
        return Math.round(parseFloat(v));
      }
      var n, i, a, o, l, d, f = X.createElement("div"), b = X.createElement("div");
      !b.style || (b.style.backgroundClip = "content-box", b.cloneNode(!0).style.backgroundClip = "", J.clearCloneStyle = b.style.backgroundClip === "content-box", r.extend(J, {
        boxSizingReliable: function() {
          return e(), i;
        },
        pixelBoxStyles: function() {
          return e(), o;
        },
        pixelPosition: function() {
          return e(), n;
        },
        reliableMarginLeft: function() {
          return e(), d;
        },
        scrollboxSize: function() {
          return e(), a;
        },
        reliableTrDimensions: function() {
          var v, L, m, T;
          return l == null && (v = X.createElement("table"), L = X.createElement("tr"), m = X.createElement("div"), v.style.cssText = "position:absolute;left:-11111px;border-collapse:separate", L.style.cssText = "border:1px solid", L.style.height = "1px", m.style.height = "9px", m.style.display = "block", We.appendChild(v).appendChild(L).appendChild(m), T = p.getComputedStyle(L), l = parseInt(T.height, 10) + parseInt(T.borderTopWidth, 10) + parseInt(T.borderBottomWidth, 10) === L.offsetHeight, We.removeChild(v)), l;
        }
      }));
    })();
    function gt(e, t, n) {
      var i, a, o, l, d = Gt.test(t), f = e.style;
      return n = n || At(e), n && (l = n.getPropertyValue(t) || n[t], d && (l = l.replace(Ui, "$1")), l === "" && !rt(e) && (l = r.style(e, t)), !J.pixelBoxStyles() && Ut.test(l) && Wi.test(t) && (i = f.width, a = f.minWidth, o = f.maxWidth, f.minWidth = f.maxWidth = f.width = l, l = n.width, f.width = i, f.minWidth = a, f.maxWidth = o)), l !== void 0 ? l + "" : l;
    }
    function $n(e, t) {
      return {
        get: function() {
          if (e()) {
            delete this.get;
            return;
          }
          return (this.get = t).apply(this, arguments);
        }
      };
    }
    var jn = ["Webkit", "Moz", "ms"], Bn = X.createElement("div").style, In = {};
    function Gi(e) {
      for (var t = e[0].toUpperCase() + e.slice(1), n = jn.length; n--; )
        if (e = jn[n] + t, e in Bn)
          return e;
    }
    function Qt(e) {
      var t = r.cssProps[e] || In[e];
      return t || (e in Bn ? e : In[e] = Gi(e) || e);
    }
    var Qi = /^(none|table(?!-c[ea]).+)/, Xi = { position: "absolute", visibility: "hidden", display: "block" }, Rn = {
      letterSpacing: "0",
      fontWeight: "400"
    };
    function zn(e, t, n) {
      var i = ht.exec(t);
      return i ? Math.max(0, i[2] - (n || 0)) + (i[3] || "px") : t;
    }
    function Xt(e, t, n, i, a, o) {
      var l = t === "width" ? 1 : 0, d = 0, f = 0;
      if (n === (i ? "border" : "content"))
        return 0;
      for (; l < 4; l += 2)
        n === "margin" && (f += r.css(e, n + Fe[l], !0, a)), i ? (n === "content" && (f -= r.css(e, "padding" + Fe[l], !0, a)), n !== "margin" && (f -= r.css(e, "border" + Fe[l] + "Width", !0, a))) : (f += r.css(e, "padding" + Fe[l], !0, a), n !== "padding" ? f += r.css(e, "border" + Fe[l] + "Width", !0, a) : d += r.css(e, "border" + Fe[l] + "Width", !0, a));
      return !i && o >= 0 && (f += Math.max(0, Math.ceil(
        e["offset" + t[0].toUpperCase() + t.slice(1)] - o - f - d - 0.5
      )) || 0), f;
    }
    function Vn(e, t, n) {
      var i = At(e), a = !J.boxSizingReliable() || n, o = a && r.css(e, "boxSizing", !1, i) === "border-box", l = o, d = gt(e, t, i), f = "offset" + t[0].toUpperCase() + t.slice(1);
      if (Ut.test(d)) {
        if (!n)
          return d;
        d = "auto";
      }
      return (!J.boxSizingReliable() && o || !J.reliableTrDimensions() && Se(e, "tr") || d === "auto" || !parseFloat(d) && r.css(e, "display", !1, i) === "inline") && e.getClientRects().length && (o = r.css(e, "boxSizing", !1, i) === "border-box", l = f in e, l && (d = e[f])), d = parseFloat(d) || 0, d + Xt(
        e,
        t,
        n || (o ? "border" : "content"),
        l,
        i,
        d
      ) + "px";
    }
    r.extend({
      cssHooks: {
        opacity: {
          get: function(e, t) {
            if (t) {
              var n = gt(e, "opacity");
              return n === "" ? "1" : n;
            }
          }
        }
      },
      cssNumber: {
        animationIterationCount: !0,
        columnCount: !0,
        fillOpacity: !0,
        flexGrow: !0,
        flexShrink: !0,
        fontWeight: !0,
        gridArea: !0,
        gridColumn: !0,
        gridColumnEnd: !0,
        gridColumnStart: !0,
        gridRow: !0,
        gridRowEnd: !0,
        gridRowStart: !0,
        lineHeight: !0,
        opacity: !0,
        order: !0,
        orphans: !0,
        widows: !0,
        zIndex: !0,
        zoom: !0
      },
      cssProps: {},
      style: function(e, t, n, i) {
        if (!(!e || e.nodeType === 3 || e.nodeType === 8 || !e.style)) {
          var a, o, l, d = He(t), f = Gt.test(t), b = e.style;
          if (f || (t = Qt(d)), l = r.cssHooks[t] || r.cssHooks[d], n !== void 0) {
            if (o = typeof n, o === "string" && (a = ht.exec(n)) && a[1] && (n = _n(e, t, a), o = "number"), n == null || n !== n)
              return;
            o === "number" && !f && (n += a && a[3] || (r.cssNumber[d] ? "" : "px")), !J.clearCloneStyle && n === "" && t.indexOf("background") === 0 && (b[t] = "inherit"), (!l || !("set" in l) || (n = l.set(e, n, i)) !== void 0) && (f ? b.setProperty(t, n) : b[t] = n);
          } else
            return l && "get" in l && (a = l.get(e, !1, i)) !== void 0 ? a : b[t];
        }
      },
      css: function(e, t, n, i) {
        var a, o, l, d = He(t), f = Gt.test(t);
        return f || (t = Qt(d)), l = r.cssHooks[t] || r.cssHooks[d], l && "get" in l && (a = l.get(e, !0, n)), a === void 0 && (a = gt(e, t, i)), a === "normal" && t in Rn && (a = Rn[t]), n === "" || n ? (o = parseFloat(a), n === !0 || isFinite(o) ? o || 0 : a) : a;
      }
    }), r.each(["height", "width"], function(e, t) {
      r.cssHooks[t] = {
        get: function(n, i, a) {
          if (i)
            return Qi.test(r.css(n, "display")) && (!n.getClientRects().length || !n.getBoundingClientRect().width) ? Fn(n, Xi, function() {
              return Vn(n, t, a);
            }) : Vn(n, t, a);
        },
        set: function(n, i, a) {
          var o, l = At(n), d = !J.scrollboxSize() && l.position === "absolute", f = d || a, b = f && r.css(n, "boxSizing", !1, l) === "border-box", v = a ? Xt(
            n,
            t,
            a,
            b,
            l
          ) : 0;
          return b && d && (v -= Math.ceil(
            n["offset" + t[0].toUpperCase() + t.slice(1)] - parseFloat(l[t]) - Xt(n, t, "border", !1, l) - 0.5
          )), v && (o = ht.exec(i)) && (o[3] || "px") !== "px" && (n.style[t] = i, i = r.css(n, t)), zn(n, i, v);
        }
      };
    }), r.cssHooks.marginLeft = $n(
      J.reliableMarginLeft,
      function(e, t) {
        if (t)
          return (parseFloat(gt(e, "marginLeft")) || e.getBoundingClientRect().left - Fn(e, { marginLeft: 0 }, function() {
            return e.getBoundingClientRect().left;
          })) + "px";
      }
    ), r.each({
      margin: "",
      padding: "",
      border: "Width"
    }, function(e, t) {
      r.cssHooks[e + t] = {
        expand: function(n) {
          for (var i = 0, a = {}, o = typeof n == "string" ? n.split(" ") : [n]; i < 4; i++)
            a[e + Fe[i] + t] = o[i] || o[i - 2] || o[0];
          return a;
        }
      }, e !== "margin" && (r.cssHooks[e + t].set = zn);
    }), r.fn.extend({
      css: function(e, t) {
        return Pe(this, function(n, i, a) {
          var o, l, d = {}, f = 0;
          if (Array.isArray(i)) {
            for (o = At(n), l = i.length; f < l; f++)
              d[i[f]] = r.css(n, i[f], !1, o);
            return d;
          }
          return a !== void 0 ? r.style(n, i, a) : r.css(n, i);
        }, e, t, arguments.length > 1);
      }
    });
    function ye(e, t, n, i, a) {
      return new ye.prototype.init(e, t, n, i, a);
    }
    r.Tween = ye, ye.prototype = {
      constructor: ye,
      init: function(e, t, n, i, a, o) {
        this.elem = e, this.prop = n, this.easing = a || r.easing._default, this.options = t, this.start = this.now = this.cur(), this.end = i, this.unit = o || (r.cssNumber[n] ? "" : "px");
      },
      cur: function() {
        var e = ye.propHooks[this.prop];
        return e && e.get ? e.get(this) : ye.propHooks._default.get(this);
      },
      run: function(e) {
        var t, n = ye.propHooks[this.prop];
        return this.options.duration ? this.pos = t = r.easing[this.easing](
          e,
          this.options.duration * e,
          0,
          1,
          this.options.duration
        ) : this.pos = t = e, this.now = (this.end - this.start) * t + this.start, this.options.step && this.options.step.call(this.elem, this.now, this), n && n.set ? n.set(this) : ye.propHooks._default.set(this), this;
      }
    }, ye.prototype.init.prototype = ye.prototype, ye.propHooks = {
      _default: {
        get: function(e) {
          var t;
          return e.elem.nodeType !== 1 || e.elem[e.prop] != null && e.elem.style[e.prop] == null ? e.elem[e.prop] : (t = r.css(e.elem, e.prop, ""), !t || t === "auto" ? 0 : t);
        },
        set: function(e) {
          r.fx.step[e.prop] ? r.fx.step[e.prop](e) : e.elem.nodeType === 1 && (r.cssHooks[e.prop] || e.elem.style[Qt(e.prop)] != null) ? r.style(e.elem, e.prop, e.now + e.unit) : e.elem[e.prop] = e.now;
        }
      }
    }, ye.propHooks.scrollTop = ye.propHooks.scrollLeft = {
      set: function(e) {
        e.elem.nodeType && e.elem.parentNode && (e.elem[e.prop] = e.now);
      }
    }, r.easing = {
      linear: function(e) {
        return e;
      },
      swing: function(e) {
        return 0.5 - Math.cos(e * Math.PI) / 2;
      },
      _default: "swing"
    }, r.fx = ye.prototype.init, r.fx.step = {};
    var ut, Nt, Yi = /^(?:toggle|show|hide)$/, Ji = /queueHooks$/;
    function Yt() {
      Nt && (X.hidden === !1 && p.requestAnimationFrame ? p.requestAnimationFrame(Yt) : p.setTimeout(Yt, r.fx.interval), r.fx.tick());
    }
    function Wn() {
      return p.setTimeout(function() {
        ut = void 0;
      }), ut = Date.now();
    }
    function qt(e, t) {
      var n, i = 0, a = { height: e };
      for (t = t ? 1 : 0; i < 4; i += 2 - t)
        n = Fe[i], a["margin" + n] = a["padding" + n] = e;
      return t && (a.opacity = a.width = e), a;
    }
    function Un(e, t, n) {
      for (var i, a = (_e.tweeners[t] || []).concat(_e.tweeners["*"]), o = 0, l = a.length; o < l; o++)
        if (i = a[o].call(n, t, e))
          return i;
    }
    function Ki(e, t, n) {
      var i, a, o, l, d, f, b, v, L = "width" in t || "height" in t, m = this, T = {}, P = e.style, W = e.nodeType && _t(e), F = B.get(e, "fxshow");
      n.queue || (l = r._queueHooks(e, "fx"), l.unqueued == null && (l.unqueued = 0, d = l.empty.fire, l.empty.fire = function() {
        l.unqueued || d();
      }), l.unqueued++, m.always(function() {
        m.always(function() {
          l.unqueued--, r.queue(e, "fx").length || l.empty.fire();
        });
      }));
      for (i in t)
        if (a = t[i], Yi.test(a)) {
          if (delete t[i], o = o || a === "toggle", a === (W ? "hide" : "show"))
            if (a === "show" && F && F[i] !== void 0)
              W = !0;
            else
              continue;
          T[i] = F && F[i] || r.style(e, i);
        }
      if (f = !r.isEmptyObject(t), !(!f && r.isEmptyObject(T))) {
        L && e.nodeType === 1 && (n.overflow = [P.overflow, P.overflowX, P.overflowY], b = F && F.display, b == null && (b = B.get(e, "display")), v = r.css(e, "display"), v === "none" && (b ? v = b : (st([e], !0), b = e.style.display || b, v = r.css(e, "display"), st([e]))), (v === "inline" || v === "inline-block" && b != null) && r.css(e, "float") === "none" && (f || (m.done(function() {
          P.display = b;
        }), b == null && (v = P.display, b = v === "none" ? "" : v)), P.display = "inline-block")), n.overflow && (P.overflow = "hidden", m.always(function() {
          P.overflow = n.overflow[0], P.overflowX = n.overflow[1], P.overflowY = n.overflow[2];
        })), f = !1;
        for (i in T)
          f || (F ? "hidden" in F && (W = F.hidden) : F = B.access(e, "fxshow", { display: b }), o && (F.hidden = !W), W && st([e], !0), m.done(function() {
            W || st([e]), B.remove(e, "fxshow");
            for (i in T)
              r.style(e, i, T[i]);
          })), f = Un(W ? F[i] : 0, i, m), i in F || (F[i] = f.start, W && (f.end = f.start, f.start = 0));
      }
    }
    function Zi(e, t) {
      var n, i, a, o, l;
      for (n in e)
        if (i = He(n), a = t[i], o = e[n], Array.isArray(o) && (a = o[1], o = e[n] = o[0]), n !== i && (e[i] = o, delete e[n]), l = r.cssHooks[i], l && "expand" in l) {
          o = l.expand(o), delete e[i];
          for (n in o)
            n in e || (e[n] = o[n], t[n] = a);
        } else
          t[i] = a;
    }
    function _e(e, t, n) {
      var i, a, o = 0, l = _e.prefilters.length, d = r.Deferred().always(function() {
        delete f.elem;
      }), f = function() {
        if (a)
          return !1;
        for (var L = ut || Wn(), m = Math.max(0, b.startTime + b.duration - L), T = m / b.duration || 0, P = 1 - T, W = 0, F = b.tweens.length; W < F; W++)
          b.tweens[W].run(P);
        return d.notifyWith(e, [b, P, m]), P < 1 && F ? m : (F || d.notifyWith(e, [b, 1, 0]), d.resolveWith(e, [b]), !1);
      }, b = d.promise({
        elem: e,
        props: r.extend({}, t),
        opts: r.extend(!0, {
          specialEasing: {},
          easing: r.easing._default
        }, n),
        originalProperties: t,
        originalOptions: n,
        startTime: ut || Wn(),
        duration: n.duration,
        tweens: [],
        createTween: function(L, m) {
          var T = r.Tween(
            e,
            b.opts,
            L,
            m,
            b.opts.specialEasing[L] || b.opts.easing
          );
          return b.tweens.push(T), T;
        },
        stop: function(L) {
          var m = 0, T = L ? b.tweens.length : 0;
          if (a)
            return this;
          for (a = !0; m < T; m++)
            b.tweens[m].run(1);
          return L ? (d.notifyWith(e, [b, 1, 0]), d.resolveWith(e, [b, L])) : d.rejectWith(e, [b, L]), this;
        }
      }), v = b.props;
      for (Zi(v, b.opts.specialEasing); o < l; o++)
        if (i = _e.prefilters[o].call(b, e, v, b.opts), i)
          return U(i.stop) && (r._queueHooks(b.elem, b.opts.queue).stop = i.stop.bind(i)), i;
      return r.map(v, Un, b), U(b.opts.start) && b.opts.start.call(e, b), b.progress(b.opts.progress).done(b.opts.done, b.opts.complete).fail(b.opts.fail).always(b.opts.always), r.fx.timer(
        r.extend(f, {
          elem: e,
          anim: b,
          queue: b.opts.queue
        })
      ), b;
    }
    r.Animation = r.extend(_e, {
      tweeners: {
        "*": [function(e, t) {
          var n = this.createTween(e, t);
          return _n(n.elem, e, ht.exec(t), n), n;
        }]
      },
      tweener: function(e, t) {
        U(e) ? (t = e, e = ["*"]) : e = e.match(Oe);
        for (var n, i = 0, a = e.length; i < a; i++)
          n = e[i], _e.tweeners[n] = _e.tweeners[n] || [], _e.tweeners[n].unshift(t);
      },
      prefilters: [Ki],
      prefilter: function(e, t) {
        t ? _e.prefilters.unshift(e) : _e.prefilters.push(e);
      }
    }), r.speed = function(e, t, n) {
      var i = e && typeof e == "object" ? r.extend({}, e) : {
        complete: n || !n && t || U(e) && e,
        duration: e,
        easing: n && t || t && !U(t) && t
      };
      return r.fx.off ? i.duration = 0 : typeof i.duration != "number" && (i.duration in r.fx.speeds ? i.duration = r.fx.speeds[i.duration] : i.duration = r.fx.speeds._default), (i.queue == null || i.queue === !0) && (i.queue = "fx"), i.old = i.complete, i.complete = function() {
        U(i.old) && i.old.call(this), i.queue && r.dequeue(this, i.queue);
      }, i;
    }, r.fn.extend({
      fadeTo: function(e, t, n, i) {
        return this.filter(_t).css("opacity", 0).show().end().animate({ opacity: t }, e, n, i);
      },
      animate: function(e, t, n, i) {
        var a = r.isEmptyObject(e), o = r.speed(t, n, i), l = function() {
          var d = _e(this, r.extend({}, e), o);
          (a || B.get(this, "finish")) && d.stop(!0);
        };
        return l.finish = l, a || o.queue === !1 ? this.each(l) : this.queue(o.queue, l);
      },
      stop: function(e, t, n) {
        var i = function(a) {
          var o = a.stop;
          delete a.stop, o(n);
        };
        return typeof e != "string" && (n = t, t = e, e = void 0), t && this.queue(e || "fx", []), this.each(function() {
          var a = !0, o = e != null && e + "queueHooks", l = r.timers, d = B.get(this);
          if (o)
            d[o] && d[o].stop && i(d[o]);
          else
            for (o in d)
              d[o] && d[o].stop && Ji.test(o) && i(d[o]);
          for (o = l.length; o--; )
            l[o].elem === this && (e == null || l[o].queue === e) && (l[o].anim.stop(n), a = !1, l.splice(o, 1));
          (a || !n) && r.dequeue(this, e);
        });
      },
      finish: function(e) {
        return e !== !1 && (e = e || "fx"), this.each(function() {
          var t, n = B.get(this), i = n[e + "queue"], a = n[e + "queueHooks"], o = r.timers, l = i ? i.length : 0;
          for (n.finish = !0, r.queue(this, e, []), a && a.stop && a.stop.call(this, !0), t = o.length; t--; )
            o[t].elem === this && o[t].queue === e && (o[t].anim.stop(!0), o.splice(t, 1));
          for (t = 0; t < l; t++)
            i[t] && i[t].finish && i[t].finish.call(this);
          delete n.finish;
        });
      }
    }), r.each(["toggle", "show", "hide"], function(e, t) {
      var n = r.fn[t];
      r.fn[t] = function(i, a, o) {
        return i == null || typeof i == "boolean" ? n.apply(this, arguments) : this.animate(qt(t, !0), i, a, o);
      };
    }), r.each({
      slideDown: qt("show"),
      slideUp: qt("hide"),
      slideToggle: qt("toggle"),
      fadeIn: { opacity: "show" },
      fadeOut: { opacity: "hide" },
      fadeToggle: { opacity: "toggle" }
    }, function(e, t) {
      r.fn[e] = function(n, i, a) {
        return this.animate(t, n, i, a);
      };
    }), r.timers = [], r.fx.tick = function() {
      var e, t = 0, n = r.timers;
      for (ut = Date.now(); t < n.length; t++)
        e = n[t], !e() && n[t] === e && n.splice(t--, 1);
      n.length || r.fx.stop(), ut = void 0;
    }, r.fx.timer = function(e) {
      r.timers.push(e), r.fx.start();
    }, r.fx.interval = 13, r.fx.start = function() {
      Nt || (Nt = !0, Yt());
    }, r.fx.stop = function() {
      Nt = null;
    }, r.fx.speeds = {
      slow: 600,
      fast: 200,
      _default: 400
    }, r.fn.delay = function(e, t) {
      return e = r.fx && r.fx.speeds[e] || e, t = t || "fx", this.queue(t, function(n, i) {
        var a = p.setTimeout(n, e);
        i.stop = function() {
          p.clearTimeout(a);
        };
      });
    }, function() {
      var e = X.createElement("input"), t = X.createElement("select"), n = t.appendChild(X.createElement("option"));
      e.type = "checkbox", J.checkOn = e.value !== "", J.optSelected = n.selected, e = X.createElement("input"), e.value = "t", e.type = "radio", J.radioValue = e.value === "t";
    }();
    var Gn, yt = r.expr.attrHandle;
    r.fn.extend({
      attr: function(e, t) {
        return Pe(this, r.attr, e, t, arguments.length > 1);
      },
      removeAttr: function(e) {
        return this.each(function() {
          r.removeAttr(this, e);
        });
      }
    }), r.extend({
      attr: function(e, t, n) {
        var i, a, o = e.nodeType;
        if (!(o === 3 || o === 8 || o === 2)) {
          if (typeof e.getAttribute > "u")
            return r.prop(e, t, n);
          if ((o !== 1 || !r.isXMLDoc(e)) && (a = r.attrHooks[t.toLowerCase()] || (r.expr.match.bool.test(t) ? Gn : void 0)), n !== void 0) {
            if (n === null) {
              r.removeAttr(e, t);
              return;
            }
            return a && "set" in a && (i = a.set(e, n, t)) !== void 0 ? i : (e.setAttribute(t, n + ""), n);
          }
          return a && "get" in a && (i = a.get(e, t)) !== null ? i : (i = r.find.attr(e, t), i == null ? void 0 : i);
        }
      },
      attrHooks: {
        type: {
          set: function(e, t) {
            if (!J.radioValue && t === "radio" && Se(e, "input")) {
              var n = e.value;
              return e.setAttribute("type", t), n && (e.value = n), t;
            }
          }
        }
      },
      removeAttr: function(e, t) {
        var n, i = 0, a = t && t.match(Oe);
        if (a && e.nodeType === 1)
          for (; n = a[i++]; )
            e.removeAttribute(n);
      }
    }), Gn = {
      set: function(e, t, n) {
        return t === !1 ? r.removeAttr(e, n) : e.setAttribute(n, n), n;
      }
    }, r.each(r.expr.match.bool.source.match(/\w+/g), function(e, t) {
      var n = yt[t] || r.find.attr;
      yt[t] = function(i, a, o) {
        var l, d, f = a.toLowerCase();
        return o || (d = yt[f], yt[f] = l, l = n(i, a, o) != null ? f : null, yt[f] = d), l;
      };
    });
    var er = /^(?:input|select|textarea|button)$/i, tr = /^(?:a|area)$/i;
    r.fn.extend({
      prop: function(e, t) {
        return Pe(this, r.prop, e, t, arguments.length > 1);
      },
      removeProp: function(e) {
        return this.each(function() {
          delete this[r.propFix[e] || e];
        });
      }
    }), r.extend({
      prop: function(e, t, n) {
        var i, a, o = e.nodeType;
        if (!(o === 3 || o === 8 || o === 2))
          return (o !== 1 || !r.isXMLDoc(e)) && (t = r.propFix[t] || t, a = r.propHooks[t]), n !== void 0 ? a && "set" in a && (i = a.set(e, n, t)) !== void 0 ? i : e[t] = n : a && "get" in a && (i = a.get(e, t)) !== null ? i : e[t];
      },
      propHooks: {
        tabIndex: {
          get: function(e) {
            var t = r.find.attr(e, "tabindex");
            return t ? parseInt(t, 10) : er.test(e.nodeName) || tr.test(e.nodeName) && e.href ? 0 : -1;
          }
        }
      },
      propFix: {
        for: "htmlFor",
        class: "className"
      }
    }), J.optSelected || (r.propHooks.selected = {
      get: function(e) {
        var t = e.parentNode;
        return t && t.parentNode && t.parentNode.selectedIndex, null;
      },
      set: function(e) {
        var t = e.parentNode;
        t && (t.selectedIndex, t.parentNode && t.parentNode.selectedIndex);
      }
    }), r.each([
      "tabIndex",
      "readOnly",
      "maxLength",
      "cellSpacing",
      "cellPadding",
      "rowSpan",
      "colSpan",
      "useMap",
      "frameBorder",
      "contentEditable"
    ], function() {
      r.propFix[this.toLowerCase()] = this;
    });
    function Ue(e) {
      var t = e.match(Oe) || [];
      return t.join(" ");
    }
    function Ge(e) {
      return e.getAttribute && e.getAttribute("class") || "";
    }
    function Jt(e) {
      return Array.isArray(e) ? e : typeof e == "string" ? e.match(Oe) || [] : [];
    }
    r.fn.extend({
      addClass: function(e) {
        var t, n, i, a, o, l;
        return U(e) ? this.each(function(d) {
          r(this).addClass(e.call(this, d, Ge(this)));
        }) : (t = Jt(e), t.length ? this.each(function() {
          if (i = Ge(this), n = this.nodeType === 1 && " " + Ue(i) + " ", n) {
            for (o = 0; o < t.length; o++)
              a = t[o], n.indexOf(" " + a + " ") < 0 && (n += a + " ");
            l = Ue(n), i !== l && this.setAttribute("class", l);
          }
        }) : this);
      },
      removeClass: function(e) {
        var t, n, i, a, o, l;
        return U(e) ? this.each(function(d) {
          r(this).removeClass(e.call(this, d, Ge(this)));
        }) : arguments.length ? (t = Jt(e), t.length ? this.each(function() {
          if (i = Ge(this), n = this.nodeType === 1 && " " + Ue(i) + " ", n) {
            for (o = 0; o < t.length; o++)
              for (a = t[o]; n.indexOf(" " + a + " ") > -1; )
                n = n.replace(" " + a + " ", " ");
            l = Ue(n), i !== l && this.setAttribute("class", l);
          }
        }) : this) : this.attr("class", "");
      },
      toggleClass: function(e, t) {
        var n, i, a, o, l = typeof e, d = l === "string" || Array.isArray(e);
        return U(e) ? this.each(function(f) {
          r(this).toggleClass(
            e.call(this, f, Ge(this), t),
            t
          );
        }) : typeof t == "boolean" && d ? t ? this.addClass(e) : this.removeClass(e) : (n = Jt(e), this.each(function() {
          if (d)
            for (o = r(this), a = 0; a < n.length; a++)
              i = n[a], o.hasClass(i) ? o.removeClass(i) : o.addClass(i);
          else
            (e === void 0 || l === "boolean") && (i = Ge(this), i && B.set(this, "__className__", i), this.setAttribute && this.setAttribute(
              "class",
              i || e === !1 ? "" : B.get(this, "__className__") || ""
            ));
        }));
      },
      hasClass: function(e) {
        var t, n, i = 0;
        for (t = " " + e + " "; n = this[i++]; )
          if (n.nodeType === 1 && (" " + Ue(Ge(n)) + " ").indexOf(t) > -1)
            return !0;
        return !1;
      }
    });
    var nr = /\r/g;
    r.fn.extend({
      val: function(e) {
        var t, n, i, a = this[0];
        return arguments.length ? (i = U(e), this.each(function(o) {
          var l;
          this.nodeType === 1 && (i ? l = e.call(this, o, r(this).val()) : l = e, l == null ? l = "" : typeof l == "number" ? l += "" : Array.isArray(l) && (l = r.map(l, function(d) {
            return d == null ? "" : d + "";
          })), t = r.valHooks[this.type] || r.valHooks[this.nodeName.toLowerCase()], (!t || !("set" in t) || t.set(this, l, "value") === void 0) && (this.value = l));
        })) : a ? (t = r.valHooks[a.type] || r.valHooks[a.nodeName.toLowerCase()], t && "get" in t && (n = t.get(a, "value")) !== void 0 ? n : (n = a.value, typeof n == "string" ? n.replace(nr, "") : n == null ? "" : n)) : void 0;
      }
    }), r.extend({
      valHooks: {
        option: {
          get: function(e) {
            var t = r.find.attr(e, "value");
            return t != null ? t : Ue(r.text(e));
          }
        },
        select: {
          get: function(e) {
            var t, n, i, a = e.options, o = e.selectedIndex, l = e.type === "select-one", d = l ? null : [], f = l ? o + 1 : a.length;
            for (o < 0 ? i = f : i = l ? o : 0; i < f; i++)
              if (n = a[i], (n.selected || i === o) && !n.disabled && (!n.parentNode.disabled || !Se(n.parentNode, "optgroup"))) {
                if (t = r(n).val(), l)
                  return t;
                d.push(t);
              }
            return d;
          },
          set: function(e, t) {
            for (var n, i, a = e.options, o = r.makeArray(t), l = a.length; l--; )
              i = a[l], (i.selected = r.inArray(r.valHooks.option.get(i), o) > -1) && (n = !0);
            return n || (e.selectedIndex = -1), o;
          }
        }
      }
    }), r.each(["radio", "checkbox"], function() {
      r.valHooks[this] = {
        set: function(e, t) {
          if (Array.isArray(t))
            return e.checked = r.inArray(r(e).val(), t) > -1;
        }
      }, J.checkOn || (r.valHooks[this].get = function(e) {
        return e.getAttribute("value") === null ? "on" : e.value;
      });
    }), J.focusin = "onfocusin" in p;
    var Qn = /^(?:focusinfocus|focusoutblur)$/, Xn = function(e) {
      e.stopPropagation();
    };
    r.extend(r.event, {
      trigger: function(e, t, n, i) {
        var a, o, l, d, f, b, v, L, m = [n || X], T = St.call(e, "type") ? e.type : e, P = St.call(e, "namespace") ? e.namespace.split(".") : [];
        if (o = L = l = n = n || X, !(n.nodeType === 3 || n.nodeType === 8) && !Qn.test(T + r.event.triggered) && (T.indexOf(".") > -1 && (P = T.split("."), T = P.shift(), P.sort()), f = T.indexOf(":") < 0 && "on" + T, e = e[r.expando] ? e : new r.Event(T, typeof e == "object" && e), e.isTrigger = i ? 2 : 3, e.namespace = P.join("."), e.rnamespace = e.namespace ? new RegExp("(^|\\.)" + P.join("\\.(?:.*\\.|)") + "(\\.|$)") : null, e.result = void 0, e.target || (e.target = n), t = t == null ? [e] : r.makeArray(t, [e]), v = r.event.special[T] || {}, !(!i && v.trigger && v.trigger.apply(n, t) === !1))) {
          if (!i && !v.noBubble && !et(n)) {
            for (d = v.delegateType || T, Qn.test(d + T) || (o = o.parentNode); o; o = o.parentNode)
              m.push(o), l = o;
            l === (n.ownerDocument || X) && m.push(l.defaultView || l.parentWindow || p);
          }
          for (a = 0; (o = m[a++]) && !e.isPropagationStopped(); )
            L = o, e.type = a > 1 ? d : v.bindType || T, b = (B.get(o, "events") || /* @__PURE__ */ Object.create(null))[e.type] && B.get(o, "handle"), b && b.apply(o, t), b = f && o[f], b && b.apply && ct(o) && (e.result = b.apply(o, t), e.result === !1 && e.preventDefault());
          return e.type = T, !i && !e.isDefaultPrevented() && (!v._default || v._default.apply(m.pop(), t) === !1) && ct(n) && f && U(n[T]) && !et(n) && (l = n[f], l && (n[f] = null), r.event.triggered = T, e.isPropagationStopped() && L.addEventListener(T, Xn), n[T](), e.isPropagationStopped() && L.removeEventListener(T, Xn), r.event.triggered = void 0, l && (n[f] = l)), e.result;
        }
      },
      simulate: function(e, t, n) {
        var i = r.extend(
          new r.Event(),
          n,
          {
            type: e,
            isSimulated: !0
          }
        );
        r.event.trigger(i, null, t);
      }
    }), r.fn.extend({
      trigger: function(e, t) {
        return this.each(function() {
          r.event.trigger(e, t, this);
        });
      },
      triggerHandler: function(e, t) {
        var n = this[0];
        if (n)
          return r.event.trigger(e, t, n, !0);
      }
    }), J.focusin || r.each({ focus: "focusin", blur: "focusout" }, function(e, t) {
      var n = function(i) {
        r.event.simulate(t, i.target, r.event.fix(i));
      };
      r.event.special[t] = {
        setup: function() {
          var i = this.ownerDocument || this.document || this, a = B.access(i, t);
          a || i.addEventListener(e, n, !0), B.access(i, t, (a || 0) + 1);
        },
        teardown: function() {
          var i = this.ownerDocument || this.document || this, a = B.access(i, t) - 1;
          a ? B.access(i, t, a) : (i.removeEventListener(e, n, !0), B.remove(i, t));
        }
      };
    });
    var bt = p.location, Yn = { guid: Date.now() }, Kt = /\?/;
    r.parseXML = function(e) {
      var t, n;
      if (!e || typeof e != "string")
        return null;
      try {
        t = new p.DOMParser().parseFromString(e, "text/xml");
      } catch {
      }
      return n = t && t.getElementsByTagName("parsererror")[0], (!t || n) && r.error("Invalid XML: " + (n ? r.map(n.childNodes, function(i) {
        return i.textContent;
      }).join(`
`) : e)), t;
    };
    var ir = /\[\]$/, Jn = /\r?\n/g, rr = /^(?:submit|button|image|reset|file)$/i, sr = /^(?:input|select|textarea|keygen)/i;
    function Zt(e, t, n, i) {
      var a;
      if (Array.isArray(t))
        r.each(t, function(o, l) {
          n || ir.test(e) ? i(e, l) : Zt(
            e + "[" + (typeof l == "object" && l != null ? o : "") + "]",
            l,
            n,
            i
          );
        });
      else if (!n && tt(t) === "object")
        for (a in t)
          Zt(e + "[" + a + "]", t[a], n, i);
      else
        i(e, t);
    }
    r.param = function(e, t) {
      var n, i = [], a = function(o, l) {
        var d = U(l) ? l() : l;
        i[i.length] = encodeURIComponent(o) + "=" + encodeURIComponent(d == null ? "" : d);
      };
      if (e == null)
        return "";
      if (Array.isArray(e) || e.jquery && !r.isPlainObject(e))
        r.each(e, function() {
          a(this.name, this.value);
        });
      else
        for (n in e)
          Zt(n, e[n], t, a);
      return i.join("&");
    }, r.fn.extend({
      serialize: function() {
        return r.param(this.serializeArray());
      },
      serializeArray: function() {
        return this.map(function() {
          var e = r.prop(this, "elements");
          return e ? r.makeArray(e) : this;
        }).filter(function() {
          var e = this.type;
          return this.name && !r(this).is(":disabled") && sr.test(this.nodeName) && !rr.test(e) && (this.checked || !pt.test(e));
        }).map(function(e, t) {
          var n = r(this).val();
          return n == null ? null : Array.isArray(n) ? r.map(n, function(i) {
            return { name: t.name, value: i.replace(Jn, `\r
`) };
          }) : { name: t.name, value: n.replace(Jn, `\r
`) };
        }).get();
      }
    });
    var ar = /%20/g, or = /#.*$/, lr = /([?&])_=[^&]*/, ur = /^(.*?):[ \t]*([^\r\n]*)$/mg, fr = /^(?:about|app|app-storage|.+-extension|file|res|widget):$/, cr = /^(?:GET|HEAD)$/, dr = /^\/\//, Kn = {}, en = {}, Zn = "*/".concat("*"), tn = X.createElement("a");
    tn.href = bt.href;
    function ei(e) {
      return function(t, n) {
        typeof t != "string" && (n = t, t = "*");
        var i, a = 0, o = t.toLowerCase().match(Oe) || [];
        if (U(n))
          for (; i = o[a++]; )
            i[0] === "+" ? (i = i.slice(1) || "*", (e[i] = e[i] || []).unshift(n)) : (e[i] = e[i] || []).push(n);
      };
    }
    function ti(e, t, n, i) {
      var a = {}, o = e === en;
      function l(d) {
        var f;
        return a[d] = !0, r.each(e[d] || [], function(b, v) {
          var L = v(t, n, i);
          if (typeof L == "string" && !o && !a[L])
            return t.dataTypes.unshift(L), l(L), !1;
          if (o)
            return !(f = L);
        }), f;
      }
      return l(t.dataTypes[0]) || !a["*"] && l("*");
    }
    function nn(e, t) {
      var n, i, a = r.ajaxSettings.flatOptions || {};
      for (n in t)
        t[n] !== void 0 && ((a[n] ? e : i || (i = {}))[n] = t[n]);
      return i && r.extend(!0, e, i), e;
    }
    function hr(e, t, n) {
      for (var i, a, o, l, d = e.contents, f = e.dataTypes; f[0] === "*"; )
        f.shift(), i === void 0 && (i = e.mimeType || t.getResponseHeader("Content-Type"));
      if (i) {
        for (a in d)
          if (d[a] && d[a].test(i)) {
            f.unshift(a);
            break;
          }
      }
      if (f[0] in n)
        o = f[0];
      else {
        for (a in n) {
          if (!f[0] || e.converters[a + " " + f[0]]) {
            o = a;
            break;
          }
          l || (l = a);
        }
        o = o || l;
      }
      if (o)
        return o !== f[0] && f.unshift(o), n[o];
    }
    function pr(e, t, n, i) {
      var a, o, l, d, f, b = {}, v = e.dataTypes.slice();
      if (v[1])
        for (l in e.converters)
          b[l.toLowerCase()] = e.converters[l];
      for (o = v.shift(); o; )
        if (e.responseFields[o] && (n[e.responseFields[o]] = t), !f && i && e.dataFilter && (t = e.dataFilter(t, e.dataType)), f = o, o = v.shift(), o) {
          if (o === "*")
            o = f;
          else if (f !== "*" && f !== o) {
            if (l = b[f + " " + o] || b["* " + o], !l) {
              for (a in b)
                if (d = a.split(" "), d[1] === o && (l = b[f + " " + d[0]] || b["* " + d[0]], l)) {
                  l === !0 ? l = b[a] : b[a] !== !0 && (o = d[0], v.unshift(d[1]));
                  break;
                }
            }
            if (l !== !0)
              if (l && e.throws)
                t = l(t);
              else
                try {
                  t = l(t);
                } catch (L) {
                  return {
                    state: "parsererror",
                    error: l ? L : "No conversion from " + f + " to " + o
                  };
                }
          }
        }
      return { state: "success", data: t };
    }
    r.extend({
      active: 0,
      lastModified: {},
      etag: {},
      ajaxSettings: {
        url: bt.href,
        type: "GET",
        isLocal: fr.test(bt.protocol),
        global: !0,
        processData: !0,
        async: !0,
        contentType: "application/x-www-form-urlencoded; charset=UTF-8",
        accepts: {
          "*": Zn,
          text: "text/plain",
          html: "text/html",
          xml: "application/xml, text/xml",
          json: "application/json, text/javascript"
        },
        contents: {
          xml: /\bxml\b/,
          html: /\bhtml/,
          json: /\bjson\b/
        },
        responseFields: {
          xml: "responseXML",
          text: "responseText",
          json: "responseJSON"
        },
        converters: {
          "* text": String,
          "text html": !0,
          "text json": JSON.parse,
          "text xml": r.parseXML
        },
        flatOptions: {
          url: !0,
          context: !0
        }
      },
      ajaxSetup: function(e, t) {
        return t ? nn(nn(e, r.ajaxSettings), t) : nn(r.ajaxSettings, e);
      },
      ajaxPrefilter: ei(Kn),
      ajaxTransport: ei(en),
      ajax: function(e, t) {
        typeof e == "object" && (t = e, e = void 0), t = t || {};
        var n, i, a, o, l, d, f, b, v, L, m = r.ajaxSetup({}, t), T = m.context || m, P = m.context && (T.nodeType || T.jquery) ? r(T) : r.event, W = r.Deferred(), F = r.Callbacks("once memory"), le = m.statusCode || {}, oe = {}, ve = {}, Z = "canceled", V = {
          readyState: 0,
          getResponseHeader: function(Y) {
            var se;
            if (f) {
              if (!o)
                for (o = {}; se = ur.exec(a); )
                  o[se[1].toLowerCase() + " "] = (o[se[1].toLowerCase() + " "] || []).concat(se[2]);
              se = o[Y.toLowerCase() + " "];
            }
            return se == null ? null : se.join(", ");
          },
          getAllResponseHeaders: function() {
            return f ? a : null;
          },
          setRequestHeader: function(Y, se) {
            return f == null && (Y = ve[Y.toLowerCase()] = ve[Y.toLowerCase()] || Y, oe[Y] = se), this;
          },
          overrideMimeType: function(Y) {
            return f == null && (m.mimeType = Y), this;
          },
          statusCode: function(Y) {
            var se;
            if (Y)
              if (f)
                V.always(Y[V.status]);
              else
                for (se in Y)
                  le[se] = [le[se], Y[se]];
            return this;
          },
          abort: function(Y) {
            var se = Y || Z;
            return n && n.abort(se), be(0, se), this;
          }
        };
        if (W.promise(V), m.url = ((e || m.url || bt.href) + "").replace(dr, bt.protocol + "//"), m.type = t.method || t.type || m.method || m.type, m.dataTypes = (m.dataType || "*").toLowerCase().match(Oe) || [""], m.crossDomain == null) {
          d = X.createElement("a");
          try {
            d.href = m.url, d.href = d.href, m.crossDomain = tn.protocol + "//" + tn.host != d.protocol + "//" + d.host;
          } catch {
            m.crossDomain = !0;
          }
        }
        if (m.data && m.processData && typeof m.data != "string" && (m.data = r.param(m.data, m.traditional)), ti(Kn, m, t, V), f)
          return V;
        b = r.event && m.global, b && r.active++ === 0 && r.event.trigger("ajaxStart"), m.type = m.type.toUpperCase(), m.hasContent = !cr.test(m.type), i = m.url.replace(or, ""), m.hasContent ? m.data && m.processData && (m.contentType || "").indexOf("application/x-www-form-urlencoded") === 0 && (m.data = m.data.replace(ar, "+")) : (L = m.url.slice(i.length), m.data && (m.processData || typeof m.data == "string") && (i += (Kt.test(i) ? "&" : "?") + m.data, delete m.data), m.cache === !1 && (i = i.replace(lr, "$1"), L = (Kt.test(i) ? "&" : "?") + "_=" + Yn.guid++ + L), m.url = i + L), m.ifModified && (r.lastModified[i] && V.setRequestHeader("If-Modified-Since", r.lastModified[i]), r.etag[i] && V.setRequestHeader("If-None-Match", r.etag[i])), (m.data && m.hasContent && m.contentType !== !1 || t.contentType) && V.setRequestHeader("Content-Type", m.contentType), V.setRequestHeader(
          "Accept",
          m.dataTypes[0] && m.accepts[m.dataTypes[0]] ? m.accepts[m.dataTypes[0]] + (m.dataTypes[0] !== "*" ? ", " + Zn + "; q=0.01" : "") : m.accepts["*"]
        );
        for (v in m.headers)
          V.setRequestHeader(v, m.headers[v]);
        if (m.beforeSend && (m.beforeSend.call(T, V, m) === !1 || f))
          return V.abort();
        if (Z = "abort", F.add(m.complete), V.done(m.success), V.fail(m.error), n = ti(en, m, t, V), !n)
          be(-1, "No Transport");
        else {
          if (V.readyState = 1, b && P.trigger("ajaxSend", [V, m]), f)
            return V;
          m.async && m.timeout > 0 && (l = p.setTimeout(function() {
            V.abort("timeout");
          }, m.timeout));
          try {
            f = !1, n.send(oe, be);
          } catch (Y) {
            if (f)
              throw Y;
            be(-1, Y);
          }
        }
        function be(Y, se, vt, Ot) {
          var ke, Qe, Xe, me, Ie, xe = se;
          f || (f = !0, l && p.clearTimeout(l), n = void 0, a = Ot || "", V.readyState = Y > 0 ? 4 : 0, ke = Y >= 200 && Y < 300 || Y === 304, vt && (me = hr(m, V, vt)), !ke && r.inArray("script", m.dataTypes) > -1 && r.inArray("json", m.dataTypes) < 0 && (m.converters["text script"] = function() {
          }), me = pr(m, me, V, ke), ke ? (m.ifModified && (Ie = V.getResponseHeader("Last-Modified"), Ie && (r.lastModified[i] = Ie), Ie = V.getResponseHeader("etag"), Ie && (r.etag[i] = Ie)), Y === 204 || m.type === "HEAD" ? xe = "nocontent" : Y === 304 ? xe = "notmodified" : (xe = me.state, Qe = me.data, Xe = me.error, ke = !Xe)) : (Xe = xe, (Y || !xe) && (xe = "error", Y < 0 && (Y = 0))), V.status = Y, V.statusText = (se || xe) + "", ke ? W.resolveWith(T, [Qe, xe, V]) : W.rejectWith(T, [V, xe, Xe]), V.statusCode(le), le = void 0, b && P.trigger(
            ke ? "ajaxSuccess" : "ajaxError",
            [V, m, ke ? Qe : Xe]
          ), F.fireWith(T, [V, xe]), b && (P.trigger("ajaxComplete", [V, m]), --r.active || r.event.trigger("ajaxStop")));
        }
        return V;
      },
      getJSON: function(e, t, n) {
        return r.get(e, t, n, "json");
      },
      getScript: function(e, t) {
        return r.get(e, void 0, t, "script");
      }
    }), r.each(["get", "post"], function(e, t) {
      r[t] = function(n, i, a, o) {
        return U(i) && (o = o || a, a = i, i = void 0), r.ajax(r.extend({
          url: n,
          type: t,
          dataType: o,
          data: i,
          success: a
        }, r.isPlainObject(n) && n));
      };
    }), r.ajaxPrefilter(function(e) {
      var t;
      for (t in e.headers)
        t.toLowerCase() === "content-type" && (e.contentType = e.headers[t] || "");
    }), r._evalUrl = function(e, t, n) {
      return r.ajax({
        url: e,
        type: "GET",
        dataType: "script",
        cache: !0,
        async: !1,
        global: !1,
        converters: {
          "text script": function() {
          }
        },
        dataFilter: function(i) {
          r.globalEval(i, t, n);
        }
      });
    }, r.fn.extend({
      wrapAll: function(e) {
        var t;
        return this[0] && (U(e) && (e = e.call(this[0])), t = r(e, this[0].ownerDocument).eq(0).clone(!0), this[0].parentNode && t.insertBefore(this[0]), t.map(function() {
          for (var n = this; n.firstElementChild; )
            n = n.firstElementChild;
          return n;
        }).append(this)), this;
      },
      wrapInner: function(e) {
        return U(e) ? this.each(function(t) {
          r(this).wrapInner(e.call(this, t));
        }) : this.each(function() {
          var t = r(this), n = t.contents();
          n.length ? n.wrapAll(e) : t.append(e);
        });
      },
      wrap: function(e) {
        var t = U(e);
        return this.each(function(n) {
          r(this).wrapAll(t ? e.call(this, n) : e);
        });
      },
      unwrap: function(e) {
        return this.parent(e).not("body").each(function() {
          r(this).replaceWith(this.childNodes);
        }), this;
      }
    }), r.expr.pseudos.hidden = function(e) {
      return !r.expr.pseudos.visible(e);
    }, r.expr.pseudos.visible = function(e) {
      return !!(e.offsetWidth || e.offsetHeight || e.getClientRects().length);
    }, r.ajaxSettings.xhr = function() {
      try {
        return new p.XMLHttpRequest();
      } catch {
      }
    };
    var gr = {
      0: 200,
      1223: 204
    }, mt = r.ajaxSettings.xhr();
    J.cors = !!mt && "withCredentials" in mt, J.ajax = mt = !!mt, r.ajaxTransport(function(e) {
      var t, n;
      if (J.cors || mt && !e.crossDomain)
        return {
          send: function(i, a) {
            var o, l = e.xhr();
            if (l.open(
              e.type,
              e.url,
              e.async,
              e.username,
              e.password
            ), e.xhrFields)
              for (o in e.xhrFields)
                l[o] = e.xhrFields[o];
            e.mimeType && l.overrideMimeType && l.overrideMimeType(e.mimeType), !e.crossDomain && !i["X-Requested-With"] && (i["X-Requested-With"] = "XMLHttpRequest");
            for (o in i)
              l.setRequestHeader(o, i[o]);
            t = function(d) {
              return function() {
                t && (t = n = l.onload = l.onerror = l.onabort = l.ontimeout = l.onreadystatechange = null, d === "abort" ? l.abort() : d === "error" ? typeof l.status != "number" ? a(0, "error") : a(
                  l.status,
                  l.statusText
                ) : a(
                  gr[l.status] || l.status,
                  l.statusText,
                  (l.responseType || "text") !== "text" || typeof l.responseText != "string" ? { binary: l.response } : { text: l.responseText },
                  l.getAllResponseHeaders()
                ));
              };
            }, l.onload = t(), n = l.onerror = l.ontimeout = t("error"), l.onabort !== void 0 ? l.onabort = n : l.onreadystatechange = function() {
              l.readyState === 4 && p.setTimeout(function() {
                t && n();
              });
            }, t = t("abort");
            try {
              l.send(e.hasContent && e.data || null);
            } catch (d) {
              if (t)
                throw d;
            }
          },
          abort: function() {
            t && t();
          }
        };
    }), r.ajaxPrefilter(function(e) {
      e.crossDomain && (e.contents.script = !1);
    }), r.ajaxSetup({
      accepts: {
        script: "text/javascript, application/javascript, application/ecmascript, application/x-ecmascript"
      },
      contents: {
        script: /\b(?:java|ecma)script\b/
      },
      converters: {
        "text script": function(e) {
          return r.globalEval(e), e;
        }
      }
    }), r.ajaxPrefilter("script", function(e) {
      e.cache === void 0 && (e.cache = !1), e.crossDomain && (e.type = "GET");
    }), r.ajaxTransport("script", function(e) {
      if (e.crossDomain || e.scriptAttrs) {
        var t, n;
        return {
          send: function(i, a) {
            t = r("<script>").attr(e.scriptAttrs || {}).prop({ charset: e.scriptCharset, src: e.url }).on("load error", n = function(o) {
              t.remove(), n = null, o && a(o.type === "error" ? 404 : 200, o.type);
            }), X.head.appendChild(t[0]);
          },
          abort: function() {
            n && n();
          }
        };
      }
    });
    var ni = [], rn = /(=)\?(?=&|$)|\?\?/;
    r.ajaxSetup({
      jsonp: "callback",
      jsonpCallback: function() {
        var e = ni.pop() || r.expando + "_" + Yn.guid++;
        return this[e] = !0, e;
      }
    }), r.ajaxPrefilter("json jsonp", function(e, t, n) {
      var i, a, o, l = e.jsonp !== !1 && (rn.test(e.url) ? "url" : typeof e.data == "string" && (e.contentType || "").indexOf("application/x-www-form-urlencoded") === 0 && rn.test(e.data) && "data");
      if (l || e.dataTypes[0] === "jsonp")
        return i = e.jsonpCallback = U(e.jsonpCallback) ? e.jsonpCallback() : e.jsonpCallback, l ? e[l] = e[l].replace(rn, "$1" + i) : e.jsonp !== !1 && (e.url += (Kt.test(e.url) ? "&" : "?") + e.jsonp + "=" + i), e.converters["script json"] = function() {
          return o || r.error(i + " was not called"), o[0];
        }, e.dataTypes[0] = "json", a = p[i], p[i] = function() {
          o = arguments;
        }, n.always(function() {
          a === void 0 ? r(p).removeProp(i) : p[i] = a, e[i] && (e.jsonpCallback = t.jsonpCallback, ni.push(i)), o && U(a) && a(o[0]), o = a = void 0;
        }), "script";
    }), J.createHTMLDocument = function() {
      var e = X.implementation.createHTMLDocument("").body;
      return e.innerHTML = "<form></form><form></form>", e.childNodes.length === 2;
    }(), r.parseHTML = function(e, t, n) {
      if (typeof e != "string")
        return [];
      typeof t == "boolean" && (n = t, t = !1);
      var i, a, o;
      return t || (J.createHTMLDocument ? (t = X.implementation.createHTMLDocument(""), i = t.createElement("base"), i.href = X.location.href, t.head.appendChild(i)) : t = X), a = Cn.exec(e), o = !n && [], a ? [t.createElement(a[1])] : (a = qn([e], t, o), o && o.length && r(o).remove(), r.merge([], a.childNodes));
    }, r.fn.load = function(e, t, n) {
      var i, a, o, l = this, d = e.indexOf(" ");
      return d > -1 && (i = Ue(e.slice(d)), e = e.slice(0, d)), U(t) ? (n = t, t = void 0) : t && typeof t == "object" && (a = "POST"), l.length > 0 && r.ajax({
        url: e,
        type: a || "GET",
        dataType: "html",
        data: t
      }).done(function(f) {
        o = arguments, l.html(i ? r("<div>").append(r.parseHTML(f)).find(i) : f);
      }).always(n && function(f, b) {
        l.each(function() {
          n.apply(this, o || [f.responseText, b, f]);
        });
      }), this;
    }, r.expr.pseudos.animated = function(e) {
      return r.grep(r.timers, function(t) {
        return e === t.elem;
      }).length;
    }, r.offset = {
      setOffset: function(e, t, n) {
        var i, a, o, l, d, f, b, v = r.css(e, "position"), L = r(e), m = {};
        v === "static" && (e.style.position = "relative"), d = L.offset(), o = r.css(e, "top"), f = r.css(e, "left"), b = (v === "absolute" || v === "fixed") && (o + f).indexOf("auto") > -1, b ? (i = L.position(), l = i.top, a = i.left) : (l = parseFloat(o) || 0, a = parseFloat(f) || 0), U(t) && (t = t.call(e, n, r.extend({}, d))), t.top != null && (m.top = t.top - d.top + l), t.left != null && (m.left = t.left - d.left + a), "using" in t ? t.using.call(e, m) : L.css(m);
      }
    }, r.fn.extend({
      offset: function(e) {
        if (arguments.length)
          return e === void 0 ? this : this.each(function(a) {
            r.offset.setOffset(this, e, a);
          });
        var t, n, i = this[0];
        if (!!i)
          return i.getClientRects().length ? (t = i.getBoundingClientRect(), n = i.ownerDocument.defaultView, {
            top: t.top + n.pageYOffset,
            left: t.left + n.pageXOffset
          }) : { top: 0, left: 0 };
      },
      position: function() {
        if (!!this[0]) {
          var e, t, n, i = this[0], a = { top: 0, left: 0 };
          if (r.css(i, "position") === "fixed")
            t = i.getBoundingClientRect();
          else {
            for (t = this.offset(), n = i.ownerDocument, e = i.offsetParent || n.documentElement; e && (e === n.body || e === n.documentElement) && r.css(e, "position") === "static"; )
              e = e.parentNode;
            e && e !== i && e.nodeType === 1 && (a = r(e).offset(), a.top += r.css(e, "borderTopWidth", !0), a.left += r.css(e, "borderLeftWidth", !0));
          }
          return {
            top: t.top - a.top - r.css(i, "marginTop", !0),
            left: t.left - a.left - r.css(i, "marginLeft", !0)
          };
        }
      },
      offsetParent: function() {
        return this.map(function() {
          for (var e = this.offsetParent; e && r.css(e, "position") === "static"; )
            e = e.offsetParent;
          return e || We;
        });
      }
    }), r.each({ scrollLeft: "pageXOffset", scrollTop: "pageYOffset" }, function(e, t) {
      var n = t === "pageYOffset";
      r.fn[e] = function(i) {
        return Pe(this, function(a, o, l) {
          var d;
          if (et(a) ? d = a : a.nodeType === 9 && (d = a.defaultView), l === void 0)
            return d ? d[t] : a[o];
          d ? d.scrollTo(
            n ? d.pageXOffset : l,
            n ? l : d.pageYOffset
          ) : a[o] = l;
        }, e, i, arguments.length);
      };
    }), r.each(["top", "left"], function(e, t) {
      r.cssHooks[t] = $n(
        J.pixelPosition,
        function(n, i) {
          if (i)
            return i = gt(n, t), Ut.test(i) ? r(n).position()[t] + "px" : i;
        }
      );
    }), r.each({ Height: "height", Width: "width" }, function(e, t) {
      r.each({
        padding: "inner" + e,
        content: t,
        "": "outer" + e
      }, function(n, i) {
        r.fn[i] = function(a, o) {
          var l = arguments.length && (n || typeof a != "boolean"), d = n || (a === !0 || o === !0 ? "margin" : "border");
          return Pe(this, function(f, b, v) {
            var L;
            return et(f) ? i.indexOf("outer") === 0 ? f["inner" + e] : f.document.documentElement["client" + e] : f.nodeType === 9 ? (L = f.documentElement, Math.max(
              f.body["scroll" + e],
              L["scroll" + e],
              f.body["offset" + e],
              L["offset" + e],
              L["client" + e]
            )) : v === void 0 ? r.css(f, b, d) : r.style(f, b, v, d);
          }, t, l ? a : void 0, l);
        };
      });
    }), r.each([
      "ajaxStart",
      "ajaxStop",
      "ajaxComplete",
      "ajaxError",
      "ajaxSuccess",
      "ajaxSend"
    ], function(e, t) {
      r.fn[t] = function(n) {
        return this.on(t, n);
      };
    }), r.fn.extend({
      bind: function(e, t, n) {
        return this.on(e, null, t, n);
      },
      unbind: function(e, t) {
        return this.off(e, null, t);
      },
      delegate: function(e, t, n, i) {
        return this.on(t, e, n, i);
      },
      undelegate: function(e, t, n) {
        return arguments.length === 1 ? this.off(e, "**") : this.off(t, e || "**", n);
      },
      hover: function(e, t) {
        return this.mouseenter(e).mouseleave(t || e);
      }
    }), r.each(
      "blur focus focusin focusout resize scroll click dblclick mousedown mouseup mousemove mouseover mouseout mouseenter mouseleave change select submit keydown keypress keyup contextmenu".split(" "),
      function(e, t) {
        r.fn[t] = function(n, i) {
          return arguments.length > 0 ? this.on(t, null, n, i) : this.trigger(t);
        };
      }
    );
    var yr = /^[\s\uFEFF\xA0]+|([^\s\uFEFF\xA0])[\s\uFEFF\xA0]+$/g;
    r.proxy = function(e, t) {
      var n, i, a;
      if (typeof t == "string" && (n = e[t], t = e, e = n), !!U(e))
        return i = N.call(arguments, 2), a = function() {
          return e.apply(t || this, i.concat(N.call(arguments)));
        }, a.guid = e.guid = e.guid || r.guid++, a;
    }, r.holdReady = function(e) {
      e ? r.readyWait++ : r.ready(!0);
    }, r.isArray = Array.isArray, r.parseJSON = JSON.parse, r.nodeName = Se, r.isFunction = U, r.isWindow = et, r.camelCase = He, r.type = tt, r.now = Date.now, r.isNumeric = function(e) {
      var t = r.type(e);
      return (t === "number" || t === "string") && !isNaN(e - parseFloat(e));
    }, r.trim = function(e) {
      return e == null ? "" : (e + "").replace(yr, "$1");
    };
    var br = p.jQuery, mr = p.$;
    return r.noConflict = function(e) {
      return p.$ === r && (p.$ = mr), e && p.jQuery === r && (p.jQuery = br), r;
    }, typeof h > "u" && (p.jQuery = p.$ = r), r;
  });
})(vi);
const pn = vi.exports;
const po = {
  name: "harness-ui-input",
  mixins: [Ee, Be],
  components: { InputPartial: co },
  props: {
    type: {
      required: !1,
      type: String,
      default: "text",
      validator: function(s) {
        return [
          "date",
          "datetime-local",
          "email",
          "month",
          "number",
          "password",
          "search",
          "tel",
          "text",
          "time",
          "url",
          "week"
        ].includes(s);
      }
    },
    typeahead: {
      type: Boolean,
      required: !1,
      default: !1
    },
    strict: {
      type: Boolean,
      required: !1,
      default: !0
    },
    placeholder: {
      required: !1,
      type: String,
      default: ""
    },
    prependComponent: {
      required: !1,
      type: Object
    },
    prependHTML: {
      required: !1,
      type: String
    },
    appendComponent: {
      required: !1,
      type: Object
    },
    appendHTML: {
      required: !1,
      type: String
    }
  },
  data() {
    return {
      bloodhound: null,
      subscription: null,
      strictError: !1
    };
  },
  computed: {
    boundValue: {
      get() {
        return this.getFilter(this.filter.key);
      },
      set(s) {
        !this.strict || this.evaluateStrict ? (this.strictError = !1, this.setFilterLoadData(this.filter.key, s)) : this.strict && !this.evaluateStrict && (this.strictError = !0);
      }
    }
  },
  methods: {
    evaluateStrict(s) {
      return this.getOptionsForFilter(this.filter.key).map((p) => p.key).includes(s);
    },
    initTypeahead() {
      window && (window.$ = window.jQuery = pn);
      const s = require("corejs-typeahead");
      this.bloodhound = new s({
        datumTokenizer: s.tokenizers.ngram,
        queryTokenizer: s.tokenizers.ngram,
        local: this.getOptionsForFilter(this.filter.key).map((h) => h.key)
      });
      const p = [
        "input",
        "hint",
        "menu",
        "dataset",
        "suggestion",
        "empty",
        "open",
        "cursor",
        "highlight"
      ].reduce((h, E) => (h[E] = `harness-ui-typeahead-${E}`, h), {});
      window.$(`#${this.filter.key}-${this.type}-input`).typeahead(
        {
          highlight: !0,
          minLength: 1,
          classNames: p
        },
        {
          name: this.filter.key,
          limit: 10,
          source: this.bloodhound
        }
      ).bind("typeahead:select", (h, E) => {
        this.setFilter(this.filter.key, E);
      }).bind("typeahead:autocomplete", (h, E) => {
        this.setFilter(this.filter.key, E);
      });
    }
  },
  mounted() {
    this.typeahead && (this.initTypeahead(), this.subscription = this.$store.subscribeAction({
      before: (s, p) => {
      },
      after: (s, p) => {
        s.type.includes(`SET_${this.filter.key.toUpperCase()}_OPTIONS`) && (this.bloodhound.clear(), this.bloodhound.add(
          this.getOptionsForFilter(this.filter.key).map((h) => h.key)
        ));
      }
    }));
  },
  beforeUnmount() {
    this.typeahead && (this.subscription(), this.bloodhound.clear());
  }
}, go = { class: "row form-row" }, yo = ["for", "id", "innerHTML"], bo = ["innerHTML"], mo = ["for", "id", "innerHTML"], vo = ["innerHTML"], ko = ["innerHTML"];
function Co(s, p, h, E, $, N) {
  const x = je("InputPartial");
  return C(), w("div", null, [
    s.labelPosition == "horizontal" ? (C(), w("div", {
      key: 0,
      class: H(s.isFilterDirty(s.filter.key) ? "dirty-filter-wrapper" : "")
    }, [
      k("div", go, [
        k("div", {
          class: H(
            "col-" + s.labelColumnSize + " " + (s.isFilterDirty(s.filter.key) ? "dirty-filter-label-wrapper" : "")
          )
        }, [
          k("label", {
            for: s.filter.key,
            class: H(
              "col-form-label harness-ui-select-label harness-ui-select-label-horizontal " + (s.isFilterDirty(s.filter.key) ? "dirty-filter-label" : "")
            ),
            id: s.filter.key + "-label",
            innerHTML: s.filter.label
          }, null, 10, yo)
        ], 2),
        k("div", {
          class: H(
            "col-" + (12 - s.labelColumnSize) + " " + (s.isFilterDirty(s.filter.key) ? "dirty-filter-input-wrapper" : "")
          )
        }, [
          he(x, we(qe({ ...s.$props, ...s.$attrs, strictError: $.strictError })), null, 16),
          s.helperText ? (C(), w("small", {
            key: 0,
            innerHTML: s.helperText,
            class: H(
              "form-text harness-ui-helper-text harness-ui-input-helper-text " + s.helperTextClass
            )
          }, null, 10, bo)) : M("", !0)
        ], 2)
      ])
    ], 2)) : M("", !0),
    s.labelPosition == "vertical" ? (C(), w("div", {
      key: 1,
      class: H(s.isFilterDirty(s.filter.key) ? "dirty-filter-wrapper" : "")
    }, [
      k("label", {
        for: s.filter.key,
        class: H(
          "col-form-label harness-ui-select-label harness-ui-select-label-vertical " + (s.isFilterDirty(s.filter.key) ? "dirty-filter-label" : "")
        ),
        id: s.filter.key + "-label",
        innerHTML: s.filter.label
      }, null, 10, mo),
      he(x, we(qe({ ...s.$props, ...s.$attrs, strictError: $.strictError })), null, 16),
      s.helperText ? (C(), w("small", {
        key: 0,
        innerHTML: s.helperText,
        class: H(
          "form-text harness-ui-helper-text harness-ui-input-helper-text " + s.helperTextClass
        )
      }, null, 10, vo)) : M("", !0)
    ], 2)) : M("", !0),
    s.labelPosition == "none" ? (C(), w("div", {
      key: 2,
      class: H(
        "form-inline " + (s.isFilterDirty(s.filter.key) ? "dirty-filter-wrapper" : "")
      )
    }, [
      he(x, we(qe({ ...s.$props, ...s.$attrs, strictError: $.strictError })), null, 16),
      s.helperText ? (C(), w("small", {
        key: 0,
        innerHTML: s.helperText,
        class: H(
          "form-text harness-ui-helper-text harness-ui-input-helper-text " + s.helperTextClass
        )
      }, null, 10, ko)) : M("", !0)
    ], 2)) : M("", !0)
  ]);
}
const To = /* @__PURE__ */ fe(po, [["render", Co]]), wo = {
  name: "SelectPartial",
  mixins: [Ee, Be],
  props: {
    multiple: {
      type: Boolean,
      required: !1,
      default: !1
    }
  }
}, So = ["multiple", "id", "aria-labelledby"], Do = ["value", "disabled", "hidden", "title", "innerHTML"];
function xo(s, p, h, E, $, N) {
  return Ne((C(), w("select", {
    multiple: h.multiple,
    class: H(
      "form-control harness-ui-select " + (s.isFilterDirty(s.filter.key) ? "dirty-filter-select" : "")
    ),
    "onUpdate:modelValue": p[0] || (p[0] = (x) => s.boundValue = x),
    id: s.filter.key + "-select",
    "aria-labelledby": s.filter.key + "-label"
  }, [
    (C(!0), w(ie, null, ae(s.getOptionsForFilter(s.filter.key), (x) => (C(), w("option", {
      key: x.key,
      value: x.key,
      disabled: x.disabled,
      hidden: x.hidden,
      title: x.label,
      innerHTML: x.label
    }, null, 8, Do))), 128))
  ], 10, So)), [
    [jt, s.boundValue]
  ]);
}
const _o = /* @__PURE__ */ fe(wo, [["render", xo]]), Lo = {
  name: "harness-ui-select",
  mixins: [Ee, Be],
  components: { SelectPartial: _o },
  props: {
    multiple: {
      type: Boolean,
      required: !1,
      default: !1
    }
  }
}, Ao = { class: "row form-row" }, No = ["for", "id", "innerHTML"], qo = ["innerHTML"], Oo = ["for", "id", "innerHTML"], Ho = ["innerHTML"], Eo = ["innerHTML"];
function Po(s, p, h, E, $, N) {
  const x = je("SelectPartial");
  return C(), w("div", null, [
    s.labelPosition == "horizontal" ? (C(), w("div", {
      key: 0,
      class: H(s.isFilterDirty(s.filter.key) ? "dirty-filter-wrapper" : "")
    }, [
      k("div", Ao, [
        k("div", {
          class: H("col-" + s.labelColumnSize)
        }, [
          k("label", {
            for: s.filter.key,
            class: H(
              "col-form-label harness-ui-select-label harness-ui-select-label-horizontal " + (s.isFilterDirty(s.filter.key) ? "dirty-filter-label" : "")
            ),
            id: s.filter.key + "-label",
            innerHTML: s.filter.label
          }, null, 10, No)
        ], 2),
        k("div", {
          class: H("col-" + (12 - s.labelColumnSize))
        }, [
          he(x, we(qe({ ...s.$props, ...s.$attrs })), null, 16),
          s.helperText ? (C(), w("small", {
            key: 0,
            innerHTML: s.helperText,
            class: H(
              "form-text harness-ui-select-helper-text harness-ui-helper-text " + s.helperTextClass
            )
          }, null, 10, qo)) : M("", !0)
        ], 2)
      ])
    ], 2)) : M("", !0),
    s.labelPosition == "vertical" ? (C(), w("div", {
      key: 1,
      class: H(s.isFilterDirty(s.filter.key) ? "dirty-filter-wrapper" : "")
    }, [
      k("label", {
        for: s.filter.key,
        class: H(
          "col-form-label harness-ui-select-label harness-ui-select-label-vertical " + (s.isFilterDirty(s.filter.key) ? "dirty-filter-label" : "")
        ),
        id: s.filter.key + "-label",
        innerHTML: s.filter.label
      }, null, 10, Oo),
      he(x, we(qe({ ...s.$props, ...s.$attrs })), null, 16),
      s.helperText ? (C(), w("small", {
        key: 0,
        innerHTML: s.helperText,
        class: H(
          "form-text harness-ui-select-helper-text harness-ui-helper-text " + s.helperTextClass
        )
      }, null, 10, Ho)) : M("", !0)
    ], 2)) : M("", !0),
    s.labelPosition == "none" ? (C(), w("div", {
      key: 2,
      class: H(
        "form-inline " + (s.isFilterDirty(s.filter.key) ? "dirty-filter-wrapper" : "")
      )
    }, [
      he(x, we(qe({ ...s.$props, ...s.$attrs })), null, 16),
      s.helperText ? (C(), w("small", {
        key: 0,
        innerHTML: s.helperText,
        class: H(
          "form-text harness-ui-select-helper-text harness-ui-helper-text " + s.helperTextClass
        )
      }, null, 10, Eo)) : M("", !0)
    ], 2)) : M("", !0)
  ]);
}
const Fo = /* @__PURE__ */ fe(Lo, [["render", Po]]), Mo = {
  name: "CheckboxPartial",
  mixins: [Ee, Be],
  props: {
    option: {
      type: Object,
      required: !0
    }
  }
}, $o = ["name", "id", "value", "disabled", "aria-labelledby"];
function jo(s, p, h, E, $, N) {
  return Ne((C(), w("input", {
    class: "form-check-input harness-ui-radiogroup-input",
    type: "radio",
    name: s.filter.key,
    id: s.filter.key + h.option.key,
    value: h.option.key,
    disabled: h.option.disabled,
    "onUpdate:modelValue": p[0] || (p[0] = (x) => s.boundValue = x),
    "aria-labelledby": s.filter.key + h.option.key + "-label"
  }, null, 8, $o)), [
    [Er, s.boundValue]
  ]);
}
const Bo = /* @__PURE__ */ fe(Mo, [["render", jo]]), Io = {
  name: "harness-ui-radiogroup",
  components: { RadioGroupPartial: Bo },
  mixins: [Ee, Be],
  props: {
    inline: {
      type: Boolean,
      required: !1,
      default: !1
    }
  }
}, Ro = { key: 0 }, zo = ["for", "innerHTML"], Vo = ["id", "for", "disabled", "innerHTML"], Wo = ["innerHTML"], Uo = { key: 1 }, Go = { class: "row form-row" }, Qo = ["for", "innerHTML"], Xo = ["id", "for", "disabled", "innerHTML"], Yo = ["innerHTML"];
function Jo(s, p, h, E, $, N) {
  const x = je("RadioGroupPartial");
  return C(), w("div", null, [
    s.labelPosition === "vertical" ? (C(), w("fieldset", Ro, [
      k("legend", {
        class: "col-form-label harness-ui-radiogroup-legend",
        for: s.filter.key,
        innerHTML: s.filter.label
      }, null, 8, zo),
      (C(!0), w(ie, null, ae(s.getOptionsForFilter(s.filter.key), (_, G) => (C(), w("div", {
        class: H("form-check" + (h.inline ? " form-check-inline" : "")),
        key: G
      }, [
        he(x, we(qe({ ...s.$props, ...s.$attrs, option: _ })), null, 16),
        k("label", {
          class: "form-check-label harness-ui-radiogroup-label",
          id: s.filter.key + _.key + "-label",
          for: s.filter.key + _.key,
          disabled: _.disabled,
          innerHTML: _.label
        }, null, 8, Vo)
      ], 2))), 128)),
      s.helperText ? (C(), w("small", {
        key: 0,
        innerHTML: s.helperText,
        class: H(
          "form-text harness-ui-helper-text harness-ui-radiogroup-helper-text " + s.helperTextClass
        )
      }, null, 10, Wo)) : M("", !0)
    ])) : M("", !0),
    s.labelPosition === "horizontal" ? (C(), w("fieldset", Uo, [
      k("div", Go, [
        k("div", {
          class: H("col-" + s.labelColumnSize)
        }, [
          k("legend", {
            class: "col-form-label harness-ui-radiogroup-legend",
            for: s.filter.key,
            innerHTML: s.filter.label
          }, null, 8, Qo)
        ], 2),
        k("div", {
          class: H("col-" + (12 - s.labelColumnSize))
        }, [
          (C(!0), w(ie, null, ae(s.getOptionsForFilter(s.filter.key), (_, G) => (C(), w("div", {
            class: H("form-check" + (h.inline ? " form-check-inline" : "")),
            key: G
          }, [
            he(x, we(qe({ ...s.$props, ...s.$attrs, option: _ })), null, 16),
            k("label", {
              class: "form-check-label harness-ui-radiogroup-label",
              id: s.filter.key + _.key + "-label",
              for: s.filter.key + _.key,
              disabled: _.disabled,
              innerHTML: _.label
            }, null, 8, Xo)
          ], 2))), 128)),
          s.helperText ? (C(), w("small", {
            key: 0,
            innerHTML: s.helperText,
            class: H(
              "form-text harness-ui-helper-text harness-ui-radiogroup-helper-text " + s.helperTextClass
            )
          }, null, 10, Yo)) : M("", !0)
        ], 2)
      ])
    ])) : M("", !0)
  ]);
}
const Ko = /* @__PURE__ */ fe(Io, [["render", Jo]]), Zo = {
  name: "CheckboxPartial",
  mixins: [Ee, Be],
  props: {
    inline: {
      type: Boolean,
      required: !0
    },
    collapse: {
      type: Boolean,
      required: !0
    },
    collapsed: {
      type: Boolean,
      required: !0
    },
    option: {
      type: Object,
      required: !0
    }
  }
}, el = ["name", "id", "value", "aria-labelledby"];
function tl(s, p, h, E, $, N) {
  return Ne((C(), w("input", {
    class: "form-check-input harness-ui-checkboxgroup-input",
    type: "checkbox",
    name: s.filter.key + h.option.key,
    id: s.filter.key + h.option.key,
    value: h.option.key,
    "onUpdate:modelValue": p[0] || (p[0] = (x) => s.boundValue = x),
    "aria-labelledby": s.filter.key + h.option.key + "-label"
  }, null, 8, el)), [
    [Pr, s.boundValue]
  ]);
}
const nl = /* @__PURE__ */ fe(Zo, [["render", tl]]);
const il = {
  name: "harness-ui-checkboxgroup",
  mixins: [Ee, Be],
  components: { CheckboxPartial: nl },
  data: () => ({ collapsed: !0 }),
  props: {
    inline: {
      type: Boolean,
      docstring: "asdasdasd",
      required: !1,
      default: !1
    },
    collapse: {
      type: Boolean,
      required: !1,
      default: !1
    }
  }
}, rl = { key: 0 }, sl = ["for", "data-toggle", "href", "role"], al = ["innerHTML"], ol = ["data-toggle", "href", "role"], ll = {
  key: 0,
  class: "bi-chevron-down"
}, ul = {
  key: 1,
  class: "bi-chevron-up"
}, fl = ["href"], cl = { key: 0 }, dl = { key: 1 }, hl = ["id"], pl = ["id", "for", "innerHTML"], gl = ["innerHTML"], yl = { key: 1 }, bl = { class: "row form-row" }, ml = ["data-toggle", "href", "role", "for"], vl = ["innerHTML"], kl = ["data-toggle", "href", "role"], Cl = {
  key: 0,
  class: "bi-chevron-down"
}, Tl = {
  key: 1,
  class: "bi-chevron-up"
}, wl = ["href"], Sl = { key: 0 }, Dl = { key: 1 }, xl = ["id"], _l = ["id", "for", "innerHTML"], Ll = ["innerHTML"], Al = { key: 2 }, Nl = ["id", "for", "innerHTML"], ql = ["innerHTML"];
function Ol(s, p, h, E, $, N) {
  const x = je("CheckboxPartial");
  return C(), w("div", null, [
    s.labelPosition === "vertical" ? (C(), w("fieldset", rl, [
      k("legend", {
        class: "col-form-label harness-ui-checkboxgroup-legend",
        for: s.filter.key,
        "data-toggle": h.collapse ? "collapse" : "",
        href: h.collapse ? "#harness-ui-checkbox-collapse-" + s.filter.key : "",
        role: h.collapse ? "button" : "",
        onClick: p[1] || (p[1] = (_) => s.collapsed = !s.collapsed)
      }, [
        k("span", {
          innerHTML: s.filter.label
        }, null, 8, al),
        h.collapse ? (C(), w("button", {
          key: 0,
          class: "harness-ui-collapse-toggle-button",
          "data-toggle": h.collapse ? "collapse" : "",
          href: h.collapse ? "#harness-ui-checkbox-collapse-" + s.filter.key : "",
          role: h.collapse ? "button" : "",
          onClick: p[0] || (p[0] = (_) => s.collapsed = !s.collapsed),
          "aria-expanded": "false",
          "aria-label": "Collapse Toggle"
        }, [
          h.collapse && s.collapsed ? (C(), w("i", ll)) : M("", !0),
          h.collapse && !s.collapsed ? (C(), w("i", ul)) : M("", !0)
        ], 8, ol)) : M("", !0)
      ], 8, sl),
      h.collapse ? (C(), w("div", {
        key: 0,
        "data-toggle": "collapse",
        href: h.collapse ? "#harness-ui-checkbox-collapse-" + s.filter.key : "",
        role: "button",
        class: "harness-ui-checkboxgroup-collapse-label",
        onClick: p[2] || (p[2] = (_) => s.collapsed = !s.collapsed)
      }, [
        h.collapse && s.getFilter(s.filter.key).length === s.getOptionsForFilter(s.filter.key).length ? (C(), w("span", cl, " (All Selected) ")) : h.collapse ? (C(), w("span", dl, " (" + de(s.getFilter(s.filter.key).length) + " of " + de(s.getOptionsForFilter(s.filter.key).length) + " selected) ", 1)) : M("", !0)
      ], 8, fl)) : M("", !0),
      k("div", {
        class: H(h.collapse ? "collapse" : ""),
        id: h.collapse ? "harness-ui-checkbox-collapse-" + s.filter.key : ""
      }, [
        (C(!0), w(ie, null, ae(s.getOptionsForFilter(s.filter.key), (_, G) => (C(), w("div", {
          class: H("form-check" + (h.inline ? " form-check-inline" : "")),
          key: G
        }, [
          he(x, we(qe({ ...s.$props, ...s.$attrs, collapsed: s.collapsed, option: _ })), null, 16),
          k("label", {
            class: "form-check-label harness-ui-checkboxgroup-label",
            id: s.filter.key + _.key + "-label",
            for: s.filter.key + _.key,
            innerHTML: _.label
          }, null, 8, pl)
        ], 2))), 128)),
        s.helperText ? (C(), w("small", {
          key: 0,
          innerHTML: s.helperText,
          class: H(
            "form-text harness-ui-helper-text harness-ui-checkboxgroup-helper-text " + s.helperTextClass
          )
        }, null, 10, gl)) : M("", !0)
      ], 10, hl)
    ])) : M("", !0),
    s.labelPosition === "horizontal" ? (C(), w("fieldset", yl, [
      k("div", bl, [
        k("div", {
          class: H("col-" + s.labelColumnSize)
        }, [
          k("legend", {
            class: "col-form-label harness-ui-checkboxgroup-legend",
            "data-toggle": h.collapse ? "collapse" : "",
            href: h.collapse ? "#harness-ui-checkbox-collapse-" + s.filter.key : "",
            role: h.collapse ? "button" : "",
            for: s.filter.key,
            onClick: p[4] || (p[4] = (_) => s.collapsed = !s.collapsed)
          }, [
            k("span", {
              innerHTML: s.filter.label
            }, null, 8, vl),
            h.collapse ? (C(), w("button", {
              key: 0,
              class: "harness-ui-collapse-toggle-button",
              "data-toggle": h.collapse ? "collapse" : "",
              href: h.collapse ? "#harness-ui-checkbox-collapse-" + s.filter.key : "",
              role: h.collapse ? "button" : "",
              onClick: p[3] || (p[3] = (_) => s.collapsed = !s.collapsed),
              "aria-expanded": "false",
              "aria-label": "Collapse Toggle"
            }, [
              h.collapse && s.collapsed ? (C(), w("i", Cl)) : M("", !0),
              h.collapse && !s.collapsed ? (C(), w("i", Tl)) : M("", !0)
            ], 8, kl)) : M("", !0)
          ], 8, ml)
        ], 2),
        k("div", {
          class: H("col-" + (12 - s.labelColumnSize))
        }, [
          h.collapse ? (C(), w("div", {
            key: 0,
            class: "col-form-label harness-ui-checkboxgroup-collapse-label",
            "data-toggle": "collapse",
            href: "#harness-ui-checkbox-collapse-" + s.filter.key,
            role: "button",
            onClick: p[5] || (p[5] = (_) => s.collapsed = !s.collapsed)
          }, [
            h.collapse && s.getFilter(s.filter.key).length === s.getOptionsForFilter(s.filter.key).length ? (C(), w("span", Sl, " (All Selected) ")) : h.collapse ? (C(), w("span", Dl, " (" + de(s.getFilter(s.filter.key).length) + " of " + de(s.getOptionsForFilter(s.filter.key).length) + " selected) ", 1)) : M("", !0)
          ], 8, wl)) : M("", !0),
          k("div", {
            class: H(h.collapse ? "collapse" : ""),
            id: h.collapse ? "harness-ui-checkbox-collapse-" + s.filter.key : ""
          }, [
            (C(!0), w(ie, null, ae(s.getOptionsForFilter(s.filter.key), (_, G) => (C(), w("div", {
              class: H("form-check" + (h.inline ? " form-check-inline" : "")),
              key: G
            }, [
              he(x, we(qe({ ...s.$props, ...s.$attrs, collapsed: s.collapsed, option: _ })), null, 16),
              k("label", {
                class: "form-check-label harness-ui-checkboxgroup-label",
                id: s.filter.key + _.key + "-label",
                for: s.filter.key + _.key,
                innerHTML: _.label
              }, null, 8, _l)
            ], 2))), 128)),
            s.helperText ? (C(), w("small", {
              key: 0,
              innerHTML: s.helperText,
              class: H(
                "form-text harness-ui-helper-text harness-ui-checkboxgroup-helper-text " + s.helperTextClass
              )
            }, null, 10, Ll)) : M("", !0)
          ], 10, xl)
        ], 2)
      ])
    ])) : M("", !0),
    s.labelPosition === "none" ? (C(), w("fieldset", Al, [
      (C(!0), w(ie, null, ae(s.getOptionsForFilter(s.filter.key), (_, G) => (C(), w("div", {
        class: H("form-check" + (h.inline ? " form-check-inline" : "")),
        key: G
      }, [
        he(x, we(qe({ ...s.$props, ...s.$attrs, collapsed: s.collapsed, option: _ })), null, 16),
        k("label", {
          class: "form-check-label harness-ui-checkboxgroup-label",
          id: s.filter.key + _.key + "-label",
          for: s.filter.key + _.key,
          innerHTML: _.label
        }, null, 8, Nl)
      ], 2))), 128)),
      s.helperText ? (C(), w("small", {
        key: 0,
        innerHTML: s.helperText,
        class: H(
          "form-text harness-ui-helper-text harness-ui-checkboxgroup-helper-text " + s.helperTextClass
        )
      }, null, 10, ql)) : M("", !0)
    ])) : M("", !0)
  ]);
}
const Hl = /* @__PURE__ */ fe(il, [["render", Ol]]);
const El = {
  name: "HarnessVueBootstrapMultiselectListbox",
  mixins: [Ee, Be],
  props: {
    searchable: {
      type: Boolean,
      required: !1,
      default: !1
    },
    typeahead: {
      type: Boolean,
      required: !1,
      default: !1
    }
  },
  data() {
    return {
      bloodhound: null,
      leftBox: [],
      rightBox: [],
      search: "",
      searchDisabled: !1
    };
  },
  computed: {
    leftBoxOptions() {
      return this.unselectedOptions.filter(
        (s) => this.search === "" || s.label.toLowerCase().includes(this.search.toLowerCase())
      );
    },
    rightBoxOptions() {
      return this.getOptionsForFilter(this.filter.key).filter(
        (s) => this.getFilter(this.filter.key).includes(s.key)
      );
    },
    unselectedOptions() {
      return this.getOptionsForFilter(this.filter.key).filter(
        (s) => !this.getFilter(this.filter.key).includes(s.key)
      );
    }
  },
  methods: {
    leftToRight() {
      const s = this.getFilter(this.filter.key).concat(this.leftBox);
      this.setFilterLoadData(this.filter.key, s), this.lifecycleBloodhound();
    },
    rightToLeft() {
      const s = this.getFilter(this.filter.key).filter(
        (p) => !this.rightBox.includes(p)
      );
      this.setFilterLoadData(this.filter.key, s), this.lifecycleBloodhound();
    },
    lifecycleBloodhound() {
      this.bloodhound && (this.bloodhound.clear(), this.unselectedOptions.length ? (this.searchDisabled = !1, this.bloodhound.add(this.unselectedOptions.map((s) => s.label))) : this.searchDisabled = !0);
    },
    initTypeahead() {
      window.$ = window.jQuery = pn;
      const s = require("corejs-typeahead");
      this.bloodhound = new s({
        datumTokenizer: s.tokenizers.ngram,
        queryTokenizer: s.tokenizers.ngram,
        local: this.leftBoxOptions.map((h) => h.label)
      });
      const p = [
        "input",
        "hint",
        "menu",
        "dataset",
        "suggestion",
        "empty",
        "open",
        "cursor",
        "highlight"
      ].reduce((h, E) => (h[E] = `harness-ui-multiselect-listbox-typeahead-${E}`, h), {});
      window.$(`#harness-ui-multiselect-listbox-search-${this.filter.key}`).typeahead(
        {
          highlight: !0,
          minLength: 1,
          classNames: p
        },
        {
          name: this.filter.key,
          limit: 10,
          source: this.bloodhound
        }
      ).bind("typeahead:select", (h, E) => {
        this.search = E;
      }).bind("typeahead:autocomplete", (h, E) => {
        this.search = E;
      });
    }
  },
  mounted() {
    this.searchable && this.typeahead && this.initTypeahead();
  }
}, Pl = { class: "harness-ui-select-label harness-ui-multiselect-listbox-top-label" }, Fl = {
  key: 0,
  class: "row"
}, Ml = { class: "col" }, $l = ["id", "disabled"], jl = { class: "row align-items-center" }, Bl = { class: "col-5" }, Il = /* @__PURE__ */ k("label", { class: "col-form-label harness-ui-select-label harness-ui-multiselect-listbox-select-label harness-ui-select-label-vertical" }, "Options", -1), Rl = ["value", "title"], zl = { class: "col-2" }, Vl = { class: "text-center" }, Wl = /* @__PURE__ */ k("i", { class: "bi bi-caret-left-fill" }, null, -1), Ul = [
  Wl
], Gl = /* @__PURE__ */ k("i", { class: "bi bi-caret-right-fill" }, null, -1), Ql = [
  Gl
], Xl = { class: "col-5" }, Yl = /* @__PURE__ */ k("label", { class: "col-form-label harness-ui-select-label harness-ui-multiselect-listbox-select-label harness-ui-select-label-vertical" }, "Selected", -1), Jl = ["value", "title"];
function Kl(s, p, h, E, $, N) {
  return C(), w("div", null, [
    k("label", Pl, de(this.filter.label), 1),
    h.searchable ? (C(), w("div", Fl, [
      k("div", Ml, [
        Ne(k("input", {
          type: "text",
          id: `harness-ui-multiselect-listbox-search-${s.filter.key}`,
          class: "form-control harness-ui-input harness-ui-multiselect-listbox-search-input",
          disabled: $.searchDisabled,
          "onUpdate:modelValue": p[0] || (p[0] = (x) => $.search = x)
        }, null, 8, $l), [
          [yi, $.search]
        ])
      ])
    ])) : M("", !0),
    k("div", jl, [
      k("div", Bl, [
        Il,
        Ne(k("select", {
          class: "form-control harness-ui-select harness-ui-multiselect-listbox-select harness-ui-multiselect-listbox-select-left",
          multiple: "true",
          "onUpdate:modelValue": p[1] || (p[1] = (x) => $.leftBox = x)
        }, [
          (C(!0), w(ie, null, ae(N.leftBoxOptions, (x) => (C(), w("option", {
            key: x.key,
            value: x.key,
            title: x.label
          }, de(x.label), 9, Rl))), 128))
        ], 512), [
          [jt, $.leftBox]
        ])
      ]),
      k("div", zl, [
        k("div", Vl, [
          k("button", {
            class: "btn btn-xs",
            onClick: p[2] || (p[2] = (...x) => N.rightToLeft && N.rightToLeft(...x))
          }, Ul),
          k("button", {
            class: "btn btn-xs",
            onClick: p[3] || (p[3] = (...x) => N.leftToRight && N.leftToRight(...x))
          }, Ql)
        ])
      ]),
      k("div", Xl, [
        Yl,
        Ne(k("select", {
          class: "form-control harness-ui-select harness-ui-multiselect-listbox-select harness-ui-multiselect-listbox-select-right",
          multiple: "true",
          "onUpdate:modelValue": p[4] || (p[4] = (x) => $.rightBox = x)
        }, [
          (C(!0), w(ie, null, ae(N.rightBoxOptions, (x) => (C(), w("option", {
            key: x.key,
            value: x.key,
            title: x.label
          }, de(x.label), 9, Jl))), 128))
        ], 512), [
          [jt, $.rightBox]
        ])
      ])
    ])
  ]);
}
const Zl = /* @__PURE__ */ fe(El, [["render", Kl]]), hi = {
  FilterGrid: Rr,
  ChartGrid: Wr,
  GridWithFilters: es,
  DataTable508: os,
  ChartWithTable: $s,
  InteractiveTable: ba,
  FilterPicker: Ha,
  FilterAccordion: eo,
  HarnessVueBootstrapInput: To,
  HarnessVueBootstrapSelect: Fo,
  HarnessVueBootstrapRadioGroup: Ko,
  HarnessVueBootstrapCheckboxGroup: Hl,
  HarnessVueBootstrapMultiselectListbox: Zl
};
typeof window < "u" && (window.$ = window.jQuery = pn);
const tu = {
  install(s, p) {
    Object.keys(hi).forEach((h) => {
      s.component(h, hi[h]);
    });
  }
};
export {
  hi as components,
  tu as harnessVueBootstrap
};
